unit listunit;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  StdCtrls,
  TRPCB,
  Fmcntrls,
  Diaccess,
  Fmcmpnts,
  ExtCtrls,
  ORCtrls,
  main;

type
  TListForm = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    FMLister1: TFMLister;
    FMListBox1: TFMListBox;
    Timer1: TTimer;
    FMGets1: TFMGets;
    Button3: TButton;
    Button2: TButton;
    ORListBox1: TORListBox;
    procedure Edit1Change(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FMListBox1Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Edit1KeyPress(Sender: TObject; var Key: Char);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  ListForm: TListForm;
  TimerCount: Integer;

implementation

uses PNCSMain;

{$R *.DFM}

procedure TListForm.Edit1Change(Sender: TObject);
begin
  Timer1.Enabled := True;
  if Edit1.Text = '' then begin
    FMListBox1.Items.Clear;
    Timer1.Enabled := False;
    Button1.Enabled := False;
  end;
  {Reset timer and clear patient info controls}
  TimerCount := 0;
end;

procedure TListForm.FormCreate(Sender: TObject);
begin
  TimerCount := 0;
  ReturnIEN := '';
end;

procedure TListForm.Button1Click(Sender: TObject);
var
  x: integer;
begin
  Button2.Enabled := False;
  try
  FMListBox1.GetMore except
  end;
  // For XUS Active User?, remove users who aren't active
  if FMlistBox1.Items.Count > 0 then
    for x := FMListBox1.Items.Count - 1 downto 0 do
      if Pos('  YES', Uppercase(FMListBox1.Items[x])) > 0 then begin
        //ShowMessageCAPRI(FMListBox1.Items[x]);
        //ShowMessageCAPRI(FMListBox1.Items[x]);
        FMListBox1.Items.Delete(x)
      end
      else begin
        //If DIUser is there, then take it off, otherwise, make no change
        if Pos('  ', FMListBox1.Items[x]) > 0 then
          FMListBox1.Items[x] := Copy(FMListBox1.Items[x], 1, Pos('  ', FMListBox1.Items[x]) - 1);
      end;
  {Scroll List Down}
  FMListBox1.ItemIndex := FMListBox1.Items.Count - 1;
  FMListBox1.ItemIndex := -1;
  Edit1.Setfocus;
  Edit1.SelLength := 0;
  Edit1.SelStart := Length(Edit1.Text);
end;

procedure TListForm.Timer1Timer(Sender: TObject);
var
  x: integer;
begin
  Button2.Enabled := False;
  Inc(TimerCount);
  if TimerCount >= 4 then begin
    Timer1.Enabled := False;
    FMLister1.PartList.Clear;
    FMLister1.PartList.Add(Edit1.Text);
    try
    FMListBox1.GetList except
    end;
    // For XUS Active User?, remove users who aren't active
    if FMlistBox1.Items.Count > 0 then
      for x := FMListBox1.Items.Count - 1 downto 0 do
        if Pos('  YES', Uppercase(FMListBox1.Items[x])) > 0 then begin
          //ShowMessageCAPRI(FMListBox1.Items[x]);
          //ShowMessageCAPRI(FMListBox1.Items[x]);
          FMListBox1.Items.Delete(x)
        end
        else begin
          //If DIUser is there, then take it off, otherwise, make no change
          if Pos('  ', FMListBox1.Items[x]) > 0 then
            FMListBox1.Items[x] := Copy(FMListBox1.Items[x], 1, Pos('  ', FMListBox1.Items[x]) - 1);
        end;

    {check for errors after the server call}
    if FMLister1.ErrorList.Count > 0 then
      FMLister1.DisplayErrors;
    if FMLister1.More = True then
      button1.enabled := true
    else
      button1.enabled := false;
    if FMListBox1.Items.Count > 0 then
      for x := 0 to FMListBox1.Items.Count - 1 do begin
        if Pos(Edit1.Text, Uppercase(FMListBox1.Items[x])) > 0 then begin
          FMListBox1.ItemIndex := x;
          Button2.Enabled := True;
          ListForm.FMListBox1Click(Application);
          Break;
        end;
      end;
    Timer1.Enabled := False;
    TimerCount := 0;
  end;
end;

procedure TListForm.FMListBox1Click(Sender: TObject);
begin
  FMGets1.IENS := FMListBox1.GetselectedRecord.IEN;
  FMGets1.GetAndFill;
  // Check for errors after the server call.
  if FMGets1.ErrorList.Count > 0 then
    FMGets1.DisplayErrors;
  Button2.Enabled := True;
end;

procedure TListForm.Button3Click(Sender: TObject);
begin
  ReturnIEN := '';
  ReturnString := '';
  ListForm.Close;
end;

procedure TListForm.Button2Click(Sender: TObject);
var
  x: integer;
begin
  if FMListBox1.ItemIndex > -1 then
    if FMListBox1.Items[FMListBox1.ItemIndex] <> '' then begin
      ReturnIEN := FMListBox1.GetselectedRecord.IEN;
      for x := 0 to FMListBox1.Items.Count - 1 do begin
        if FMListBox1.Selected[x] then
          ReturnString := FMListBox1.Items[x];
        ReturnIEN := FMListBox1.GetSelectedRecord.IEN;
      end;
    end;
  if ORListBox1.ItemIndex > -1 then
    ReturnIEN := ORListBox1.Items[ORListBox1.ItemIndex];
  ListForm.Close;
end;

procedure TListForm.Edit1KeyPress(Sender: TObject; var Key: Char);
begin
  // Don't allow a space after a comma
  if (Key = ' ') and (Length(Edit1.Text) > 0) and
    (Edit1.text[Length(Edit1.Text)] = ',') then
    key := #0;

end;

end.
