unit loadexamcomments;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  Fmcntrls,
  Diaccess,
  Fmcmpnts,
  ExtCtrls,
  trpcb,
  DialogsCAPRI,
  CCOWRPCBrokerCAPRI;

type
  TfrmExamRequestComments = class(TForm)
    FMExamRequestLister1: TFMLister;
    GroupBox1: TGroupBox;
    FMExamRequestListbox: TFMListBox;
    Button1: TButton;
    ButtonLoad: TButton;
    FMGets1: TFMGets;
    Panel1: TPanel;
    Label2: TLabel;
    Label1: TLabel;
    FMCommentsMemo: TFMMemo;
    lstExamsRequested: TListBox;
    lstExamsRequestedHidden: TListBox;
    procedure Button1Click(Sender: TObject);
    procedure ButtonLoadClick(Sender: TObject);
    procedure FMExamRequestListboxClick(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmExamRequestComments: TfrmExamRequestComments;

implementation

uses main;

{$R *.DFM}

procedure TfrmExamRequestComments.Button1Click(Sender: TObject);
begin
  modalresult := mrcancel;
end;

procedure TfrmExamRequestComments.ButtonLoadClick(Sender: TObject);
begin
  modalresult := mrok;
end;

procedure TfrmExamRequestComments.FMExamRequestListboxClick(
  Sender: TObject);
var
  x: integer;
begin
  // Find Exams
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
  frmMain.RPCBroker1.Param[0].Value := FMExamRequestListbox.GetSelectedRecord.IEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      frmMain.StatusBarLoadPt.Caption := 'RPC DVBAB FIND EXAMS could not be accessed!';
      frmMain.StatusBarLoadPt.Repaint;
      Application.Processmessages;
      ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
  end;
  lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
  lstExamsRequested.Clear;
  if lstExamsRequestedHidden.Items.Count > 0 then
    for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do
      lstExamsRequested.Items.Add(Copy(lstExamsRequestedHidden.Items[x], Pos('^', lstExamsRequestedHidden.Items[x]) + 1, 254));

  FMGets1.IENS := FMExamRequestListbox.GetSelectedRecord.IEN;
  FMGets1.GetAndFill;
  ButtonLoad.Enabled := True;
end;

end.
