unit viewexam;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  Trpcb,
  StdCtrls,
  Fmcntrls,
  CheckLst,
  ORDtTm,
  ExtCtrls,
  Diaccess,
  Fmcmpnts,
  Menus,
  clipbrd,
  OleCtrls,
  ComCtrls,
  ORCtrls, ToolWin, ActnMan, ActnCtrls, ActnMenus, ActnList, XPStyleActnCtrls,
  AccessibilityUtils, VA508AccessibilityManager;


type
  TfrmViewExam = class(TForm)
    Panel1: TPanel;
    ScrollBox1: TScrollBox;
    FMOtherDisabilities3: TFMEdit;
    FMOtherDisabilities2: TFMEdit;
    FMOtherDisabilities1: TFMEdit;
    lblOtherDisabilities1: TLabel;
    lblOtherDisabilities2: TLabel;
    lblOtherDisabilities3: TLabel;
    lblRoutingLocation: TLabel;
    lblRequestedBy: TLabel;
    lblClaimFolderRequired: TLabel;
    lblOtherDocsRequired: TLabel;
    lblRO: TLabel;
    lblPriorityOfExam: TLabel;
    FMRequestDate: TFMEdit;
    lblRequestDate: TLabel;
    FMPatientNameIEN: TFMEdit;
    lblPtName: TLabel;
    lblReqRefNum: TLabel;
    edExamReferenceNumber: TEdit;
    lblRequestStatus: TLabel;
    btnClose: TButton;
    FMGetsExamRequest: TFMGets;
    FMRequestedBy: TFMEdit;
    FMRequestStatus: TFMEdit;
    FMRequestedByIEN: TFMEdit;
    FMClaimFolderRequiredFake: TFMEdit;
    FMOtherDocumentsRequiredFake: TFMEdit;
    FMPriorityOfExamFake: TFMEdit;
    FMRegionalOfficeNumberIEN: TFMEdit;
    FMRoutingLocationFake: TFMEdit;
    FMPriorityOfExam: TFMComboBox;
    FMClaimFolderRequired: TFMComboBox;
    FMOtherDocumentsRequired: TFMComboBox;
    Shape1: TShape;
    FMEditDateReportedToMAS: TFMEdit;
    lblDateReportedToMAS: TLabel;
    FMEditDateSchedulingCompleted: TFMEdit;
    lblDateSchedulingCompleted: TLabel;
    FMEditDateCompleted: TFMEdit;
    lblDateCompleted: TLabel;
    FMEditTranscriptionDate: TFMEdit;
    lblTranscriptionDate: TLabel;
    FMEditDateApproved: TFMEdit;
    lblDateApproved: TLabel;
    lblDateReleased: TLabel;
    FMEditDateReleased: TFMEdit;
    lblReleasedBy: TLabel;
    FMEditReleasedBy: TFMEdit;
    lblDatePrintedByRO: TLabel;
    FMEditDatePrintedByRO: TFMEdit;
    lblPrintedBy: TLabel;
    FMEditPrintedBy: TFMEdit;
    lblElapsedTime: TLabel;
    FMEditElapsedTime: TFMEdit;
    lblCancellationDate: TLabel;
    FMEditCancellationDate: TFMEdit;
    lblCancelledBy: TLabel;
    FMEditCancelledBy: TFMEdit;
    fmLastExamAddDate: TFMEdit;
    lblLastExamAddDate: TLabel;
    lblLastExamAddedBy: TLabel;
    fmLastExamAddedBy: TFMEdit;
    lblRemarksModifiedDate: TLabel;
    fmRemarksModified: TFMEdit;
    lblRemarksModifiedBy: TLabel;
    fmRemarksModifiedBy: TFMEdit;
    lblApprovalDateTime: TLabel;
    FMEditApprovalDateTime: TFMEdit;
    lblApprovedBy: TLabel;
    FMEditApprovedBy: TFMEdit;
    lblReturnedToOwnerSiteBy: TLabel;
    FMEditReturnedToOwnerSiteBy: TFMEdit;
    lblOwnerDomain: TLabel;
    FMEditOwnerDomain: TFMEdit;
    FMEditTransferredToAnotherSite: TFMEdit;
    lblTransferredToAnotherSite: TLabel;
    FMEditDateTransferredToOtherSite: TFMEdit;
    lblDateTransferredToOtherSite: TLabel;
    FMEditDateTransferredInFromRemoteSite: TFMEdit;
    lblDateTransferredInFromRemoteSite: TLabel;
    FMEditDateAllTransfersReturned: TFMEdit;
    lblDateAllTransfersReturned: TLabel;
    lblOrig2507ProcessingTime: TLabel;
    FMEditOrig2507ProcessingTime: TFMEdit;
    btnInsufficientExam: TButton;
    FMListerExamsRequested: TFMLister;
    FMOriginal2507Request: TFMEdit;
    lblOriginal2507Request: TLabel;
    FMListerBodySystem: TFMLister;
    FMFiler1: TFMFiler;
    FMRegionalOfficeNumber: TFMComboBox;
    FMRoutingLocation: TORComboBox;
    lblVistaActivity: TLabel;
    GroupBox1: TGroupBox;
    FMCommentsMemo: TFMMemo;
    GroupBox2: TGroupBox;
    lstExamsRequested: TListBox;
    lstExamsRequestedHidden: TListBox;
    btnCancelAllExams: TButton;
    btnViewSelectedExam: TButton;
    btnAddExam: TButton;
    AddExamPanel: TPanel;
    lblSelectExamsToAdd: TLabel;
    TreeViewExams: TTreeView;
    CheckboxExamsToComplete: TCheckListBox;
    FMListBoxBodySystems: TFMListBox;
    FMExamsList: TFMListBox;
    ButtonViewBySystem: TButton;
    btnAddSelExams: TButton;
    btnCancelAddExams: TButton;
    FMExamStatus: TFMEdit;
    FMExamType: TFMEdit;
    FMExamRequest: TFMEdit;
    FMExamNumber: TFMEdit;
    FMFeeExam: TFMEdit;
    ActionManViewExam: TActionManager;
    actEditUndo: TAction;
    actEditCut: TAction;
    actEditCopy: TAction;
    actEditPaste: TAction;
    actMenuBarViewExam: TActionMainMenuBar;
    VA508AccessibilityManager1: TVA508AccessibilityManager;                     // -MER CodeCR116 8/2010
    st508RegionalOfficeNumber: TVA508StaticText;                                // -MER CodeCR116 8/2010
    st508ClaimFolder: TVA508StaticText;                                         // -MER CodeCR116 8/2010
    st508EPriorityOfExams: TVA508StaticText;                                    // -MER CodeCR116 8/2010
    st508RoutingLocation: TVA508StaticText;                                     // -MER CodeCR116 8/2010
    st508LastRatingExamDate: TVA508StaticText;
    FMLastRatingExamDate: TFMEdit;
    dtpLastRatingExamDate: TDateTimePicker;
    lblLastRatingExamDate: TLabel;
    caLastRatingExamDate: TVA508ComponentAccessibility;
    chklstSpecialConsiderations: TCheckListBox;
    lblClaimType: TLabel;
    lblSpecialConsiderations: TLabel;
    lblInsufficient: TLabel;
    FMInsufficientExam: TFMComboBox;
    st508ClaimType: TVA508StaticText;                                           // CodeCR666 JRL 11/20/14
    st508SpecialConsiderations: TVA508StaticText;                               // CodeCR667 JRL 11/20/14
    FMInsufficientExamFake: TFMEdit;
    st508InsufficientExam: TVA508StaticText;
    cbClaimType: TComboBox;
    lblElectronicClaimFolder: TLabel;                                           // CodeCR704 JRL 4/17/15
    FMElectronicClaimFolder: TFMComboBox;                                       // CodeCR704 JRL 4/17/15
    FMElectronicClaimFolderFake: TFMEdit;                                       // CodeCR704 JRL 4/17/15
    st508ElectronicClaimFolder: TVA508StaticText;                               // CodeCR704 JRL 4/17/15
    procedure btnAddExamClick(Sender: TObject);
    procedure btnCloseClick(Sender: TObject);
    procedure btnAddSelExamsClick(Sender: TObject);                             // Add Exam to Request
    procedure btnCancelAddExamsClick(Sender: TObject);
    procedure FMClaimFolderRequiredFakeChange(Sender: TObject);
    procedure FMOtherDocumentsRequiredFakeChange(Sender: TObject);
    procedure FMPriorityOfExamFakeChange(Sender: TObject);
    procedure FMRegionalOfficeNumberIENChange(Sender: TObject);
    procedure FMRoutingLocationFakeChange(Sender: TObject);
    procedure FMRequestedByIENChange(Sender: TObject);
    procedure FMRequestStatusChange(Sender: TObject);
    procedure FMLastRatingExamDateChange(Sender: TObject);
    procedure FMPriorityOfExamExit(Sender: TObject);
    procedure FMClaimFolderRequiredExit(Sender: TObject);
    procedure FMOtherDocumentsRequiredExit(Sender: TObject);
    procedure FMRegionalOfficeNumberExit(Sender: TObject);
    procedure FMRoutingLocationExit(Sender: TObject);
    procedure edExamReferenceNumberChange(Sender: TObject);
    procedure FMPatientNameIENChange(Sender: TObject);
    procedure FMClaimFolderRequiredChange(Sender: TObject);
    procedure FMOtherDocumentsRequiredChange(Sender: TObject);
    procedure FMPriorityOfExamChange(Sender: TObject);
    procedure FMRequestDateChange(Sender: TObject);
    procedure FMRegionalOfficeNumberChange(Sender: TObject);
    procedure FMRequestedByChange(Sender: TObject);
    procedure FMRoutingLocationChange(Sender: TObject);
    procedure FMCommentsMemoChange(Sender: TObject);
    procedure FMOtherDisabilities1Change(Sender: TObject);
    procedure FMOtherDisabilities2Change(Sender: TObject);
    procedure FMOtherDisabilities3Change(Sender: TObject);
    procedure lstExamsRequestedClick(Sender: TObject);
    procedure btnViewSelectedExamClick(Sender: TObject);
    procedure btnInsufficientExamClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure ButtonViewBySystemClick(Sender: TObject);
    procedure TreeViewExamsDblClick(Sender: TObject);
    procedure FMRegionalOfficeNumberEnter(Sender: TObject);
    procedure btnCancelAllExamsClick(Sender: TObject);
    procedure FMCommentsMemoEnter(Sender: TObject);
    procedure lstExamsRequestedKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure actEditUndoUpdate(Sender: TObject);
    procedure actEditUndoExecute(Sender: TObject);
    procedure actEditCutExecute(Sender: TObject);
    procedure actEditCopyExecute(Sender: TObject);
    procedure actEditPasteExecute(Sender: TObject);
    procedure dtpLastRatingExamDateChange(Sender: TObject);                     // -MER CodeCR116 8/2010
    procedure FormCreate(Sender: TObject);                                      //CodeCR123 - rpm 11/1/10
    procedure dtpLastRatingExamDateKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormDestroy(Sender: TObject);
    procedure chklstSpecialConsiderationsClickCheck(Sender: TObject);
    procedure cbClaimTypeChange(Sender: TObject);
    procedure FormMouseWheel(Sender: TObject; Shift: TShiftState;
      WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
    procedure FMElectronicClaimFolderFakeChange(Sender: TObject);               // CodeCR704 JRL 4/17/15
    procedure FMElectronicClaimFolderChange(Sender: TObject);                   // CodeCR704 JRL 4/17/15
    procedure FMElectronicClaimFolderExit(Sender: TObject);                     // CodeCR704 JRL 4/17/15
  private
    FakeDate: TDateTime;
    SaveClaimType: Boolean;                                                     // CodeCR666 JRL 11/20/14
    SaveSpecialConsiderations: Boolean;                                         // CodeCR667 JRL 11/20/14
    procedure WMMenuChar(var Message: TWMMenuChar); message WM_MENUCHAR;
    procedure Set508ControlOptions;
    procedure LoadClaimTypeControlValues;                                       // CodeCR666 JRL 11/6/14
    procedure LoadSpecialConsiderationControlValues;                            // CodeCR667 JRL 11/6/14
    procedure GetClaimType(RequestIEN: String);                                 // CodeCR666 JRL 11/6/14
    procedure GetSpecialConsidations(RequestIEN: String);                       // CodeCR667 JRL 11/6/14
    procedure SetClaimType(RequestIEN: String);                                 // CodeCR666 JRL 11/20/14
    procedure SetSpecialConsidations(RequestIEN: String);                       // CodeCR667 JRL 11/20/14
  public
    { Public declarations }
  end;

var
  frmViewExam: TfrmViewExam;
  CommentsFlag: Boolean;
  ClaimFolderRequired: Boolean;
  ElectronicClaimFolderAvailable: Boolean;                                      // CodeCR704 JRL 4/17/15
  CurrentRecordIEN: string;
  ViewExamCancelComments: TStringList;                                          // CodeCR670 rpk 11/14/2014

implementation

uses
  caprisupport,
  comments1,                                                                    // only needed for Patch 187 and prior -- but still here for 189 for backward compatibility code
  examdet,
  main,
  newexam,
  rofinder,
  untMiscMthds;                                                                 // rpk 3/5/2015

const
  FORM_TITLE_INSUFFICIENT_EXAM = 'Add New Insufficient C&P Exam';               //CodeCR669 JRL 10/7/14
  ELECTRONIC_CLAIM_FOLDER_AVAILABLE = 'ELECTRONIC CLAIMS FOLDER AVAILABLE.';    //CodeCR704 JRL 4/17/15
  SPECIAL_CONSIDERATIONS = '**SPECIAL CONSIDERATIONS:';                         //CodeCR725 JRL 4/29/15
  CLAIM_TYPE = '**CLAIM TYPE:';                                                 //CodeCR725 JRL 4/29/15
  INSUFFICIENT_EXAM = '**INSUFFICIENT EXAM:';                                   //CodeCR725 JRL 4/29/15


{$R *.DFM}

procedure TfrmViewExam.actEditCopyExecute(Sender: TObject);
begin
  FEditCtrl.CopyToClipboard;
end;

procedure TfrmViewExam.actEditCutExecute(Sender: TObject);
begin
  FEditCtrl.CutToClipboard;
end;

procedure TfrmViewExam.actEditPasteExecute(Sender: TObject);
begin
  FEditCtrl.SelText := Clipboard.AsText;
end;

procedure TfrmViewExam.actEditUndoExecute(Sender: TObject);
begin
  FEditCtrl.Perform(EM_UNDO, 0, 0);
end;

procedure TfrmViewExam.actEditUndoUpdate(Sender: TObject);
var
  tempTMemoBox: TMemo;
  tempTFmMemoBox: TFmMemo;
  tempTEdit: TEdit;
  tempTFMEdit: TFMEdit;
begin
  FEditCtrl := nil;
  if Screen.ActiveControl is TCustomEdit then
    FEditCtrl := TCustomEdit(Screen.ActiveControl);
  if FEditCtrl <> nil then
  begin
    actEditUndo.Enabled := FEditCtrl.Perform(EM_CANUNDO, 0, 0) <> 0;
    actEditCut.Enabled := FEditCtrl.SelLength > 0;
    actEditCopy.Enabled := actEditCut.Enabled;
    actEditPaste.Enabled := Clipboard.HasFormat(CF_TEXT);
  end
  else begin
    actEditUndo.Enabled := False;
    actEditCut.Enabled := False;
    actEditCopy.Enabled := False;
    actEditPaste.Enabled := False;
  end;
  // Don't let read only memos accept paste function
  if FEditCtrl = nil then
    exit;
  if (Uppercase(FEditCtrl.ClassName) = 'TMEMO') then begin
    tempTMemoBox := FEditCtrl as TMemo;
    if (tempTMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMMEMO') then begin
    tempTFmMemoBox := FEditCtrl as TFmMemo;
    if (tempTFmMemoBox.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TEDIT') then begin
    tempTEdit := FEditCtrl as TEdit;
    if (tempTEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
  if (Uppercase(FEditCtrl.ClassName) = 'TFMEDIT') then begin
    tempTFMEdit := FEditCtrl as TFMEdit;
    if (tempTFMEdit.Readonly = True) then begin
      actEditUndo.Enabled := False;
      actEditCut.Enabled := False;
      actEditPaste.Enabled := False;
    end;
  end;
end;

procedure TfrmViewExam.btnAddExamClick(Sender: TObject);
var
  x, y: integer;
  TempExam: string;
begin
  frmViewExam.CheckBoxExamsToComplete.Items.Clear;
  if frmViewExam.FMExamsList.Items.Count > 0 then
    for x := 0 to frmViewExam.FMExamsList.Items.Count - 1 do
      if Pos('  I', frmViewExam.FMExamsList.Items[x]) = 0 then
        frmViewExam.CheckBoxExamsToComplete.Items.Add(Copy(frmViewExam.FMExamsList.Items[x], 1, Pos('  A', frmViewExam.FMExamsList.Items[x]) - 3));
  if lstExamsRequested.Items.Count > 0 then
    for x := 0 to lstExamsRequested.Items.Count - 1 do begin
      TempExam := Copy(lstExamsRequested.Items[x], 1, pos(' [O', lstExamsRequested.Items[x]) - 1);
      for y := CheckBoxExamsToComplete.Items.Count - 1 downto 0 do
        if CheckBoxExamsToComplete.Items[y] = TempExam then
          CheckBoxExamsToComplete.Items.Delete(y);
    end;
  // If exam is an insufficient type, make sure window does not show exams originally ordered
(*
  If FMPriorityofExam.Text='INSUFFICIENT EXAM' then begin;
    ShowMessageCAPRI('To request a new exam, find the original request for this INSUFFICIENT EXAM and click the "Add An Insufficient Exam Request" button.');
    Exit;
  end;
*)
  //Only if status=NEW or PENDING, REPORTED
  if (FMRequestStatus.Text <> 'NEW') and (FMRequestStatus.Text <> 'PENDING, REPORTED') then begin
    ShowMessageCAPRI('You cannot add exams to this request.  Please create a new request to schedule new exams.');
    Exit;
  end;
  AddExamPanel.BringToFront;
  AddExamPanel.Enabled := True;
  if CheckBoxExamsToComplete.Items.Count > 0 then
    for x := 0 to CheckboxExamsToComplete.Items.Count - 1 do
      CheckboxExamsToComplete.Checked[x] := False;
end;

procedure TfrmViewExam.btnCloseClick(Sender: TObject);
var
  x: integer;
  SendCancelEmail: Boolean;
  TempLine: string;
  HowManyOpen: Integer;
  FMDateNow: string;
  SpecialConsiderationCount: Integer;
//  ClaimTypeText: String;
  NeedToSave: Boolean;
  buffer : String;      // CodeCR725 JRL 4/29/15
  FoundItem : Boolean;  // CodeCR725 JRL 4/29/15
begin
  frmMain.RPCBroker1.RemoteProcedure := 'ORWU DT';
  frmMain.RPCBroker1.Param[1].Value := 'NOW';
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('ORWU DT could not be accessed!');
  end;
  fmdatenow := frmMain.RPCBroker1.Results[0];
  SendCancelEmail := False;
  if AddExamPanel.Enabled = True then
  begin
    ShowMessageCAPRI('You are adding exams.  Please complete that function before closing this window.');
    exit;
  end;
  // Update original request if all entries cancelled.
  for x := 0 to 1000 do
    if CancelIt[x] = TRUE then
      SendCancelEmail := True;
  if SendCancelEmail = True then
  begin
    HowManyOpen := 0;
    if lstExamsRequested.Items.Count > 0 then
      for x := 0 to lstExamsRequested.Items.Count - 1 do
        if Pos('[CANCEL', lstExamsRequested.Items[x]) = 0 then
          inc(HowManyOpen);
    if HowManyOpen = 0 then
    begin
      btnAddexam.Enabled := False;                                              // Do this in case they don't save changes and go back into form.
      frmMain.FMValidator1.Setup('396.3', frmMain.FMExamRequestListbox.GetSelectedRecord.IEN, '19', FMDateNow); // Set cancel date to today
      if not frmMain.FMValidator1.Validate then
        frmMain.FMValidator1.DisplayErrors
      else                                                                      {file}
      begin
        //Put validated .01 field for new record on Filer's change list
        FMFiler1.AddFDA('396.3', frmMain.FMExamRequestListbox.GetSelectedRecord.IEN, '19', FMDateNow); // Set cancel date to today
        //Add new record
        if not FMFiler1.Update then
          FMFiler1.DisplayErrors;
        //get IENS of new record}
      end;
//      FMEdit12.Text := '`' + AuthorIEN;
      FMEditCancelledBy.Text := '`' + AuthorIEN;                                // rpk 4/20/2015
      if lstExamsRequested.Items.Count > 0 then
        for x := 0 to lstExamsRequested.Items.Count - 1 do
          if Pos('[CANCEL', lstExamsRequested.Items[x]) > 0 then
          begin
            FMRequestStatus.Text := Copy(lstExamsRequested.Items[x], Pos('[CANCEL', lstExamsRequested.Items[x]) + 1, 999);
            FMRequestStatus.Text := Copy(FMRequestStatus.Text, 1, Length(FMRequestStatus.Text) - 1);
          end;
      if FMRequestStatus.Text = 'CANCELED BY RO' then
        FMRequestStatus.Text := 'RX';
      if FMRequestStatus.Text = 'CANCELED BY MAS' then
        FMRequestStatus.Text := 'X';
    end;
    // Check here if no exams are attached and set status to cancelled if so.
    // This is needed in case there are transmission errors which prevents
    // the original from having any exams attached.
    // Also needed in case the user cancels all exams.
    HowManyOpen := 0;
    if lstExamsRequested.Items.Count > 0 then
      for x := 0 to lstExamsRequested.Items.Count - 1 do
        if Pos('[CANCEL', lstExamsRequested.Items[x]) = 0 then
          inc(HowManyOpen);
    //Only do it for a new or pending exam, not a completed.
    if ((FMRequestStatus.Text = 'NEW') or (FMRequestStatus.Text <> 'PENDING, REPORTED')) then
      if HowManyOpen = 0 then begin
        if FMRequestStatus.Text = '' then
        begin
          FMRequestStatus.Text := 'X';                                          // Canceled by MAS;
          ShowMessageCAPRI('This request has no pending exams.  It will be cancelled.');
        end;
        // Save new status
        if FMRequestStatus.FMModified then
          if FMRequestStatus.Validate then
          begin
            FMFiler1.AddChgdControl(FMRequestStatus);
            FMRequestStatus.Text := FMRequestStatus.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            FMRequestStatus.Text := FMRequestStatus.FMTag;
          end;
        {if FMEdit12.FMModified then
          if FMEdit12.Validate then
          begin
            FMFiler1.AddChgdControl(FMEdit12);
            FMEdit12.Text := FMEdit12.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            FMEdit12.Text := FMEdit12.FMTag;
          end;}

        if FMEditCancelledBy.FMModified then                                    // rpk 4/20/2015
          if FMEditCancelledBy.Validate then
          begin
            FMFiler1.AddChgdControl(FMEditCancelledBy);
            FMEditCancelledBy.Text := FMEditCancelledBy.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            FMEditCancelledBy.Text := FMEditCancelledBy.FMTag;
          end;

        if FMFiler1.AnythingToFile then
          if FMFiler1.DataProblemCheck then
            FMFiler1.ProcessDataProblemList;
        if FMFiler1.Update then
        begin
          AddRequestIEN := FMFiler1.FindIen('+1,') + ',';
          ModalResult := mrOK;
        end
        else
          FMFiler1.DisplayErrors;
      end;
  end;
  //
  // Check whether to save or not save when exiting
  NeedToSave := FALSE;
  If IsPatchInstalled('DVBA*2.7*189') then                                      // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
  begin
    if (SaveFlag = TRUE) OR
      (SaveClaimType = TRUE) OR                                                 // CodeCR666 JRL 11/20/14
      (SaveSpecialConsiderations = TRUE) then                                   // CodeCR667 JRL 11/20/14
      NeedToSave := TRUE;
  end
  else                                                                          // DVBA*2.7*187
  begin
    if SaveFlag = TRUE then
      NeedToSave := TRUE;
  end;

  if NeedToSave then                                                            // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
  begin
    if Application.MessageBox('Save Changes?', 'Changes Detected', 4) = 6 then
    begin
      if TreeViewExams.Selected <> nil then
      begin
        ShowMessageCAPRI('You are looking at exams by body system.  Either click the "View Selected Exams" button to abort the selection you have clicked or double-click it to add it to your list of exams being requested.');
        try
          if TreeViewExams.CanFocus then                                        // rpk 11/10/2014
            TreeViewExams.SetFocus
        except
        end;
        exit;
      end;
      if FMClaimFolderRequired.Text = '' then
      begin
        ShowMessageCAPRI('Please select whether claim folder is required.');
        Exit;
      end;
      If IsPatchInstalled('DVBA*2.7*190') then                                  // CodeCR704 JRL 4/17/15
      begin                                                                     // CodeCR704 JRL 4/17/15
        If FMElectronicClaimFolder.Text = '' Then                               // CodeCR704 JRL 4/17/15
        Begin                                                                   // CodeCR704 JRL 4/17/15
          ShowMessageCAPRI('Please select whether Electronic Claim Folder Available is required.'); // CodeCR704 JRL 4/17/15
          Exit;                                                                 // CodeCR704 JRL 4/17/15
        End;                                                                    // CodeCR704 JRL 4/17/15
      end;                                                                      // CodeCR704 JRL 4/17/15
      (*
        If FMOtherDocumentsRequired.Text='' then begin;
          ShowMessageCAPRI('Please select whether other documents are required.');
          Exit;
        end;
      *)
      if FMRegionalOfficeNumber.Text = '' then
      begin
        ShowMessageCAPRI('Please select a regional office number.');
        Exit;
      end;
      if not IsPatchInstalled('DVBA*2.7*189') then                              // CodeCR666 2/5/15 JRL - added test for backward compatibility
      begin
        if FMPriorityOfExam.Text = '' then
        begin
          ShowMessageCAPRI('Please select a priority of exam(s).');
          Exit;
        end;
      end;

      If IsPatchInstalled('DVBA*2.7*189') then                                  // CodeCR666 JRL 2/3/15 - Added for backward compatibility
      begin
        if cbClaimType.ItemIndex = -1 then                                      // CodeCR666 JRL 1/29/15
        begin                                                                   // CodeCR666 JRL 2/2/15
          ShowMessageCAPRI('Please select one Claim Type.');                    // CodeCR666 JRL 1/29/15
          Exit;                                                                 // CodeCR666 JRL 2/2/15
        end;                                                                    // CodeCR666 JRL 2/2/15
      end;

      // Added Special Considerations per updated CodeCR667 - JRL - 1/30/15
      if IsPatchInstalled('DVBA*2.7*189') then                                  // CodeCR666 JRL 2/3/15 - Added for backward compatibility
      begin
        SpecialConsiderationCount := 0;                                         // CodeCR667 JRL 1/30/15
        for x := 0 to chklstSpecialConsiderations.Count - 1 do                  // CodeCR667 JRL 1/30/15
        begin                                                                   // CodeCR667 JRL 1/30/15
          if chklstSpecialConsiderations.Checked[x] then                        // CodeCR667 JRL 1/30/15
            inc(SpecialConsiderationCount);                                     // CodeCR667 JRL 1/30/15
        end;                                                                    // CodeCR667 JRL 1/30/15
        if SpecialConsiderationCount = 0 then                                   // CodeCR667 JRL 1/30/15
        begin                                                                   // CodeCR667 JRL 2/2/15
          ShowMessageCAPRI('Please select ONE OR MORE Special Considerations' + #13#10 + 'or select Not Applicable".'); // CodeCR667 JRL 1/30/15
          Exit;                                                                 // CodeCR667 JRL 2/2/15
        end;                                                                    // CodeCR667 JRL 2/2/15
      end;                                                                      // if IsPatchInstalled('DVBA*2.7*189') then

      if FMRoutingLocation.Text = '' then
      begin
        ShowMessageCAPRI('Please select a routing location.');
        Exit;
      end;
      //FMRequestedByIEN.Text:='`'+AuthorIEN;  // Set to person who edited
      (*
      if FMPatientNameIEN.FMModified then  if FMPatientNameIEN.Validate then begin
        FMFiler1.AddChgdControl(FMPatientNameIEN);FMPatientNameIEN.Text:=FMPatientNameIEN.FMCtrlExternal;
        end else begin
         frmMain.FMValidator1.DisplayErrors; FMPatientNameIEN.Text:=FMPatientNameIEN.FMTag;
        end;
      *)

      (*
      // Check if claim folder comment already there.  If not, add it.
      claimcommentfound:=false;
      If FMCommentsMemo.Lines.Count>0 then
        for xx:=0 to FMCommentsMemo.Lines.Count-1 do
          If Pos('CLAIM FOLDER REQUIRED FOR THIS 2507 REQUEST?',FMCommentsMemo.Lines[xx])>0 then
            claimcommentfound:=true;
      *)

      // If space in line 2 is removed, put it back
      if FMCommentsMemo.Lines[0] = 'CLAIMS FILE BEING SENT FOR REVIEW BY THE EXAMINER.' then
        if FMCommentsMemo.Lines[1] <> '' then
          FMCommentsMemo.Lines.Insert(1, '');

      //rra 919417 comment out line of code below so editing of
      // 2507 Request does not update the Requested By value
      // FMRequestedByIEN.Text := '`' + AuthorIEN;

      //----- CLAIM FOLDER REQUIRED ------ //  
      if ClaimFolderRequired = True then
        if uppercase(FMClaimFolderRequired.Text) = 'NO' then
        begin
          // Changed from yes to no.
          // delete out of comments
//          if FMCommentsMemo.Lines[0] = 'CLAIMS FILE BEING SENT FOR REVIEW BY THE EXAMINER.' then
//            FMCommentsMemo.Lines.Delete(0);
//          if FMCommentsMemo.Lines[0] = '' then
//            FMCommentsMemo.Lines.Delete(0);
          // Above commented code does not delete the text if it doesn't happen to be on
          // line one.  There are times when other text is added above and the
          // text deletion fails.  Added a search for the current text and 
          // delete it wherever it is found in the comments.
          for x := 0 to FMCommentsMemo.Lines.Count - 1 do                       // CodeCR704 JRL 4/20/15
          begin                                                                 // CodeCR704 JRL 4/20/15
            if FMCommentsMemo.Lines[x] = 'CLAIMS FILE BEING SENT FOR REVIEW BY THE EXAMINER.' then
            begin                                                               // CodeCR704 JRL 4/20/15
              FMCommentsMemo.Lines.Delete(x);
//              if FMCommentsMemo.Lines[x] = '' then
//                FMCommentsMemo.Lines.Delete(x);
            end;                                                                // CodeCR704 JRL 4/20/15
          end;                                                                  // CodeCR704 JRL 4/20/15
        end;

      if ClaimFolderRequired = False then
        if uppercase(FMClaimFolderRequired.Text) = 'YES' then
        begin
          // Changed from no to yes
//        FMCommentsMemo.Lines.Insert(0, 'CLAIMS FILE BEING SENT FOR REVIEW BY THE EXAMINER.');
          FMCommentsMemo.Lines.Add('CLAIMS FILE BEING SENT FOR REVIEW BY THE EXAMINER.');  
        end;
        
      If IsPatchInstalled('DVBA*2.7*190') then                                  // CodeCR704 JRL 4/17/15
      begin                                                                     // CodeCR704 JRL 4/17/15
        //----- ELECTRONIC CLAIM FOLDER ------ //  
        if ElectronicClaimFolderAvailable = True then                           // CodeCR704 JRL 4/17/15
          if uppercase(FMElectronicClaimFolder.Text) = 'NO' then                // CodeCR704 JRL 4/17/15
          begin                                                                 // CodeCR704 JRL 4/17/15
          // Changed from yes to no.                                            // CodeCR704 JRL 4/17/15
          // delete out of comments                                             // CodeCR704 JRL 4/17/15
            for x := 0 to FMCommentsMemo.Lines.Count - 1 do                     // CodeCR704 JRL 4/17/15
            begin                                                               // CodeCR704 JRL 4/17/15
              if FMCommentsMemo.Lines[x] = ELECTRONIC_CLAIM_FOLDER_AVAILABLE then // CodeCR704 JRL 4/17/15
              begin                                                             // CodeCR704 JRL 4/17/15
                FMCommentsMemo.Lines.Delete(x);                                 // CodeCR704 JRL 4/17/15
//                if FMCommentsMemo.Lines[x] = '' then                            // CodeCR704 JRL 4/17/15
//                  FMCommentsMemo.Lines.Delete(x);                               // CodeCR704 JRL 4/17/15
              end;                                                              // CodeCR704 JRL 4/17/15
            end;                                                                // CodeCR704 JRL 4/17/15
          end;                                                                  // CodeCR704 JRL 4/17/15
        if ElectronicClaimFolderAvailable = False then                          // CodeCR704 JRL 4/17/15
          if uppercase(FMElectronicClaimFolder.Text) = 'YES' then               // CodeCR704 JRL 4/17/15
          begin                                                                 // CodeCR704 JRL 4/17/15
            // Changed from no to yes                                           // CodeCR704 JRL 4/17/15
//          FMCommentsMemo.Lines.Insert(x, ELECTRONIC_CLAIM_FOLDER_AVAILABLE);  // CodeCR704 JRL 4/17/15
            FMCommentsMemo.Lines.Add(ELECTRONIC_CLAIM_FOLDER_AVAILABLE);
          end;                                                                  // CodeCR704 JRL 4/17/15
        //----- INSUFFICIENT EXAM ------ //  
        buffer := INSUFFICIENT_EXAM + ' ';                                      // CodeCR725 JRL 4/29/15
        if FMInsufficientExam.Items[FMInsufficientExam.ItemIndex] = 'YES' then  // CodeCR725 JRL 4/29/15
           buffer := buffer + 'YES'                                             // CodeCR725 JRL 4/29/15
        else                                                                    // CodeCR725 JRL 4/29/15
           buffer := buffer + 'NO';                                             // CodeCR725 JRL 4/29/15
        FoundItem := FALSE;                                                     // CodeCR725 JRL 4/29/15
        for x := 0 to FMCommentsMemo.Lines.Count - 1 do                         // CodeCR725 JRL 4/29/15
        begin                                                                   // CodeCR725 JRL 4/29/15
          if Pos(INSUFFICIENT_EXAM, FMCommentsMemo.Lines[x]) <> 0 then          // CodeCR725 JRL 4/29/15
          begin                                                                 // CodeCR725 JRL 4/29/15
            FMCommentsMemo.Lines[x] := buffer;                                  // CodeCR725 JRL 4/29/15
            FoundItem := TRUE;                                                  // CodeCR725 JRL 4/29/15
            break;                                                              // CodeCR725 JRL 4/29/15
          end;                                                                  // CodeCR725 JRL 4/29/15
        end;                                                                    // CodeCR725 JRL 4/29/15
        // if exam was an older exam, then INSUFFICIENT EXAM won't be           // CodeCR725 JRL 4/29/15
        // found in the old text.  Add it now.                                  // CodeCR725 JRL 4/29/15
        if FoundItem = FALSE then                                               // CodeCR725 JRL 4/29/15
           FMCommentsMemo.Lines.Insert(0, buffer);                              // CodeCR725 JRL 4/29/15
        //----- SPECIAL CONSIDERATIONS ------ //  
        // Find Special Considerations in text.  Instead of testing for change, // CodeCR725 JRL 4/29/15
        // just delete old line and replace with newly generated text           // CodeCR725 JRL 4/29/15
        buffer := SPECIAL_CONSIDERATIONS + ' ';                                 // CodeCR725 JRL 4/29/15
        for x := 0 to chklstSpecialConsiderations.Count - 1 do                  // CodeCR725 JRL 4/29/15
        begin                                                                   // CodeCR725 JRL 4/29/15
          if chklstSpecialConsiderations.Checked[x] then                        // CodeCR725 JRL 4/29/15
             buffer := buffer + chklstSpecialConsiderations.Items[x] + ', ';    // CodeCR725 JRL 4/29/15
        end;                                                                    // CodeCR725 JRL 4/29/15
        buffer := copy(buffer,1,length(buffer)-2);                              // CodeCR725 JRL 4/29/15
        FoundItem := FALSE;                                                     // CodeCR725 JRL 4/29/15
        for x := 0 to FMCommentsMemo.Lines.Count - 1 do                         // CodeCR725 JRL 4/29/15
        begin                                                                   // CodeCR725 JRL 4/29/15
          if Pos(SPECIAL_CONSIDERATIONS, FMCommentsMemo.Lines[x]) <> 0 then// CodeCR725 JRL 4/29/15
          begin                                                                 // CodeCR725 JRL 4/29/15
            FMCommentsMemo.Lines[x] := buffer;                                  // CodeCR725 JRL 4/29/15
            FoundItem := TRUE;                                                  // CodeCR725 JRL 4/29/15
            break;                                                              // CodeCR725 JRL 4/29/15
          end;                                                                  // CodeCR725 JRL 4/29/15
        end;                                                                    // CodeCR725 JRL 4/29/15
        // if exam was an older exam, then SPECIAL CONSIDERATIONS won't be      // CodeCR725 JRL 4/29/15
        // found in the old text.  Add it now.                                  // CodeCR725 JRL 4/29/15
        if FoundItem = FALSE then                                               // CodeCR725 JRL 4/29/15
           FMCommentsMemo.Lines.Insert(0, buffer);                              // CodeCR725 JRL 4/29/15
                            
        //----- CLAIM TYPE ------ //  
        // Find CLAIM TYPE in text.  Instead of testing for change,             // CodeCR725 JRL 4/29/15
        // just delete old line and replace with newly generated text           // CodeCR725 JRL 4/29/15
        buffer := CLAIM_TYPE + ' ' + cbClaimType.Items[cbClaimType.ItemIndex];  // CodeCR725 JRL 4/29/15
        FoundItem := FALSE;                                                     // CodeCR725 JRL 4/29/15
        for x := 0 to FMCommentsMemo.Lines.Count - 1 do                         // CodeCR725 JRL 4/29/15
        begin                                                                   // CodeCR725 JRL 4/29/15
          if Pos(CLAIM_TYPE, FMCommentsMemo.Lines[x]) <> 0 then                 // CodeCR725 JRL 4/29/15
          begin                                                                 // CodeCR725 JRL 4/29/15
            FMCommentsMemo.Lines[x] := buffer;                                  // CodeCR725 JRL 4/29/15
            FoundItem := TRUE;                                                  // CodeCR725 JRL 4/29/15
            break;                                                              // CodeCR725 JRL 4/29/15
          end;                                                                  // CodeCR725 JRL 4/29/15
        end;                                                                    // CodeCR725 JRL 4/29/15
        // if exam was an older exam, then CLAIM TYPE won't be                  // CodeCR725 JRL 4/29/15
        // found in the old text.  Add it now.                                  // CodeCR725 JRL 4/29/15
        if FoundItem = FALSE then                                               // CodeCR725 JRL 4/29/15
           FMCommentsMemo.Lines.Insert(0, buffer);                              // CodeCR725 JRL 4/29/15
      end;                                                                      // CodeCR704 JRL 4/17/15

      TimeSinceLastBrokerCall := 0;                                             // Prevent event

      if FMRequestDate.FMModified then
        if FMRequestDate.Validate then
        begin
          FMFiler1.AddChgdControl(FMRequestDate);
          FMRequestDate.Text := FMRequestDate.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMRequestDate.Text := FMRequestDate.FMTag;
        end;
      if FMRequestStatus.FMModified then
        if FMRequestStatus.Validate then
        begin
          FMFiler1.AddChgdControl(FMRequestStatus);
          FMRequestStatus.Text := FMRequestStatus.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMRequestStatus.Text := FMRequestStatus.FMTag;
        end;
      if FMClaimFolderRequiredFake.FMModified then
        if FMClaimFolderRequiredFake.Validate then
        begin
          FMFiler1.AddChgdControl(FMClaimFolderRequiredFake);
          FMClaimFolderRequiredFake.Text := FMClaimFolderRequiredFake.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMClaimFolderRequiredFake.Text := FMClaimFolderRequiredFake.FMTag;
        end;
      If IsPatchInstalled('DVBA*2.7*190') then                                  // CodeCR704 JRL 4/17/15
      begin                                                                     // CodeCR704 JRL 4/17/15
        if FMElectronicClaimFolderFake.FMModified then                          // CodeCR704 JRL 4/17/15
          if FMElectronicClaimFolderFake.Validate then                          // CodeCR704 JRL 4/17/15
          begin                                                                 // CodeCR704 JRL 4/17/15
            FMFiler1.AddChgdControl(FMElectronicClaimFolderFake);               // CodeCR704 JRL 4/17/15
            FMElectronicClaimFolderFake.Text := FMElectronicClaimFolderFake.FMCtrlExternal; // CodeCR704 JRL 4/17/15
          end                                                                   // CodeCR704 JRL 4/17/15
          else                                                                  // CodeCR704 JRL 4/17/15
          begin                                                                 // CodeCR704 JRL 4/17/15
            frmMain.FMValidator1.DisplayErrors;                                 // CodeCR704 JRL 4/17/15
            FMElectronicClaimFolderFake.Text := FMElectronicClaimFolderFake.FMTag; // CodeCR704 JRL 4/17/15
          end;                                                                  // CodeCR704 JRL 4/17/15
      end;                                                                      // CodeCR704 JRL 4/17/15
      if FMOtherDocumentsRequiredFake.FMModified then
        if FMOtherDocumentsRequiredFake.Validate then
        begin
          FMFiler1.AddChgdControl(FMOtherDocumentsRequiredFake);
          FMOtherDocumentsRequiredFake.Text := FMOtherDocumentsRequiredFake.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMOtherDocumentsRequiredFake.Text := FMOtherDocumentsRequiredFake.FMTag;
        end;
      //if FMRegionalOfficeNumberIEN.FMModified then  if FMRegionalOfficeNumberIEN.Validate then begin
      //  FMFiler1.AddChgdControl(FMRegionalOfficeNumberIEN);FMRegionalOfficeNumberIEN.Text:=FMRegionalOfficeNumberIEN.FMCtrlExternal;
      //  end else begin
      //   frmMain.FMValidator1.DisplayErrors; FMRegionalOfficeNumberIEN.Text:=FMRegionalOfficeNumberIEN.FMTag;
      //end;
      if FMRequestedByIEN.FMModified then
        if FMRequestedByIEN.Validate then
        begin
          FMFiler1.AddChgdControl(FMRequestedByIEN);
          FMRequestedByIEN.Text := FMRequestedByIEN.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMRequestedByIEN.Text := FMRequestedByIEN.FMTag;
        end;

      if not IsPatchInstalled('DVBA*2.7*189') then                              // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
      begin
        if FMPriorityOfExamFake.FMModified then
          if FMPriorityOfExamFake.Validate then
          begin
            FMFiler1.AddChgdControl(FMPriorityOfExamFake);
            FMPriorityOfExamFake.Text := FMPriorityOfExamFake.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            FMPriorityOfExamFake.Text := FMPriorityOfExamFake.FMTag;
          end;
      end;

      If IsPatchInstalled('DVBA*2.7*189') then                                  // CodeCR666 JRL 2/3/15 - Added test for backward compatibility
      begin
        if SaveClaimType then                                                   // CodeCR666 JRL 11/20/14
          SetClaimType(edExamReferenceNumber.Text);                             // CodeCR666 JRL 11/20/14
        if SaveSpecialConsiderations then                                       // CodeCR667 JRL 11/20/14
          SetSpecialConsidations(edExamReferenceNumber.Text);                   // CodeCR667 JRL 11/20/14
      end;

      if FMOtherDisabilities1.FMModified then
        if FMOtherDisabilities1.Validate then
        begin
          FMFiler1.AddChgdControl(FMOtherDisabilities1);
          FMOtherDisabilities1.Text := FMOtherDisabilities1.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMOtherDisabilities1.Text := FMOtherDisabilities1.FMTag;
        end;
      if FMOtherDisabilities2.FMModified then
        if FMOtherDisabilities2.Validate then
        begin
          FMFiler1.AddChgdControl(FMOtherDisabilities2);
          FMOtherDisabilities2.Text := FMOtherDisabilities2.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMOtherDisabilities2.Text := FMOtherDisabilities2.FMTag;
        end;
      if FMOtherDisabilities3.FMModified then
        if FMOtherDisabilities3.Validate then
        begin
          FMFiler1.AddChgdControl(FMOtherDisabilities3);
          FMOtherDisabilities3.Text := FMOtherDisabilities3.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMOtherDisabilities3.Text := FMOtherDisabilities3.FMTag;
        end;
      if FMRoutingLocationFake.FMModified then
        if FMRoutingLocationFake.Validate then
        begin
          FMFiler1.AddChgdControl(FMRoutingLocationFake);
          FMRoutingLocationFake.Text := FMRoutingLocationFake.FMCtrlExternal;
        end
        else
        begin
          FMRoutingLocationFake.Text := '';
          ShowMessageCAPRI('This type of request cannot be sent to the division you''ve selected.  Please select a valid division.');
          exit;
          frmMain.FMValidator1.DisplayErrors;
          FMRoutingLocationFake.Text := FMRoutingLocationFake.FMTag;
        end;
      if FMLastRatingExamDate.FMModified then
        if FMLastRatingExamDate.Validate then
        begin
          FMFiler1.AddChgdControl(FMLastRatingExamDate);
          FMLastRatingExamDate.Text := FMLastRatingExamDate.FMCtrlExternal;
        end
        else
        begin
          frmMain.FMValidator1.DisplayErrors;
          FMLastRatingExamDate.Text := FMLastRatingExamDate.FMTag;
        end;
      if FMCommentsMemo.FMModified then
        FMFiler1.AddChgdControl(FMCommentsMemo);
      if CommentsFlag = True then
      begin
        // Update Remarks Modified Fields
        fmRemarksModified.Text := 'NOW';
        fmRemarksModifiedBy.Text := '`' + AuthorIEN;
        if fmRemarksModified.FMModified then
          if fmRemarksModified.Validate then
          begin
            FMFiler1.AddChgdControl(fmRemarksModified);
            fmRemarksModified.Text := fmRemarksModified.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            fmRemarksModified.Text := fmRemarksModified.FMTag;
          end;
        if fmRemarksModifiedBy.FMModified then
          if fmRemarksModifiedBy.Validate then
          begin
            FMFiler1.AddChgdControl(fmRemarksModifiedBy);
            fmRemarksModifiedBy.Text := fmRemarksModifiedBy.FMCtrlExternal;
          end
          else
          begin
            frmMain.FMValidator1.DisplayErrors;
            fmRemarksModifiedBy.Text := fmRemarksModifiedBy.FMTag;
          end;
      end;                                                                      // if CommentsFlag = True then
      if FMFiler1.AnythingToFile then
        if FMFiler1.DataProblemCheck then
          FMFiler1.ProcessDataProblemList;
      if FMFiler1.Update then
      begin
        AddRequestIEN := FMFiler1.FindIen('+1,') + ',';
        ModalResult := mrOK;
      end
      else
        FMFiler1.DisplayErrors;
    end;                                                                        // if Application.MessageBox('Save Changes?', 'Changes Detected', 4) = 6 then
  end;                                                                          // if NeedToSave then

  // Now send e-mail if any exams are cancelled;
  for x := 0 to 1000 do
    if CancelIt[x] = TRUE then
      SendCancelEmail := True;
  if SendCancelEmail = True then
  begin
    frmMain.MailManBuffer.Lines.Clear;
    frmMain.MailManBuffer.Lines.Add('The following veteran had one or more 2507 exams cancelled:');
    frmMain.MailManBuffer.Lines.Add('');
    frmMain.MailManBuffer.Lines.Add('  Name: ' + Uppercase(Copy(frmMain.Panel1.caption, 1, Pos('  SSN#', frmMain.Panel1.Caption))) + '   SSN: ' + PatientSSN + '   C-Number: ' + frmMain.CNumber.Caption);
    frmMain.MailManBuffer.Lines.Add('');

    If IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
    begin
      // Add Claim Type to email                                                // CodeCR666 JRL 1/29/15
      frmMain.MailManBuffer.Lines.Add('Claim Type:');                           // CodeCR666 JRL 1/29/15
      frmMain.MailManBuffer.Lines.Add(cbClaimType.Items[cbClaimType.ItemIndex]); // CodeCR666 JRL 1/29/15
      frmMain.MailManBuffer.Lines.Add('');                                      // blank line                        // CodeCR666 JRL 1/29/15
      // Add Special Considerations to email                                    // CodeCR667 JRL 11/5/14
      frmMain.MailManBuffer.Lines.Add('Special Consideration(s):');             // CodeCR667 JRL 2/2/15
      for x := 0 to chklstSpecialConsiderations.Count - 1 do                    // CodeCR667 JRL 11/5/14
      begin                                                                     // CodeCR667 JRL 11/5/14
        if chklstSpecialConsiderations.Checked[x] then                          // CodeCR667 JRL 11/5/14
          frmMain.MailManBuffer.Lines.Add('   ' + chklstSpecialConsiderations.Items[x]);
      end;                                                                      // CodeCR667 JRL 11/5/14
      frmMain.MailManBuffer.Lines.Add('');                                      // blank line                        // CodeCR667 JRL 11/5/14
    end
    else                                                                        // DVBA*2.7*187
    begin
      frmMain.MailManBuffer.Lines.Add('Priority of Exam:  ' + FMPriorityOfExamFake.Text); // CodeCR471 JRL 4/26/13
      frmMain.MailManBuffer.Lines.Add('');                                      // CodeCR471 JRL 4/26/13
    end;

    frmMain.MailManBuffer.Lines.Add('Exams cancelled                               Reason');
    for x := 0 to 1000 do
      if CancelIt[x] = TRUE then
      begin
        TempLine := Uppercase(Copy(Uppercase(lstExamsRequested.Items[x]), 1, Pos('[CANCEL', Uppercase(lstExamsRequested.Items[x])) - 1)) + '..................................................';
        frmMain.MailManBuffer.Lines.Add('     ' + Copy(TempLine, 1, 40) + ' ' + CancelReason[x]);
      end;
    // Add all exams cancelled message?
    frmMain.MailManBuffer.Lines.Add('');
    HowManyOpen := 0;
    if lstExamsRequested.Items.Count > 0 then
      for x := 0 to lstExamsRequested.Items.Count - 1 do
        if (Pos('[CANCEL', lstExamsRequested.Items[x]) = 0) AND                 //CodeCR471 JRL 5/21/13
          (Pos('[COMPLETE', lstExamsRequested.Items[x]) = 0) then               // Ignore cancel AND COMPLETED (new) exams
          inc(HowManyOpen);
    if HowManyOpen = 0 then
      frmMain.MailManBuffer.Lines.Add('*** All exams on this request are now CANCELLED. ***')
    else
      if HowManyOpen = 1 then
        frmMain.MailManBuffer.Lines.Add('*** There is still 1 exam open on this request. ***')
      else
        frmMain.MailManBuffer.Lines.Add('*** There are still ' + IntToStr(HowManyOpen) + ' exams open on this request. ***');
    // Add comments
    if ViewExamCancelComments.Count > 0 then begin
      frmMain.MailManBuffer.Lines.Add('');
      frmMain.MailManBuffer.Lines.Add('========================<  Additional Comments  >========================');
      frmMain.MailManBuffer.Lines.AddStrings(ViewExamCancelComments);           // rpk 11/18/2014
    end;

    if IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/2/15 - Added test for backward compatibility
    begin
      //CodeCR266 - rpm 1/10/12 - call new SendNotification function
      if NOT SendNotification(frmMain.MailManBuffer.Lines,
        AuthorIEN,
        'CAPRI: Cancellation of 2507 Exams',
        'DVBA C 2507 CANCELLATION',
        CurrentRecordIEN) then
        ShowMessageCAPRI('There was a problem notifying one or more recipients of mailgroup DVBA C 2507 CANCELLATION.  Please notify IRM!');
    end
    else                                                                        // DVBA*2.7*187
    begin
      // popup comments prior to 189 are shown here.  In Patch 189 forward, they
      // are shown from the exam detail screen
      frmComments := TfrmComments.Create(frmMain);
      frmComments.Top := frmMain.Top + ((frmMain.Height - frmComments.Height) div 2);
      frmComments.Left := frmMain.Left + ((frmMain.Width - frmComments.Width) div 2);
      frmComments.MemoCancelComments.Lines.Clear;
      try
        frmComments.MemoCancelComments.SetFocus
      except
      end;
      //  Set up screen
      frmComments.Font := frmMain.panel1.Font;
//    frmComments.label1.font := frmMain.panel1.Font;                           // label never displayed
      frmComments.memoCancelComments.Font := frmMain.panel1.font;
//    frmComments.button1.Font := frmMain.panel1.font;                          // button was renamed
//    frmComments.button1.height := frmMain.panel1.height;
//    frmComments.button1.top := frmComments.height - frmComments.button1.height * 3 - 8;
      frmComments.btnDone.Font := frmMain.panel1.font;
      frmComments.btnDone.height := frmMain.panel1.height;
      frmComments.btnDone.top := frmComments.height - frmComments.btnDone.height * 3 - 8;
//    frmComments.memoCancelComments.Top := frmComments.Label1.Top + frmComments.Label1.Height + 8;
//    frmComments.memoCancelComments.height := frmComments.button1.Top - frmComments.memoCancelComments.Top - 8;
      frmComments.memoCancelComments.height := frmComments.btnDone.Top - frmComments.memoCancelComments.Top - 8;
      //
      frmComments.ShowModal;
      if frmComments.memoCancelComments.Lines.Count > 0 then
      begin
        frmMain.MailManBuffer.Lines.Add('');
        frmMain.MailManBuffer.Lines.Add('========================<  Additional Comments  >========================');
        for x := 0 to frmComments.memoCancelComments.Lines.Count - 1 do
          frmMain.MailManBuffer.Lines.Add(frmComments.memoCancelComments.Lines[x]);
      end;
      //CodeCR266 - rpm 1/10/12 - call new SendNotification function
      if NOT SendNotification(frmMain.MailManBuffer.Lines,
        AuthorIEN,
        'CAPRI: Cancellation of 2507 Exams',
        'DVBA C 2507 CANCELLATION',
        CurrentRecordIEN) then
        ShowMessageCAPRI('There was a problem notifying one or more recipients of mailgroup DVBA C 2507 CANCELLATION.  Please notify IRM!');
      frmComments.Release;
      frmComments := nil;
    end;
  end;
  // End of cancel e-mail;
  ModalResult := mrOK;
end;

// Add selected Exams button

procedure TfrmViewExam.btnAddSelExamsClick(Sender: TObject);                    // Add Selected Exam(s) to Request
var
  x, y: integer;
  xx, yy, zz: integer;
  flag: boolean;
  tempholder: integer;
begin
  Flag := False;
  tempHolder := -1;
  for x := 0 to CheckBoxExamsToComplete.Items.Count - 1 do
    if CheckBoxExamsToComplete.Checked[x] then
      Flag := True;
  if Flag = False then begin
    ShowMessageCAPRI('Please select at least one exam.');
    Exit;
  end;
  if Application.MessageBox('Are you sure you want to add these exams?', 'Add Exams to 2507 Request', 4) = 6 then begin
    // Check to be sure exam requested isn't already open
    if frmMain.FMExamRequestListbox.Items.Count > 0 then
      tempholder := frmMain.FMExamRequestListbox.ItemIndex;
    for xx := 0 to frmMain.FMExamRequestListbox.Items.Count - 1 do begin
      // Find Exams
      frmMain.FMExamRequestListbox.ItemIndex := xx;
      frmMain.RPCBroker1.Results.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
      frmMain.RPCBroker1.Param[0].Value := frmMain.FMExamRequestListbox.GetSelectedRecord.IEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do
          ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
      end;
      if frmMain.RPCBroker1.Results.Count > 0 then
        for yy := 0 to frmMain.RPCBroker1.Results.Count - 1 do
          for zz := 0 to CheckBoxExamsToComplete.Items.Count - 1 do
            if CheckBoxExamsToComplete.Checked[zz] = True then
              if Pos(CheckBoxExamsToComplete.Items[zz] + ' [OPEN]', frmMain.RPCBroker1.Results[yy]) > 0 then begin
                ShowMessageCAPRI('An open ' + CheckBoxExamsToComplete.Items[zz] + ' has been found for request dated ' + Copy(frmMain.FMExamRequestListbox.Items[xx], 1, Pos('  |  ', frmMain.FMExamRequestListbox.Items[xx]) - 1) + '.  A duplicate of an open exam cannot be submitted.');
                frmMain.FMExamRequestListbox.ItemIndex := -1;                   // Clear selection;
                frmMain.FMExamRequestListbox.ItemIndex := tempHolder;
                exit;
              end;
    end;
    frmMain.FMExamRequestListbox.ItemIndex := -1;                               // Clear selection;
    AddRequestIEN := edExamReferenceNumber.Text;
    // Now add to the 2507 Exam File 396.4
    for x := 0 to CheckboxExamsToComplete.Items.Count - 1 do
      if CheckboxExamsToComplete.Checked[x] then
        for y := 0 to FMExamsList.Items.Count - 1 do
          if CheckBoxExamsToComplete.Items[x] + '    A' = Copy(FMExamsList.Items[y], 1, length(CheckBoxExamsToComplete.Items[x] + '    A')) then begin
            // Found one.  File it!
            FMExamsList.ItemIndex := y;
            frmMain.RPCBroker1.Results.Clear;
            frmMain.RPCBroker1.RemoteProcedure := 'DVBAB INCREASE EXAM COUNT';
            frmMain.RPCBrokerCall;
            try
              frmMain.RPCBroker1.Call;
            except
              on EBrokerError do
                ShowMessageCAPRI('RPC DVBAB INCREASE EXAM COUNT could not be accessed!');
            end;
            FMExamNumber.Text := frmMain.RPCBroker1.Results[0];
            FMExamRequest.Text := '`' + AddRequestIEN;
            FMExamType.Text := '`' + FMExamsList.GetSelectedRecord.IEN;
            FMExamStatus.Text := 'O';
            FMFeeExam.Text := 'Y';
            FMExamNumber.IENS := '+1';
            FMExamRequest.IENS := '+1';
            FMExamType.IENS := '+1';
            FMExamStatus.IENS := '+1';
            //FMExamFeeExam.IENS:='+1';
            fmLastExamAddDate.Text := 'NOW';
            fmLastExamAddedBy.Text := '`' + AuthorIEN;
            if fmLastExamAddDate.FMModified then
              if fmLastExamAddDate.Validate then begin
                FMFiler1.AddChgdControl(fmLastExamAddDate);
                fmLastExamAddDate.Text := fmLastExamAddDate.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                fmLastExamAddDate.Text := fmLastExamAddDate.FMTag;
              end;
            if fmLastExamAddedBy.FMModified then
              if fmLastExamAddedBy.Validate then begin
                FMFiler1.AddChgdControl(fmLastExamAddedBy);
                fmLastExamAddedBy.Text := fmLastExamAddedBy.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                fmLastExamAddedBy.Text := fmLastExamAddedBy.FMTag;
              end;
            if FMExamRequest.FMModified then
              if FMExamRequest.Validate then begin
                FMFiler1.AddChgdControl(FMExamRequest);
                FMExamRequest.Text := FMExamRequest.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                FMExamRequest.Text := FMExamRequest.FMTag;
              end;
            if FMExamNumber.FMModified then
              if FMExamNumber.Validate then begin
                FMFiler1.AddChgdControl(FMExamNumber);
                FMExamNumber.Text := FMExamNumber.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                FMExamNumber.Text := FMExamNumber.FMTag;
              end;
            if FMExamType.FMModified then
              if FMExamType.Validate then begin
                FMFiler1.AddChgdControl(FMExamType);
                FMExamType.Text := FMExamType.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                FMExamType.Text := FMExamType.FMTag;
              end;
            if FMExamStatus.FMModified then
              if FMExamStatus.Validate then begin
                FMFiler1.AddChgdControl(FMExamStatus);
                FMExamStatus.Text := FMExamStatus.FMCtrlExternal;
              end
              else begin
                frmMain.FMValidator1.DisplayErrors;
                FMExamStatus.Text := FMExamStatus.FMTag;
              end;
            if FMFiler1.AnythingToFile then
              if FMFiler1.DataProblemCheck then begin
                FMFiler1.ProcessDataProblemList
              end
              else
                if FMFiler1.Update then begin
                end
                else
                  FMFiler1.DisplayErrors;
          end;
    //
// Find Exams
    frmMain.FMExamRequestListbox.ItemIndex := tempHolder;
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
    frmMain.RPCBroker1.Param[0].Value := frmMain.FMExamRequestListbox.GetSelectedRecord.IEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
    frmViewExam.lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
    frmViewExam.lstExamsRequested.Items.Clear;
    if frmViewExam.lstExamsRequestedHidden.Items.Count > 0 then
      for x := 0 to frmViewExam.lstExamsRequestedHidden.Items.Count - 1 do
        frmViewExam.lstExamsRequested.Items.Add(Copy(frmViewExam.lstExamsRequestedHidden.Items[x], Pos('^', frmViewExam.lstExamsRequestedHidden.Items[x]) + 1, 254));
    //
    AddExamPanel.SendToBack;
    AddExamPanel.Enabled := False;
  end
  else begin
  end;
end;

procedure TfrmViewExam.btnCancelAddExamsClick(Sender: TObject);
begin
  AddExamPanel.SendToBack;
  AddExamPanel.Enabled := False;
end;

procedure TfrmViewExam.FMClaimFolderRequiredFakeChange(Sender: TObject);
begin
  SaveFlag := True;
  FMClaimFolderRequired.Text := FMClaimFolderRequiredFake.Text;
end;

//------------------------------------------------------------------------------
// CodeCR704 JRL 4/17/15 -- Added routine
//------------------------------------------------------------------------------

procedure TfrmViewExam.FMElectronicClaimFolderFakeChange(Sender: TObject);
begin
  If IsPatchInstalled('DVBA*2.7*190') then
  begin
    SaveFlag := True;
    FMElectronicClaimFolder.Text := FMElectronicClaimFolderFake.Text;
  end;
end;

procedure TfrmViewExam.FMOtherDocumentsRequiredFakeChange(
  Sender: TObject);
begin
  SaveFlag := True;
  FMOtherDocumentsRequired.Text := FMOtherDocumentsRequiredFake.Text;
end;

procedure TfrmViewExam.FMPriorityOfExamFakeChange(Sender: TObject);
begin
  SaveFlag := True;
  if Copy(FMPriorityOfExamFake.Text, 1, 1) <> '`' then
    FMPriorityOfExam.Text := FMPriorityOfExamFake.Text;
end;

procedure TfrmViewExam.cbClaimTypeChange(Sender: TObject);
begin
  SaveClaimType := True;                                                        // CodeCR666 JRL 2/2/15
end;

//------------------------------------------------------------------------------
// Altered routine per updated CodeCR667 - JRL - 1/30/15
// Requirement:  In instances where a user selects the special consideration
// not applicable, the multi-selection box shall not allow any additional
// selections to be made.
//
// If you click "NOT APPLICABLE", uncheck all other selections
// If you click another selection and "NOT APPLICABLE" is already checked,
//    unclick that selection
//------------------------------------------------------------------------------

procedure TfrmViewExam.chklstSpecialConsiderationsClickCheck(Sender: TObject);  // CodeCR667 JRL 11/20/14
const
  NOT_APPLICABLE = 'NOT APPLICABLE';
var
  i, NA_Index: Integer;
begin                                                                           // CodeCR667 JRL 11/20/14
  SaveSpecialConsiderations := True;                                            // CodeCR667 JRL 11/20/14
  // find NOT APPLICABLE index
  for i := 0 to chklstSpecialConsiderations.Count - 1 do
    if chklstSpecialConsiderations.Items[i] = NOT_APPLICABLE then
      NA_Index := i;
  // if you click "NOT APPLICABLE", uncheck all the other selections
  if chklstSpecialConsiderations.Items[chklstSpecialConsiderations.ItemIndex] =
    NOT_APPLICABLE then
  begin
    for i := 0 to chklstSpecialConsiderations.Count - 1 do
    begin
      if i <> chklstSpecialConsiderations.ItemIndex then
        chklstSpecialConsiderations.Checked[i] := FALSE
    end;
  end;
  // if "NOT APPLICABLE" is checked, don't allow any other items to be checked
  if (chklstSpecialConsiderations.Items[chklstSpecialConsiderations.ItemIndex] <>
    NOT_APPLICABLE) AND chklstSpecialConsiderations.Checked[NA_Index] = TRUE then
  begin
    chklstSpecialConsiderations.Checked[chklstSpecialConsiderations.ItemIndex] := FALSE;
  end;
end;                                                                            // CodeCR667 JRL 11/20/14


procedure TfrmViewExam.FMRegionalOfficeNumberIENChange(Sender: TObject);
begin
  SaveFlag := True;
  if Copy(FMRegionalOfficeNumberIEN.Text, 1, 1) <> '`' then
    FMRegionalOfficeNumber.Text := FMRegionalOfficeNumberIEN.Text;
end;

procedure TfrmViewExam.FMRoutingLocationFakeChange(Sender: TObject);
begin
  SaveFlag := True;
  if Copy(FMRoutingLocationFake.Text, 1, 1) <> '`' then
    FMRoutingLocation.Text := FMRoutingLocationFake.Text;
end;

procedure TfrmViewExam.FMRequestedByIENChange(Sender: TObject);
begin
  SaveFlag := True;
  FMRequestedBy.Text := FMRequestedByIEN.Text
end;

procedure TfrmViewExam.FMRequestStatusChange(Sender: TObject);
begin
  if ((FMRequestStatus.Text <> 'NEW') and (FMRequestStatus.Text <> 'PENDING, REPORTED') or (ReadOnlyMode = True)) then begin
    fmCommentsMemo.ReadOnly := True;
    btnAddExam.Enabled := False;
    fmOtherDisabilities1.Enabled := False;
    fmOtherDisabilities2.Enabled := False;
    fmOtherDisabilities3.Enabled := False;
    fmRoutingLocation.Enabled := False;
    fmRequestedBy.Enabled := False;
    If IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
    begin
      cbClaimType.Enabled := False;                                             // CodeCR666 JRL 11/5/14 Added Claim Type
      chklstSpecialConsiderations.Enabled := False;                             // CodeCR667 JRL 11/5/14 Added Special Considerations
    end
    else                                                                        // DVBA*2.7*187
      fmPriorityofExam.Enabled := False;
    fmOtherDocumentsRequired.Enabled := False;
    fmClaimFolderRequired.Enabled := False;
    fmElectronicClaimFolder.Enabled := False;                                   // rpk 4/20/2015
    FMRegionalOfficeNumber.Enabled := False; // rpk 4/20/2015
    fmRoutingLocation.Enabled := False;
    fmRegionalOfficeNumber.Enabled := False;
    dtpLastRatingExamDate.Enabled := False;                                     // -MER CodeCR116 8/2010
    fmLastRatingExamDate.Enabled := False;
  end
  else
  begin
    fmCommentsMemo.ReadOnly := False;
    btnAddExam.Enabled := True;
    fmOtherDisabilities1.Enabled := True;
    fmOtherDisabilities2.Enabled := True;
    fmOtherDisabilities3.Enabled := True;
    fmRoutingLocation.Enabled := True;
    fmRequestedBy.Enabled := False;                                             // Changed this
    fmOtherDocumentsRequired.Enabled := True;
    fmClaimFolderRequired.Enabled := True;
    fmElectronicClaimFolder.Enabled := True;                                    // rpk 4/20/2015
    If IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
    begin
      cbClaimType.Enabled := True;                                              // CodeCR666 JRL 1/29/15 Added Claim Type
      chklstSpecialConsiderations.Enabled := True;                              // CodeCR667 JRL 11/5/14 Added Special Considerations
    end
    else                                                                        // DVBA*2.7*187
      fmPriorityofExam.Enabled := True;                                         // CodeCR666 JRL 11/5/14 Removed Priority of Exam
//    fmRegionalOfficeNumber.Enabled := False;
    FMRegionalOfficeNumber.Enabled := True; // rpk 4/20/2015
    dtpLastRatingExamDate.Enabled := True;                                      // -MER CodeCR116 8/2010
    fmLastRatingExamDate.Enabled := True;
  end;
  Set508ControlOptions;                                                         // -MER CodeCR116 8/2010
  //SaveFlag:=True;
end;

// -MER CodeCR116 8/2010

procedure TfrmViewExam.FMLastRatingExamDateChange(Sender: TObject);
begin
  SaveFlag := True;
  if FMLastRatingExamDate.Text = '' then begin                                  // rpk 11/18/2014
      // If there is no valid date, we fake having no assigned date for the component
      // We also set a default date to avoid having to scroll too far through the calendar
    dtpLastRatingExamDate.Date := FakeDate;
    dtpLastRatingExamDate.Format := 'N/A';
  end
  else begin
    try
      dtpLastRatingExamDate.Date := OddDateFormatToDelphiDate(FMLastRatingExamDate.Text);
    except
      on e: Exception do begin
        // If there is no valid date, we fake having no assigned date for the component
        // We also set a default date to avoid having to scroll too far through the calendar
        dtpLastRatingExamDate.Date := FakeDate;
        dtpLastRatingExamDate.Format := 'N/A';
      end;
    end;
  end;
end;

procedure TfrmViewExam.FMPriorityOfExamExit(Sender: TObject);
var
  x: integer;
begin
  (*
    If FMPriorityOfExam.Text='INSUFFICIENT EXAM' then begin;
      ShowMessageCAPRI('"INSUFFICIENT EXAM" is a special category.  Click ADD AN INSUFFICIENT EXAM REQUEST if this request is insufficient and needs further follow-up.');
      FMPriorityOfExam.SetFocus;
      Exit;
    end;
  *)
  if FMPriorityOfExam.Text = '' then
    exit;
  for x := 0 to FMPriorityOfExam.Items.Count - 1 do
    if Pos(uppercase(FMPriorityOfExam.Text), uppercase(FMPriorityOfExam.Items[x])) = 1 then begin
      FMPriorityOfExam.ItemIndex := x;
    end;
  if FMPriorityOfExam.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Priority of Exam response is not valid.');
    FMPriorityOfExam.Text := '';
    FMPriorityOfExam.Setfocus;
    exit;
  end;
  FMPriorityOfExamFake.Text := FMPriorityOfExam.Text;
end;

procedure TfrmViewExam.FMClaimFolderRequiredExit(Sender: TObject);
var
  x: integer;
begin
  if FMClaimFolderRequired.Text = '' then
    exit;
  for x := 0 to FMClaimFolderRequired.Items.Count - 1 do
    if Pos(uppercase(FMClaimFolderRequired.Text), uppercase(FMClaimFolderRequired.Items[x])) > 0 then
      FMClaimFolderRequired.ItemIndex := x;
  if FMClaimFolderRequired.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Claim Folder Required response is not valid.');
    FMClaimFolderRequired.Text := '';
    FMClaimFolderRequired.Setfocus;
    exit;
  end;
  FMClaimFolderRequiredFake.Text := FMClaimFolderRequired.Text;
end;

//------------------------------------------------------------------------------
// CodeCR704 JRL 4/17/15 -- Added routine
//------------------------------------------------------------------------------

procedure TfrmViewExam.FMElectronicClaimFolderExit(Sender: TObject);
var
  x: integer;
begin
  If IsPatchInstalled('DVBA*2.7*190') then
  begin
    if FMElectronicClaimFolder.Text = '' then
      exit;
    for x := 0 to FMElectronicClaimFolder.Items.Count - 1 do
      if Pos(uppercase(FMElectronicClaimFolder.Text), uppercase(FMElectronicClaimFolder.Items[x])) > 0 then
        FMElectronicClaimFolder.ItemIndex := x;
    if FMElectronicClaimFolder.ItemIndex = -1 then
    begin
      ShowMessageCAPRI('The Electronic Claim Folder Available response is not valid.');
      FMElectronicClaimFolder.Text := '';
      FMElectronicClaimFolder.Setfocus;
      exit;
    end;
    FMElectronicClaimFolderFake.Text := FMElectronicClaimFolder.Text;
  end;
end;

procedure TfrmViewExam.FMOtherDocumentsRequiredExit(Sender: TObject);
var
  x: integer;
begin
  if FMOtherDocumentsRequired.Text = '' then
    exit;
  for x := 0 to FMOtherDocumentsRequired.Items.Count - 1 do
    if Pos(uppercase(FMOtherDocumentsRequired.Text), uppercase(FMOtherDocumentsRequired.Items[x])) > 0 then
      FMOtherDocumentsRequired.ItemIndex := x;
  if FMOtherDocumentsRequired.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Other Documents Required response is not valid.');
    FMOtherDocumentsRequired.Text := '';
    FMOtherDocumentsRequired.SetFocus;
    exit;
  end;
  FMOtherDocumentsRequiredFake.Text := FMOtherDocumentsRequired.Text;
end;

procedure TfrmViewExam.FMRegionalOfficeNumberExit(Sender: TObject);
var
  x: integer;
begin
  if FMRegionalOfficeNumber.Text = '' then
    exit;
  for x := 0 to FMRegionalOfficeNumber.Items.Count - 1 do
    if uppercase(FMRegionalOfficeNumber.Text) = uppercase(FMRegionalOfficeNumber.Items[x]) then begin
      FMRegionalOfficeNumber.ItemIndex := x;
    end;
  if FMRegionalOfficeNumber.ItemIndex = -1 then begin
    //ShowMessageCAPRI('The Regional Office you have entered is not in the list.');
    FMRegionalOfficeNumber.Text := '';
    FMRegionalOfficeNumber.Enabled := True;
    FMRegionalOfficeNumber.Setfocus;
    exit;
  end;
  if frmMain.lstInstitutions.Items.Count > 0 then
    for x := 0 to frmMain.lstInstitutions.Items.Count - 1 do
      if Pos(FMRegionalOfficeNumber.Text + '^', frmMain.lstInstitutions.Items[x]) = 1 then
        FMRegionalOfficeNumberIEN.Text := '`' + Piece(frmMain.lstInstitutions.Items[x], '^', 4);
end;

procedure TfrmViewExam.FMRoutingLocationExit(Sender: TObject);
var
  x: integer;
begin
  if FMRoutingLocation.Text = '' then
    exit;
  for x := 0 to FMRoutingLocation.Items.Count - 1 do
    if Pos(uppercase(FMRoutingLocation.Text), uppercase(FMRoutingLocation.Items[x])) = 1 then begin
      FMRoutingLocation.ItemIndex := x;
    end;
  if FMRoutingLocation.ItemIndex = -1 then begin
    ShowMessageCAPRI('The Routing Location response is not valid.');
    FMRoutingLocation.Text := '';
    FMRoutingLocation.SetFocus;
    exit;
  end;
  FMRoutingLocationFake.Text := '`' + Piece(FMRoutingLocation.Items[FMRoutingLocation.ItemIndex], '^', 2);
end;

procedure TfrmViewExam.edExamReferenceNumberChange(Sender: TObject);
begin
  Scrollbox1.VertScrollbar.Position := 0;
  SaveFlag := False;                                                            // Set flags to false
  CommentsFlag := False;
  if (FMRequestStatus.Text <> 'NEW') and (FMRequestStatus.Text <> 'PENDING, REPORTED') then
    if not IsPatchInstalled('DVBA*2.7*189') then
    begin
      if FMPriorityOfExam.Text = 'INSUFFICIENT EXAM' then
        FMPriorityOfExam.Enabled := False
      else
        FMPriorityOfExam.Enabled := True;
    end;
  // Added new release status for enabling Insufficient exam button - CodeCR669 JRL 12/15/14
  if (Copy(FMRequestStatus.Text + '          ', 1, 9) = 'COMPLETED') OR         //COMPLETED, PRINTED BY RO
    (Copy(FMRequestStatus.Text + '          ', 1, 14) = 'RELEASED TO RO') then  //RELEASED TO RO, NOT PRINTED
  begin
    btnInsufficientExam.Enabled := True;
    if not IsPatchInstalled('DVBA*2.7*189') then                                // CodeCR666 JRL 2/3/15 -- Added test for backward compatibility
      FMPriorityOfExam.Enabled := False;                                        // This must be here to keep the box off appropriately.
  end
  else
    btnInsufficientExam.Enabled := False;

  if IsPatchInstalled('DVBA*2.7*189') then                                      // CodeCR666/667 JRL 2/5/15 - Added test for backward compatibility
  begin
    // Replaced Priority of Exam with Claim Type and Special Considerations, CodeCR666/CodeCR667 JRL 11/12/14
    if (FMRequestStatus.Text <> 'NEW') and (FMRequestStatus.Text <> 'PENDING, REPORTED') then // CodeCR666/667 JRL 11/12/14
      if Uppercase(FMInsufficientExam.Text) = 'YES' then                        // CodeCR666/667 JRL 11/12/14
      begin                                                                     // CodeCR666/667 JRL 11/12/14
        cbClaimType.Enabled := FALSE;                                           // CodeCR666 JRL 1/29/15
        chklstSpecialConsiderations.Enabled := FALSE;                           // CodeCR666/667 JRL 11/12/14
      end                                                                       // CodeCR666/667 JRL 11/12/14
      else                                                                      // CodeCR666/667 JRL 11/12/14
      begin                                                                     // CodeCR666/667 JRL 11/12/14
        cbClaimType.Enabled := TRUE;                                            // CodeCR666 JRL 1/29/15
        chklstSpecialConsiderations.Enabled := TRUE;                            // CodeCR666/667 JRL 11/12/14
      end;                                                                      // CodeCR666/667 JRL 11/12/14
    // Added new release status for enabling Insufficient exam button - CodeCR669 JRL 12/15/14
    if (Copy(FMRequestStatus.Text + '          ', 1, 9) = 'COMPLETED') OR       //COMPLETED, PRINTED BY RO
      (Copy(FMRequestStatus.Text + '          ', 1, 14) = 'RELEASED TO RO') then //RELEASED TO RO, NOT PRINTED
    begin                                                                       // CodeCR666/667 JRL 11/12/14
      btnInsufficientExam.Enabled := True;                                      // CodeCR666/667 JRL 11/12/14
      cbClaimType.Enabled := FALSE;                                             // CodeCR666 JRL 1/29/15
      chklstSpecialConsiderations.Enabled := FALSE;                             // CodeCR666/667 JRL 11/12/14
    end                                                                         // CodeCR666/667 JRL 11/12/14
    else                                                                        // CodeCR666/667 JRL 11/12/14
      btnInsufficientExam.Enabled := False;                                     // CodeCR666/667 JRL 11/12/14
  end;
end;

procedure TfrmViewExam.FMPatientNameIENChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMClaimFolderRequiredChange(Sender: TObject);
begin
  SaveFlag := True;
end;

//------------------------------------------------------------------------------
// CodeCR704 JRL 4/17/15 -- Added routine
//------------------------------------------------------------------------------

procedure TfrmViewExam.FMElectronicClaimFolderChange(Sender: TObject);
begin
  If IsPatchInstalled('DVBA*2.7*190') then
    SaveFlag := True;
end;

procedure TfrmViewExam.FMOtherDocumentsRequiredChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMPriorityOfExamChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMRequestDateChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMRegionalOfficeNumberChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMRequestedByChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMRoutingLocationChange(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMCommentsMemoChange(Sender: TObject);
begin
  SaveFlag := True;
  CommentsFlag := True;
end;

procedure TfrmViewExam.FMOtherDisabilities1Change(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMOtherDisabilities2Change(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.FMOtherDisabilities3Change(Sender: TObject);
begin
  SaveFlag := True;
end;

procedure TfrmViewExam.lstExamsRequestedClick(Sender: TObject);
begin
  if lstExamsRequested.ItemIndex > -1 then begin
    btnViewSelectedExam.Enabled := True;
  end;
end;

procedure TfrmViewExam.btnViewSelectedExamClick(Sender: TObject);
var
  x: integer;
  z: string;
  addexam: boolean;
  flag: boolean;
begin
  frmExamDetails := TfrmExamDetails.Create(frmMain);
  try
    if ReadOnlyMode = True then
      frmExamDetails.btnCancelExam.Enabled := False;
    EditWhich := lstExamsRequested.ItemIndex;                                   // Store which exam being edited;
    btnClose.Enabled := False;                                                  // rpk 11/17/2014
    addexam := btnAddExam.Enabled;
    btnAddExam.Enabled := False;
    btnViewSelectedExam.Enabled := False;
    if lstExamsRequested.ItemIndex = -1 then
      exit;
    for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do
      if Pos('^' + lstExamsRequested.Items[lstExamsRequested.ItemIndex], lstExamsRequestedHidden.Items[x]) > 0 then
        z := Copy(lstExamsRequestedHidden.Items[x], 1, Pos('^', lstExamsRequestedHidden.Items[x]) - 1);
    if z = '' then
      exit;
    frmExamDetails.edExamReferenceNumber.Text := z;                             //Exam IEN
    frmExamDetails.fmGetsExamDetails.IENS := z;
    frmExamDetails.fmGetsExamDetails.GetAndFill;


  //  CodeCR319 - rpm 6/25/12 - increasing the max size of the report text
  //  field in C&P Exam Request Report Management form caused <STORE> errors
  //  when retrieving data from field #71 using the GetAndFill method to
  //  populate a hidden TFMMemo component named FMExamDetailsCommentsMemo.
  //  FMExamDetailsCommentsMemo has been removed from the list of components
  //  populated by the GetAndFill.  The Exam results are now separately
  //  retrieved by GetExamResults.
    GetExamResults(frmExamDetails.fmGetsExamDetails.IENS, frmExamDetails.FMExamDetailsCommentsMemo, frmExamDetails.RichEditExamReport);

    frmExamDetails.Height := frmMain.Height - 75;
    if frmExamDetails.Height > 873 then
      frmExamDetails.Height := 873;
//    frmExamDetails.btnClose.Top := frmExamDetails.Height - 57;
//    frmExamDetails.btnCancelExam.Top := frmExamDetails.Height - 57;
//    frmExamDetails.Scrollbox1.Height := frmExamDetails.Height - 82;
    frmExamDetails.Scrollbox1.Height := frmExamDetails.Panel1.Height - frmExamDetails.btnClose.Height; // rpk 1/15/2015

    frmExamDetails.Top := 7 + frmMain.Top + ((frmMain.Height - frmExamDetails.Height) div 2);
    frmExamDetails.Left := frmMain.Left + ((frmMain.Width - frmExamDetails.Width) div 2);
    frmExamDetails.Scrollbox1.VertScrollBar.Position := 0;
    frmExamDetails.RichEditExamReport.Visible := True;
    // Don't let unreleased reports be viewed
//    if Uppercase(FMEdit6.Text) = '' then begin
    if Uppercase(FMEditDateReleased.Text) = '' then begin                       // rpk 4/20/2015
      frmExamDetails.RichEditExamReport.Visible := False;
    end;

    frmExamDetails.ShowModal;
    // Find Exams - Reload in case status has been changed to cancelled
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
    frmMain.RPCBroker1.Param[0].Value := CurrentRecordIEN;
    frmMain.RPCBroker1.Param[0].PType := literal;
    frmMain.RPCBrokerCall;
    try
      frmMain.RPCBroker1.Call;
    except
      on EBrokerError do
        ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
    end;
    frmViewExam.lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
    frmViewExam.lstExamsRequested.Clear;

    if frmViewExam.lstExamsRequestedHidden.Items.Count > 0 then
      for x := 0 to frmViewExam.lstExamsRequestedHidden.Items.Count - 1 do
        frmViewExam.lstExamsRequested.Items.Add(Copy(frmViewExam.lstExamsRequestedHidden.Items[x],
          Pos('^', frmViewExam.lstExamsRequestedHidden.Items[x]) + 1, 254));
    //
    frmViewExam.btnViewSelectedExam.Enabled := False;                           // Reset this button on reload
    btnClose.Enabled := True;                                                   // rpk 11/17/2014
    btnAddExam.Enabled := AddExam;
  finally
//  frmExamDetails.Release;
//  frmExamDetails := nil;
    FreeAndNil(frmExamDetails);                                                 // rpk 11/12/2014
  end;

  btnCancelAllExams.Enabled := False;
  if lstExamsRequested.Items.Count > 0 then begin
    flag := true;
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if Pos('[OPEN]', lstExamsRequested.Items[x]) = 0 then
        flag := false;
    if flag = true then
      btnCancelAllExams.Enabled := True;
  end;
end;                                                                            // btnViewSelectedExamClick

procedure TfrmViewExam.btnInsufficientExamClick(Sender: TObject);
var
  x, y: integer;
  IFlag: Boolean;
  tempExam: string;
begin
  IFlag := False;
  if lstExamsRequested.Items.Count > 0 then begin
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if Length(lstExamsRequested.Items[x]) > Pos(']  ', lstExamsRequested.Items[x]) + 3 then
        IFlag := True;
    if IFLag = False then begin
      ShowMessageCAPRI('You must mark at least one exam insufficient to perform this action.');
      exit;
    end;
  end;

  InsufficientExam := True;
  AddRequestIEN := '+1';
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB CHECK CREDENTIALS';
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC DVBAB CHECK CREDENTIALS could not be accessed!');
  end;
  if frmMain.RPCBroker1.Results[0] <> '[OK]' then begin
    ShowMessageCAPRI(frmMain.RPCBroker1.Results[0]);
    application.terminate;
    Exit;
  end;
  frmMain.btnAddRequest.Enabled := False;
  frmMain.btnViewExam.Enabled := False;
  // If credentials are ok, then continue
  // Populate lists and controls
  frmNewExam := TfrmNewExam.Create(frmMain);
  if IsPatchInstalled('DVBA*2.7*189') then
  begin
    frmNewExam.Caption := FORM_TITLE_INSUFFICIENT_EXAM;                         //CodeCR669 JRL 10/7/14
    frmNewExam.FMInsufficientExam.ItemIndex := 1;                               // 0 = No, 1 = Yes    //CodeCR669 JRL 10/7/14
    frmNewExam.FMInsufficientExam.Enabled := FALSE;                             //CodeCR669 JRL 10/7/14
  end;
  frmMain.FMListerExams.GetList(frmNewExam.FMExamsList.Items);
  frmNewExam.FMExamsList.GetList;
  frmNewExam.CheckBoxExamsToComplete.Items.Clear;
  if frmNewExam.FMExamsList.Items.Count > 0 then
    for x := 0 to frmNewExam.FMExamsList.Items.Count - 1 do
      if Pos('  I', frmNewExam.FMExamsList.Items[x]) = 0 then
        frmNewExam.CheckBoxExamsToComplete.Items.Add(Copy(frmNewExam.FMExamsList.Items[x], 1, Pos('  A', frmNewExam.FMExamsList.Items[x]) - 3));
  frmMain.FMListerMedicalCenterDivision.GetList(frmNewExam.FMRoutingLocation.Items);
  frmNewExam.FMRoutingLocation.Items := listMedicalCenterDivision;
  //frmMain.FMListerInstitutionFile.GetList(frmNewExam.FMRegionalOfficeNumber.Items);
  frmNewExam.FMRegionalOfficeNumber.Items.Clear;
  if frmMain.lstInstitutions.Items.Count > 0 then
    for x := 0 to frmMain.lstInstitutions.Items.Count - 1 do
      frmNewExam.FMRegionalOfficeNumber.Items.Add(Copy(frmMain.lstInstitutions.Items[x], 1, Pos('^', frmMain.lstInstitutions.Items[x]) - 1));
  frmNewExam.FMPatientName.Text := Copy(frmMain.Panel1.caption, 1, Pos('  SSN#', frmMain.Panel1.Caption));
  frmNewExam.FMPatientNameIEN.Text := '`' + PatientIEN;
  frmNewExam.FMRequestDate.Text := 'NOW';
  frmNewExam.FMRequestedBy.Text := frmMain.FMUserName.Caption;
  frmNewExam.FMRequestedByIEN.Text := '`' + AuthorIEN;
  frmNewExam.FMRequestStatus.Text := 'N';
  frmNewExam.FMClaimFolderRequired.Text := '';
  frmNewExam.FMElectronicClaimFolder.Text := '';                                // CodeCR704 JRL 4/17/15
  frmNewExam.FMOtherDocumentsRequired.Text := '';
  frmNewExam.FMRegionalOfficeNumberIEN.Text := FMRegionalOfficeNumberIEN.Text;
  frmNewExam.FMRegionalOfficeNumber.Text := FMRegionalOfficeNumber.Text;
  frmNewExam.FMRegionalOfficeNumber.Enabled := False;
  if not IsPatchInstalled('DVBA*2.7*189') then                                  // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
    frmNewExam.FMPriorityOfExam.Text := '';
  frmNewExam.FMOtherDisabilities1.Text := '';
  frmNewExam.FMOtherDisabilities2.Text := '';
  frmNewExam.FMOtherDisabilities3.Text := '';
  frmNewExam.FMRoutingLocation.Text := '';
  frmNewExam.FMLastRatingExamDate.Text := '';
  frmNewExam.FMCommentsMemo.Lines.Clear;
  frmNewExam.FMOriginal2507Request.Text := '`' + EdExamReferenceNumber.text;
//  frmNewExam.FMOriginal2507ProcessingTime.Text := FMEdit10.Text;
  frmNewExam.FMOriginal2507ProcessingTime.Text := FMEditElapsedTime.Text;       // rpk 4/20/2015
  if IsPatchInstalled('DVBA*2.7*189') then                                      // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
  begin
    LoadClaimTypeControlValues;                                                 // CodeCR666 JRL 11/12/14
    LoadSpecialConsiderationControlValues;                                      // CodeCR667 JRL 11/12/14
  end
  else                                                                          // DVBA*2.7*187
  begin
    frmNewExam.FMPriorityOfExam.Enabled := False;                               // Don't less user change the status
    frmNewExam.FMPriorityOfExam.Text := 'INSUFFICIENT EXAM';
    frmNewExam.FMPriorityOfExamExit(Application);
  end;
  //Setup for new entry
  frmNewExam.FMPatientNameIEN.IENS := '+1';
  frmNewExam.FMRequestDate.IENS := '+1';
  frmNewExam.FMClaimFolderRequiredFake.IENS := '+1';
  if IsPatchInstalled('DVBA*2.7*189') then
    frmNewExam.FMInsufficientExamFake.IENS := '+1';                             // CodeCR669 JRL 11/19/14
  frmNewExam.FMOtherDocumentsRequiredFake.IENS := '+1';
  frmNewExam.FMRegionalOfficeNumberIEN.IENS := '+1';
  frmNewExam.FMRequestedByIEN.IENS := '+1';
  frmNewExam.FMRequestStatus.IENS := '+1';
  if not IsPatchInstalled('DVBA*2.7*189') then                                  // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
    frmNewExam.FMPriorityOfExamFake.IENS := '+1';
  frmNewExam.FMOtherDisabilities1.IENS := '+1';
  frmNewExam.FMOtherDisabilities2.IENS := '+1';
  frmNewExam.FMOtherDisabilities3.IENS := '+1';
  frmNewExam.FMRoutingLocationFake.IENS := '+1';
  frmNewExam.FMLastRatingExamDate.IENS := '+1';
  frmNewExam.FMCommentsMemo.IENS := '+1';
  frmNewExam.FMOriginal2507Request.IENS := '+1';
  frmNewExam.FMOriginal2507ProcessingTime.IENS := '+1';
  //Enter Request
  frmNewExam.Height := frmMain.Height - 75;
  if frmNewExam.Height > 698 then
    frmNewExam.Height := 698;
  frmNewExam.Top := 7 + frmMain.Top + ((frmMain.Height - frmNewExam.Height) div 2);
  frmNewExam.Left := frmMain.Left + ((frmMain.Width - frmNewExam.Width) div 2);
  frmNewExam.btnSendRequest.Top := frmNewExam.Height - 73;
  frmNewExam.btnCancel.Top := frmNewExam.Height - 73;
  frmNewExam.Scrollbox1.Height := frmNewExam.Height - 74;
  frmNewExam.ListBoxInsufficientExams.Items.Clear;
  //Enter request
  //frmNewExam.Top:=frmMain.Top + ((frmMain.Height-frmNewExam.Height) div 2);
  //frmNewExam.Left:=frmMain.Left + ((frmMain.Width-frmNewExam.Width) div 2);
  frmNewExam.CheckBoxExamsToComplete.Items.Clear;
  if frmNewExam.FMExamsList.Items.Count > 0 then
    for x := 0 to frmViewExam.FMExamsList.Items.Count - 1 do
      if Pos('  I', frmViewExam.FMExamsList.Items[x]) = 0 then
        frmNewExam.CheckBoxExamsToComplete.Items.Add(Copy(frmViewExam.FMExamsList.Items[x], 1, Pos('  A', frmViewExam.FMExamsList.Items[x]) - 3));
  if lstExamsRequested.Items.Count > 0 then
    for x := 0 to lstExamsRequested.Items.Count - 1 do begin
      TempExam := Copy(lstExamsRequested.Items[x], 1, pos(' [C', lstExamsRequested.Items[x]) - 1);
      for y := frmNewExam.CheckBoxExamsToComplete.Items.Count - 1 downto 0 do
        if frmNewExam.CheckBoxExamsToComplete.Items[y] = TempExam then
          frmNewExam.CheckBoxExamsToComplete.Checked[y] := true;
    end;
  for y := frmNewExam.CheckBoxExamsToComplete.Items.Count - 1 downto 0 do
    if frmNewExam.CheckBoxExamsToComplete.Checked[y] = True then begin
      frmNewExam.CheckBoxExamsToComplete.Checked[y] := False;
      frmNewExam.ListBoxInsufficientExams.Items.Add(frmNewExam.CheckBoxExamsToComplete.Items[y]);
    end
    else begin
      frmNewExam.CheckBoxExamsToComplete.Items.Delete(y);
    end;
  frmNewExam.CheckboxExamsToComplete.Items.Clear;

  frmNewExam.Scrollbox1.VertScrollBar.Position := 0;
  if frmNewExam.FMRegionalOfficeNumberIEN.Text <> '' then
    frmNewExam.FMRoutingLocation.Enabled := True;

  frmNewExam.FMListerCustomExamListDivisionsListBox.GetList;
  //Check for inactive divisions
  if frmNewExam.FMListerCustomExamListDivisionsListBox.Items.Count > 0 then
    for x := 0 to frmNewExam.FMListerCustomExamListDivisionsListBox.Items.Count - 1 do begin
      frmNewExam.FMListerCustomExamListDivisionsListBox.ItemIndex := x;
      frmNewExam.CustomExamListDivisions.IENS := frmNewExam.FMListerCustomExamListDivisionsListBox.GetSelectedRecord.IEN;
      frmNewExam.CustomExamListDivisions.GetAndFill;
      //Inactivate if "YES"
      if frmNewExam.FMEditInactivateDivision.Text = 'YES' then begin
        if frmNewExam.FMRoutingLocation.Items.Count > 0 then
          for y := frmNewExam.FMRoutingLocation.Items.Count - 1 downto 0 do begin
            frmNewExam.FMRoutingLocation.ItemIndex := y;
            if Piece(frmNewExam.FMRoutingLocation.Items[y], '^', 2) = frmNewExam.FMListerCustomExamListDivisionsListBox.Items[x] then begin
              frmNewExam.FMRoutingLocation.Items.Delete(y);
            end;
          end;
      end;
    end;
  frmNewExam.FMRoutingLocation.ItemIndex := -1;

  FrmNewExam.ShowModal;
  frmNewExam.Release;
  frmNewExam := nil;
  frmMain.ExamRequestRefreshClick(Application);
  frmMain.btnAddRequest.Enabled := True;
  if frmMain.FMExamRequestListbox.ItemIndex > -1 then
    frmMain.btnViewExam.Enabled := True;
  InsufficientExam := False;                                                    // Reset Flag
  lstExamsRequested.ItemIndex := -1;                                            // Reset List
end;

procedure TfrmViewExam.FormActivate(Sender: TObject);
var
  x: integer;
  flag: boolean;
begin
  if uppercase(FMClaimFolderRequiredFake.Text) = 'YES' then
    ClaimFolderRequired := True
  else
    ClaimFolderRequired := False;
  if IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR704 JRL 4/17/15
  begin                                                                         // CodeCR704 JRL 4/17/15
    if uppercase(FMElectronicClaimFolderFake.Text) = 'YES' then                 // CodeCR704 JRL 4/17/15
      ElectronicClaimFolderAvailable := True                                    // CodeCR704 JRL 4/17/15
    else                                                                        // CodeCR704 JRL 4/17/15
      ElectronicClaimFolderAvailable := False;                                  // CodeCR704 JRL 4/17/15
  end;                                                                          // CodeCR704 JRL 4/17/15
  if IsPatchInstalled('DVBA*2.7*189') then
  begin
    if uppercase(FMInsufficientExamFake.Text) = 'YES' then                      // CodeCR669 JRL 11/19/14
      FMInsufficientExam.ItemIndex := 1                                         // YES                                 // CodeCR669 JRL 11/19/14
    else                                                                        // CodeCR669 JRL 11/19/14
      FMInsufficientExam.ItemIndex := 0;                                        // NO                                  // CodeCR669 JRL 11/19/14
  end;
  CurrentRecordIEN := frmMain.FMExamRequestListbox.GetSelectedRecord.IEN;
  if FMRegionalOfficeNumber.Text = '' then
    FMRegionalOfficeNumber.enabled := True;
  btnCancelAllExams.Enabled := False;
  if lstExamsRequested.Items.Count > 0 then begin
    flag := true;
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if Pos('[OPEN]', lstExamsRequested.Items[x]) = 0 then
        flag := false;
    if flag = true then
      btnCancelAllExams.Enabled := True;
  end;
  // Force update of screen controls
  FMRequestStatusChange(Application);
  if ReadOnlyMode = True then
    btnCancelAllExams.Enabled := False;
  if ReadOnlyMode = True then
    btnInsufficientExam.Enabled := False;
  if IsPatchInstalled('DVBA*2.7*189') then
  begin
    GetClaimType(CurrentRecordIEN);                                             // CodeCR666 JRL 11/12/14
    SaveClaimType := FALSE;                                                     // CodeCR666 JRL 11/20/14
    GetSpecialConsidations(CurrentRecordIEN);                                   // CodeCR667 JRL 11/12/14
    SaveSpecialConsiderations := FALSE;                                         // CodeCR667 JRL 11/20/14
  end;
end;

procedure TfrmViewExam.FormCreate(Sender: TObject);
begin
  AddExamPanel.SendToBack;
  FakeDate := Now + 1;

  if IsPatchInstalled('DVBA*2.7*190') then                                      // CodeCR704 JRL 4/17/15
  begin                                                                         // CodeCR704 JRL 4/17/15
     // show                                                                    // CodeCR704 JRL 4/17/15
    lblElectronicClaimFolder.Visible := TRUE;                                   // CodeCR704 JRL 4/17/15
    FMElectronicClaimFolder.Visible := TRUE;                                    // CodeCR704 JRL 4/17/15
  end                                                                           // CodeCR704 JRL 4/17/15
  else                                                                          // CodeCR704 JRL 4/17/15
  begin                                                                         // CodeCR704 JRL 4/17/15
     // hide                                                                    // CodeCR704 JRL 4/17/15
    lblElectronicClaimFolder.Visible := FALSE;                                  // CodeCR704 JRL 4/17/15
    FMElectronicClaimFolder.Visible := FALSE;                                   // CodeCR704 JRL 4/17/15
  end;                                                                          // CodeCR704 JRL 4/17/15
  if IsPatchInstalled('DVBA*2.7*189') then
  begin
     // show
    lblClaimType.Visible := TRUE;
    cbClaimType.Visible := TRUE;
    lblSpecialConsiderations.Visible := TRUE;
    chklstSpecialConsiderations.Visible := TRUE;
    lblInsufficient.Visible := TRUE;
    FMInsufficientExam.Visible := TRUE;
     // hide
    lblPriorityOfExam.Visible := FALSE;
    FMPriorityOfExam.Visible := FALSE;
     // populate
    LoadClaimTypeControlValues;                                                 // RPC to load values for Claim Type             // CodeCR666 JRL 11/5/14
    LoadSpecialConsiderationControlValues;                                      // RPC to load values for Special Considerations // CodeCR667 JRL 11/5/14
  end
  else                                                                          // DVBA*2.7*187
  begin
     // show
    lblPriorityOfExam.Visible := TRUE;
    FMPriorityOfExam.Visible := TRUE;
     // hide
    lblClaimType.Visible := FALSE;
    cbClaimType.Visible := FALSE;
    lblSpecialConsiderations.Visible := FALSE;
    chklstSpecialConsiderations.Visible := FALSE;
    lblInsufficient.Visible := FALSE;
    FMInsufficientExam.Visible := FALSE;
     // populate
    TfrmNewExam.GetPriorityOfExamItemList(Self.FMPriorityOfExam)                //CodeCR123 - rpm 11/1/10
  end;
  ViewExamCancelComments := TStringList.Create;                                 // CodeCR670 rpk 11/14/2014
end;

procedure TfrmViewExam.FormDestroy(Sender: TObject);
begin
  FreeAndNil(ViewExamCancelComments);                                           // CodeCR670 rpk 11/14/2014
end;

procedure TfrmViewExam.FormMouseWheel(Sender: TObject; Shift: TShiftState;      // rpk 3/5/2015
  WheelDelta: Integer; MousePos: TPoint; var Handled: Boolean);
var
  tbool: Boolean;
  wc: TWinControl;
begin
  wc := ScrollBox1;
  if wc <> nil then begin
    tbool := ScrollBox(wc, MousePos, WheelDelta);
    Handled := tbool;
  end;
end;

procedure TfrmViewExam.ButtonViewBySystemClick(Sender: TObject);
begin
  if ButtonViewBySystem.Caption = 'Find by Body System' then begin
    TreeViewExams.Selected := nil;
    TreeViewExams.Visible := True;
    CheckBoxExamsToComplete.Visible := False;
    ButtonViewBySystem.Caption := 'View Selected Exams';
  end
  else begin
    TreeViewExams.Selected := nil;
    CheckBoxExamsToComplete.Visible := True;
    TreeViewExams.Visible := False;
    ButtonViewBySystem.Caption := 'Find by Body System';
  end;
end;


procedure TfrmViewExam.dtpLastRatingExamDateChange(Sender: TObject);            // -MER CodeCR116 8/2010
begin
  SaveFlag := True;
  if (Trunc(dtpLastRatingExamDate.Date) = Trunc(FakeDate)) then begin
    dtpLastRatingExamDate.Format := 'N/A';
    FMLastRatingExamDate.OnChange := nil;                                       // prevent event handler loop
    FMLastRatingExamDate.Text := '@';                                           // delete any saved value
    FMLastRatingExamDate.OnChange := FMLastRatingExamDateChange;
  end else begin
    dtpLastRatingExamDate.Format := 'MMM dd, yyyy';
    FMLastRatingExamDate.OnChange := nil;                                       // prevent event handler loop
    FMLastRatingExamDate.Text := FormatDateTime('MMM dd, yyyy', dtpLastRatingExamDate.Date);
    FMLastRatingExamDate.OnChange := FMLastRatingExamDateChange;
  end;
end;

// -MER 12/2010 This event handler allows a user to clear a selected date from
// the last rating exam date control

procedure TfrmViewExam.dtpLastRatingExamDateKeyDown(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  if (Key = VK_DELETE) then begin
    // confirm and clear
    if (MessageBox(Handle, 'Do you wish to clear the last exam date?',
      'Confirmation', mb_YesNo or mb_IconExclamation) = id_Yes)
      then begin
      SaveFlag := True;
      dtpLastRatingExamDate.Date := FakeDate;
      dtpLastRatingExamDate.Format := 'N/A';
      FMLastRatingExamDate.OnChange := nil;                                     // prevent event handler loop
      FMLastRatingExamDate.Text := '@';
      FMLastRatingExamDate.OnChange := FMLastRatingExamDateChange;
    end;
  end;
end;

procedure TfrmViewExam.TreeViewExamsDblClick(Sender: TObject);
var
  x: integer;
begin
  if TreeViewExams.Selected <> nil then begin
    for x := 0 to CheckBoxExamsToComplete.Items.Count - 1 do
      if CheckBoxExamsToComplete.Items[x] = TreeViewExams.Selected.Text then begin
        CheckBoxexamsToComplete.Itemindex := x;
        CheckBoxexamsToComplete.Checked[x] := True;
      end;
    if TreeViewExams.Selected.Parent <> nil then
      ButtonViewBySystemClick(Application);
  end;
end;

procedure TfrmViewExam.FMRegionalOfficeNumberEnter(Sender: TObject);
begin
  if frmROFinder.ShowModal = mrOK then
    if frmROFinder.ORListBoxSites.ItemIndex > -1 then begin
      FMRegionalOfficeNumber.Text := frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 1);
      FMRegionalOfficeNumberIEN.Text := '`' + frmMain.Piece(frmROFinder.ORListBoxSites.Items[frmROFinder.ORListBoxSites.ItemIndex], '^', 2);
    end;
  try
//    if btnCancel.CanFocus then  // rpk 11/10/2014
//      btnCancel.SetFocus
    if btnClose.CanFocus then                                                   // rpk 11/17/2014
      btnClose.SetFocus                                                         // rpk 11/17/2014
  except
  end;
  exit;

end;

procedure TfrmViewExam.btnCancelAllExamsClick(Sender: TObject);
var
  x: integer;
  z: string;
  addexam: boolean;
  whichexam: integer;
  flag: boolean;
begin
  btnCancelAllExams.Enabled := False;
  if lstExamsRequested.Items.Count > 0 then begin
    flag := true;
    for x := 0 to lstExamsRequested.Items.Count - 1 do
      if Pos('[OPEN]', lstExamsRequested.Items[x]) = 0 then
        flag := false;
    if flag = true then
      btnCancelAllExams.Enabled := True;
  end;
  if btnCancelAllExams.Enabled = False then begin
    //CodeCR71 - correct verbiage
    ShowMessageCAPRI('Cannot cancel all exams, because all exams do not have an [OPEN] status.');
    exit;
  end;

  // Double-check cancel all and exit if user clicks anything other than YES.
  if Application.MessageBox('Are you sure you want to cancel all the exams?', 'Cancel all exams', 4) <> 6 then
    exit;
  cancellationReason := '-1';
  ViewExamCancelComments.Clear;                                                 // rpk 11/14/2014

  for whichexam := 0 to lstExamsRequested.Items.Count - 1 do begin
    lstExamsRequested.ItemIndex := whichexam;

    frmExamDetails := TfrmExamDetails.Create(frmMain);
    try
      EditWhich := lstExamsRequested.ItemIndex;                                 // Store which exam being edited;
      btnClose.Enabled := False;                                                // rpk 11/17/2014
      addexam := btnAddExam.Enabled;
      btnAddExam.Enabled := False;
      btnViewSelectedExam.Enabled := False;
      if lstExamsRequested.ItemIndex = -1 then
        exit;
      for x := 0 to lstExamsRequestedHidden.Items.Count - 1 do
        if Pos('^' + lstExamsRequested.Items[lstExamsRequested.ItemIndex], lstExamsRequestedHidden.Items[x]) > 0 then
          z := Copy(lstExamsRequestedHidden.Items[x], 1, Pos('^', lstExamsRequestedHidden.Items[x]) - 1);
      if z = '' then
        exit;
      frmExamDetails.edExamReferenceNumber.Text := z;                           //Exam IEN
      frmExamDetails.fmGetsExamDetails.IENS := z;
      frmExamDetails.fmGetsExamDetails.GetAndFill;
      frmExamDetails.Height := frmMain.Height - 75;
      if frmExamDetails.Height > 873 then
        frmExamDetails.Height := 873;
//      frmExamDetails.btnClose.Top := frmExamDetails.Height - 73;
//      frmExamDetails.btnCancelExam.Top := frmExamDetails.Height - 73;
//      frmExamDetails.Scrollbox1.Height := frmExamDetails.Height - 74;
      frmExamDetails.Scrollbox1.Height := frmExamDetails.Panel1.Height - frmExamDetails.btnClose.Height; // rpk 1/15/2015

      frmExamDetails.Top := 7 + frmMain.Top + ((frmMain.Height - frmExamDetails.Height) div 2);
      frmExamDetails.Left := frmMain.Left + ((frmMain.Width - frmExamDetails.Width) div 2);
      frmExamDetails.Scrollbox1.VertScrollBar.Position := 0;
      frmExamDetails.RichEditExamReport.Visible := True;
      // Don't let unreleased reports be viewed
//      if Uppercase(FMEdit6.Text) = '' then begin
      if Uppercase(FMEditDateReleased.Text) = '' then begin                     // rpk 4/20/2015
        frmExamDetails.RichEditExamReport.Visible := False;
      end;

      frmExamDetails.ShowModal;
      // Find Exams - Reload in case status has been changed to cancelled
      frmMain.RPCBroker1.Results.Clear;
      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FIND EXAMS';
      frmMain.RPCBroker1.Param[0].Value := CurrentRecordIEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBrokerCall;
      try
        frmMain.RPCBroker1.Call;
      except
        on EBrokerError do
          ShowMessageCAPRI('RPC DVBAB FIND EXAMS could not be accessed!');
      end;
      frmViewExam.lstExamsRequestedHidden.Items := frmMain.RPCBroker1.Results;
      frmViewExam.lstExamsRequested.Clear;

      if frmViewExam.lstExamsRequestedHidden.Items.Count > 0 then
        for x := 0 to frmViewExam.lstExamsRequestedHidden.Items.Count - 1 do
          frmViewExam.lstExamsRequested.Items.Add(Copy(frmViewExam.lstExamsRequestedHidden.Items[x],
            Pos('^', frmViewExam.lstExamsRequestedHidden.Items[x]) + 1, 254));
      //
      frmViewExam.btnViewSelectedExam.Enabled := False;                         // Reset this button on reload
      btnClose.Enabled := True;                                                 // rpk 11/17/2014
      btnAddExam.Enabled := AddExam;
  //    frmExamDetails.Release;
  //    frmExamDetails := nil;
    finally
      FreeAndNil(frmExamDetails);                                               // rpk 11/7/2014
    end;
    if CancellationReason = '-1' then begin
      //exam cancellation was cancelled;
      CancellationReason := '';
      ViewExamCancelComments.Clear;                                             // rpk 11/17/2014
      Exit;
    end;
  end;
  CancellationReason := '';
  btnCloseClick(Application);                                                   // rpk 11/17/2014
end;

procedure TfrmViewExam.FMCommentsMemoEnter(Sender: TObject);
begin
  FEditCtrl := FMCommentsMemo;
  FMCommentsMemo.selStart := 0;                                                 // -MER CodeCR116 8/2010
end;


procedure TfrmViewExam.lstExamsRequestedKeyUp(Sender: TObject;
  var Key: Word; Shift: TShiftState);
begin
  lstExamsRequested.Repaint;
end;

//CCAPRI_CodeCR96 - jcs - 03/16/10

procedure TfrmViewExam.WMMenuChar(var Message: TWMMenuChar);
begin
  If Not ActivateMenu(self, Message) then
    Inherited;
end;

{==============================================================================
  Set508ControlOptions
    Set508ControlOptions is a method that will set UI controls to be compatible
      with screen readers if a screen reader is active.  If a screen reader is
      not active, the 508 text components are hidden

  Modification History:
    CodeCR116 - 8/2010 Method created -MER
    CodeCR666 - 2/5/15 JRL Added new controls
 ==============================================================================}

procedure TfrmViewExam.Set508ControlOptions;
var
  buffer: string;                                                               // CodeCR666 JRL 11/12/14
  i: Integer;                                                                   // CodeCR666 JRL 11/12/14
begin
  if (UpdateEditBoxesForScreenReader(self)) then begin
    // A screen reader is active
    // Set up the static text accessibility controls for disabled combo boxes
    if not (FMRegionalOfficeNumber.Enabled) then begin
      st508RegionalOfficeNumber.Caption := 'Regional Office: Read Only.  Value is ' + FMRegionalOfficeNumber.Text;
      st508RegionalOfficeNumber.Visible := TRUE;
    end else begin
      st508RegionalOfficeNumber.Visible := FALSE;
    end;
    if not (FMClaimFolderRequired.Enabled) then begin
      st508ClaimFolder.Caption := 'Claim Folder Required?  Read Only.  Value is ' + FMClaimFolderRequired.Text;
      st508ClaimFolder.Visible := TRUE;
    end else begin
      st508ClaimFolder.Visible := FALSE;
    end;
    if IsPatchInstalled('DVBA*2.7*190') then                                    // CodeCR704 JRL 4/17/15
    begin                                                                       // CodeCR704 JRL 4/17/15
      if not (FMElectronicClaimFolder.Enabled) then                             // CodeCR704 JRL 4/17/15
      begin                                                                     // CodeCR704 JRL 4/17/15
        st508ElectronicClaimFolder.Caption := 'Electronic Claim Folder Available?  Read Only.  Value is ' + FMElectronicClaimFolder.Text; // CodeCR704 JRL 4/17/15
        st508ElectronicClaimFolder.Visible := TRUE;                             // CodeCR704 JRL 4/17/15
      end                                                                       // CodeCR704 JRL 4/17/15
      else                                                                      // CodeCR704 JRL 4/17/15
      begin                                                                     // CodeCR704 JRL 4/17/15
        st508ElectronicClaimFolder.Visible := FALSE;                            // CodeCR704 JRL 4/17/15
      end;                                                                      // CodeCR704 JRL 4/17/15
    end;                                                                        // CodeCR704 JRL 4/17/15

    if IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
    begin
      if not (FMInsufficientExam.Enabled) then                                  // CodeCR669 JRL 11/20/14
      begin                                                                     // CodeCR669 JRL 11/20/14
        st508InsufficientExam.Caption := 'Insufficient Exam: Read Only. Value is ' + FMInsufficientExam.Text;
        st508InsufficientExam.Visible := TRUE;                                  // CodeCR669 JRL 11/20/14
      end                                                                       // CodeCR669 JRL 11/20/14
      else                                                                      // CodeCR669 JRL 11/20/14
        st508InsufficientExam.Visible := FALSE;                                 // CodeCR669 JRL 11/20/14
    end
    else                                                                        // DVBA*2.7*187
    begin
      if not (FMPriorityOfExam.Enabled) then
      begin
        st508EPriorityOfExams.Caption := 'Priority of exams:  Read Only.  Value is ' + FMPriorityOfExam.Text;
        st508EPriorityOfExams.Visible := TRUE;
      end
      else
      begin
        st508EPriorityOfExams.Visible := FALSE;
      end;
    end;
    if IsPatchInstalled('DVBA*2.7*189') then                                    // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
    begin
      if not (cbClaimType.Enabled) then                                         // Added Claim Type 508 Code
      begin                                                                     // CodeCR666 JRL 1/29/15
        st508ClaimType.Caption := 'Claim Type?  Read Only.  Value is ' + cbClaimType.Items[cbClaimType.ItemIndex];
        st508ClaimType.Visible := TRUE;
      end
      else
      begin
        st508ClaimType.Visible := FALSE;
      end;
      if not (chklstSpecialConsiderations.Enabled) then                         // Added Special Considerations 508 Code
      begin                                                                     // CodeCR667 JRL 11/12/14
        buffer := '';
        for i := 0 to chklstSpecialConsiderations.Count - 1 do
        begin
          if chklstSpecialConsiderations.Checked[i] then
            buffer := buffer + chklstSpecialConsiderations.Items[i] + ' ';
        end;
        st508SpecialConsiderations.Caption := 'Special Considerations?  Read Only.  Value is ' + buffer;
        st508SpecialConsiderations.Visible := TRUE;
      end
      else
      begin
        st508SpecialConsiderations.Visible := FALSE;
      end;
    end;
    if not (FMRoutingLocation.Enabled) then begin
      st508RoutingLocation.Caption := 'Routing Location:  Read Only.  Value is ' + FMRoutingLocation.Text;
      st508RoutingLocation.Visible := TRUE;
    end else begin
      st508RoutingLocation.Visible := FALSE;
    end;
    if not (dtpLastRatingExamDate.Enabled) then begin
      st508LastRatingExamDate.Caption := 'Last Rating Exam Date:  Read Only.  Value is ' + FMLastRatingExamDate.Text;
      st508LastRatingExamDate.Visible := TRUE;
    end else begin
      st508LastRatingExamDate.Visible := FALSE;
    end;
  end else begin
    // a screen reader is not active
    st508ClaimFolder.Visible := FALSE;
    st508ClaimType.Visible := FALSE;                                            // rpk 4/20/2015
    if IsPatchInstalled('DVBA*2.7*190') then                                    // CodeCR704 JRL 4/21/15
       st508ElectronicClaimFolder.Visible := FALSE;                             // rpk 4/20/2015
    if not IsPatchInstalled('DVBA*2.7*189') then                                // CodeCR666 JRL 2/5/15 - Added test for backward compatibility
      st508EPriorityOfExams.Visible := FALSE;
    st508InsufficientExam.Visible := FALSE;                                     // rpk 4/20/2015
    st508LastRatingExamDate.Visible := FALSE;
    st508RegionalOfficeNumber.Visible := FALSE;
    st508RoutingLocation.Visible := FALSE;
    st508SpecialConsiderations.Visible := FALSE;                                // rpk 4/20/2015
  end;
end;                                                                            // Set508ControlOptions

// -----------------------------------------------------------------------------
// Load Claim Type Control Values
// -----------------------------------------------------------------------------
// Claim Type replaces "Priority of Exam".  Call an RPC to update the new
//     Claim Type multiple field.
//
//   RPC:  DVBA CAPRI LISTCLAIMTYPE
//
//   INPUT PARAMETERS:
//     None
//   OUTPUT:
//     CLAIM TYPE ^ IEN OF CLAIM TYPE
//
// CodeCR666  JRL  11/7/14
// CodeCR666  JRL   2/2/15 Changed control from check listbox to combobox since
//                          requirement changed from multi-select to only one
//                          value required
// -----------------------------------------------------------------------------

procedure TfrmViewExam.LoadClaimTypeControlValues;
var
  i: Integer;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI LISTCLAIMTYPE';
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBAB CAPRI LISTCLAIMTYPE could not be accessed!');
  End;
  cbClaimType.Items.Clear;
  If frmMain.RPCBroker1.Results.Count > 0 Then
  begin
    For i := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    begin
      cbClaimType.Items.Add(Piece(frmMain.RPCBroker1.Results[i], '^', 1));
    end;
  end;
end;

// -----------------------------------------------------------------------------
// Get Claim Type
// -----------------------------------------------------------------------------
// Claim Type replaces "Priority of Exam".  Call an RPC to update the new
//     Claim Type multiple field.
//
//   RPC:  DVBA CAPRI GETCLAIMTYPE
//
//   INPUT PARAMETERS:
//     IEN OF REQUEST
//   VALID OUTPUT:
//     CLAIM TYPE NAME ^ IEN OF CLAIM TYPE
//   ERROR OUTPUT:
//     INVALID REQUEST IEN
//
// CodeCR666  JRL  11/7/14
// CodeCR666  JRL   1/29/15 Changed control from check listbox to listbox since
//                          requirement changed from multi-select to only one
//                          value required
// -----------------------------------------------------------------------------

procedure TfrmViewExam.GetClaimType(RequestIEN: String);
var
  i, j: Integer;
  buffer: string;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI GETCLAIMTYPE';
  frmMain.RPCBroker1.Param[0].Value := RequestIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBAB CAPRI GETCLAIMTYPE could not be accessed!');
  End;
  If frmMain.RPCBroker1.Results.Count > 0 Then
  begin
    For i := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    begin
      buffer := Piece(frmMain.RPCBroker1.Results[i], '^', 1);
      if (i = 0) AND (buffer = 'INVALID REQUEST IEN') then
      begin
        ShowMessageCAPRI('An invalid Claim Type IEN was sent to RPC DVBA CAPRI GETCLAIMTYPE');
        Exit;
      end;
      for j := 0 to cbClaimType.Items.Count - 1 do
      begin
        if cbClaimType.Items[j] = buffer then
          cbClaimType.ItemIndex := j;
      end;
    end;
  end;
end;

// -----------------------------------------------------------------------------
// Set Claim Type
// -----------------------------------------------------------------------------
// Claim Type replaces "Priority of Exam".  Call an RPC to update the new
//     Claim Type multiple field.
//
//   RPC:  DVBA CAPRI SETCLAIMTYPE
//
//   INPUT PARAMETERS:
//     IEN OF REQUEST
//     ARRAY LIST OF VALID CLAIM TYPE NAME (NOT IEN)
//   ERROR OUTPUT:
//     INVALID REQUEST IEN
//     CLAIM TYPE NAME NOT A VALID CLAIM TYPE
//     CLAIM TYPE NAME COULD NOT BE FILED
//
// CodeCR666  JRL  11/7/14
// CodeCR666  JRL   2/2/15 Changed control from check listbox to combobox since
//                          requirement changed from multi-select to only one
//                          value required
// -----------------------------------------------------------------------------

procedure TfrmViewExam.SetClaimType(RequestIEN: String);
var
  i: Integer;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI SETCLAIMTYPE';
  frmMain.RPCBroker1.Param[0].Value := RequestIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].PType := list;
  frmMain.RPCBroker1.Param[1].Mult[IntToStr(1)] := cbClaimType.Items[cbClaimType.ItemIndex];
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBA CAPRI SETCLAIMTYPE could not be accessed!');
  end;
end;

// -----------------------------------------------------------------------------
// Load SpecialConsideration Control Values
// -----------------------------------------------------------------------------
// Special Considerations accompanies Claim Type to replace "Priority of Exam".
//    Call an RPC to update the new Special Considerations multiple field.
//
//   RPC:  DVBA CAPRI LISTSPCLCONSID
//
//   INPUT PARAMETERS:
//     NONE
//   OUTPUT:
//     SPECIAL CONSIDERATION ^ IEN OF SPECIAL CONSIDERATION
//
// CodeCR667  JRL  11/5/14
// -----------------------------------------------------------------------------

procedure TfrmViewExam.LoadSpecialConsiderationControlValues;
var
  i: Integer;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI LISTSPCLCONSID';
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBAB CAPRI LISTSPCLCONSID could not be accessed!');
  End;
  chklstSpecialConsiderations.Items.Clear;
  If frmMain.RPCBroker1.Results.Count > 0 Then
  begin
    For i := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    begin
      chklstSpecialConsiderations.Items.Add(Piece(frmMain.RPCBroker1.Results[i], '^', 1));
    end;
  end;
end;

// -----------------------------------------------------------------------------
// Get Special Considerations
// -----------------------------------------------------------------------------
// Special Considerations accompanies Claim Type to replace "Priority of Exam".
//    Call an RPC to retrieve the new Special Considerations multiple field.
//
//   RPC:  DVBA CAPRI GETSPCLCONSID
//
//   INPUT PARAMETERS:
//     IEN OF REQUEST
//   VALID OUTPUT:
//     SPECIAL CONSIDERATION ^ IEN OF SPECIAL CONSIDERATION
//   ERROR OUTPUT:
//     INVALID REQUEST IEN
//     NO SPECIAL CONSIDERATIONS ON FILE
//
// CodeCR666  JRL  11/7/14
// CodeCR666  JRL   1/30/15 Changed control from check listbox to listbox since
//                          requirement changed from multi-select to only one
//                          value required
// -----------------------------------------------------------------------------

procedure TfrmViewExam.GetSpecialConsidations(RequestIEN: String);
var
  i, j: Integer;
  buffer: string;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI GETSPCLCONSID';
  frmMain.RPCBroker1.Param[0].Value := RequestIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBAB CAPRI GETSPCLCONSID could not be accessed!');
  End;
  for j := 0 to chklstSpecialConsiderations.Count - 1 do
    chklstSpecialConsiderations.Checked[j] := FALSE;
  If frmMain.RPCBroker1.Results.Count > 0 Then
  begin
    For i := 0 To frmMain.RPCBroker1.Results.Count - 1 Do
    begin
      buffer := Piece(frmMain.RPCBroker1.Results[i], '^', 1);
      if (i = 0) AND (buffer = 'INVALID REQUEST IEN') then
      begin
        ShowMessageCAPRI('An invalid Special Considerations IEN was sent to RPC DVBA CAPRI GETSPCLCONSID');
        Exit;
      end;
      for j := 0 to chklstSpecialConsiderations.Count - 1 do
      begin
        if chklstSpecialConsiderations.Items[j] = buffer then
          chklstSpecialConsiderations.Checked[j] := TRUE;
      end;
    end;
  end;
end;


// -----------------------------------------------------------------------------
// Set SpecialConsideration Control Values
// -----------------------------------------------------------------------------
// Special Considerations accompanies Claim Type to replace "Priority of Exam".
//    Call an RPC to update the new Special Considerations multiple field.
//
//   RPC:  DVBA CAPRI SETSPCLCONSID
//
//   INPUT PARAMETERS:
//     IEN OF REQUEST
//     ARRAY LIST OF VALID CLAIM TYPE NAME (NOT IEN)
//   ERROR OUTPUT:
//     INVALID REQUEST IEN
//     SPECIAL CONSIDERATION NAME NOT A VALID SPECIAL CONSIDERATION
//     SPECIAL CONSIDERATION NAME COULD NOT BE FILED
//
// CodeCR667  JRL  11/5/14
// -----------------------------------------------------------------------------

procedure TfrmViewExam.SetSpecialConsidations(RequestIEN: String);
var
  i: Integer;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBA CAPRI SETSPCLCONSID';
  frmMain.RPCBroker1.Param[0].Value := RequestIEN;
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].PType := list;
  for i := 0 to chklstSpecialConsiderations.Count - 1 do
  begin
    if chklstSpecialConsiderations.Checked[i] then
      frmMain.RPCBroker1.Param[1].Mult[IntToStr(i + 1)] := chklstSpecialConsiderations.Items[i];
  end;
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    On EBrokerError Do
      ShowMessageCAPRI('RPC DVBA CAPRI SETSPCLCONSID could not be accessed!');
  end;
end;


end.

