Unit AuditReport;

Interface

Uses
  Classes,
  Controls,
  Db,
  DBClient,
  DBCtrls,
  DBTables,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Forms,
  Graphics,
  kbmMemTable,
  Mask,
  Messages,
  Provider,
  Qrctrls,
  QRExport,
  QuickRpt,
  StdCtrls,
  SysUtils,
  Windows;

Type
  TfrmAuditReport = Class(TForm)
    ColumnHeaderBand1       : TQRBand;
    DetailBand1             : TQRBand;
    kbmMemTable1            : TkbmMemTable;
    kbmMemTable1ClaimNbr    : TStringField;
    kbmMemTable1Date_Time   : TStringField;
    kbmMemTable1Location    : TStringField;
    kbmMemTable1PageCount   : TIntegerField;
    kbmMemTable1PatientICN  : TStringField;
    kbmMemTable1PatientName : TStringField;
    kbmMemTable1PatientSSN  : TStringField;
    kbmMemTable1Sensitive   : TStringField;
    kbmMemTable1UserDivision: TStringField;
    kbmMemTable1UserIEN     : TStringField;
    kbmMemTable1UserName    : TStringField;
    kbmMemTable1UserSSN     : TStringField;
    kbmMemTable1UserTitle   : TStringField;
    PageHeaderBand1         : TQRBand;
    QRCSVFilterCVS          : TQRCSVFilter;
    QRDBText1               : TQRDBText;
    QRDBText10              : TQRDBText;
    QRDBText11              : TQRDBText;
    QRDBText2               : TQRDBText;
    QRDBText3               : TQRDBText;
    QRDBText4               : TQRDBText;
    QRDBText5               : TQRDBText;
    QRDBText6               : TQRDBText;
    QRDBText7               : TQRDBText;
    QRDBText8               : TQRDBText;
    QRDBText9               : TQRDBText;
    QRExpr3                 : TQRExpr;
    QRLabel1                : TQRLabel;
    QRLabel10               : TQRLabel;
    QRLabel11               : TQRLabel;
    QRLabel12               : TQRLabel;
    QRLabel13               : TQRLabel;
    QRLabel2                : TQRLabel;
    QRLabel3                : TQRLabel;
    QRLabel4                : TQRLabel;
    QRLabel5                : TQRLabel;
    QRLabel6                : TQRLabel;
    QRLabel7                : TQRLabel;
    QRLabel8                : TQRLabel;
    QRLabel9                : TQRLabel;
    QRSysData1              : TQRSysData;
    QRSysData2              : TQRSysData;
    QuickRep1               : TQuickRep;
    TitleBand1              : TQRBand;
    Procedure ColumnHeaderBand1BeforePrint(Sender: TQRCustomBand;Var PrintBand: Boolean);
    Procedure PageHeaderBand1BeforePrint(Sender: TQRCustomBand;Var PrintBand: Boolean);
    Procedure QuickRep1BeforePrint(Sender: TCustomQuickRep;Var PrintReport: Boolean);
    Procedure TitleBand1BeforePrint(Sender: TQRCustomBand;Var PrintBand: Boolean);
  Public
    auditDataset: TDBDataSet;
  End;

Var
  frmAuditReport: TfrmAuditReport;

Implementation

Uses AuditReportPreview;

{$R *.DFM}

Procedure TfrmAuditReport.QuickRep1BeforePrint(Sender: TCustomQuickRep;
  Var PrintReport: Boolean);
Begin
  If QuickRep1.Exporting Then
    QuickRep1.Font.Pitch := fpFixed;
End;

Procedure TfrmAuditReport.PageHeaderBand1BeforePrint(Sender: TQRCustomBand;
  Var PrintBand: Boolean);
Begin
  If QuickRep1.Exporting Then
    PrintBand := False;
End;

Procedure TfrmAuditReport.TitleBand1BeforePrint(Sender: TQRCustomBand;
  Var PrintBand: Boolean);
Begin
  If QuickRep1.Exporting Then
    PrintBand := False;
End;

Procedure TfrmAuditReport.ColumnHeaderBand1BeforePrint(
  Sender: TQRCustomBand; Var PrintBand: Boolean);
Begin
  If QuickRep1.Exporting Then
    PrintBand := False;
End;

End.
