Unit connected;

Interface

Uses
  Classes,
  Controls,
  Dialogs,
  DialogsCAPRI,
  ExtCtrls,
  Forms,
  Graphics,
  Messages,
  StdCtrls,
  SysUtils,
  Windows;

Type
  TfrmStayConnected = Class(TForm)
    Button1       : TButton;
    Button2       : TButton;
    Label1        : TLabel;
    panelCountdown: TPanel;
    Timer1        : TTimer;
    Timer2        : TTimer;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure Timer1Timer(Sender: TObject);
    Procedure Timer2Timer(Sender: TObject);
  Private
    { Private declarations }
  Public
    { Public declarations }
  End;

Var
  frmStayConnected: TfrmStayConnected;
  timecountdown: integer;

Implementation

{$R *.DFM}

Procedure TfrmStayConnected.Button1Click(Sender: TObject);
Begin
  Timer1.Enabled := False;
  ModalResult := mrOk;
End;

Procedure TfrmStayConnected.Button2Click(Sender: TObject);
Begin
  Timer1.Enabled := False;
  modalresult := mrcancel;
End;

Procedure TfrmStayConnected.Timer1Timer(Sender: TObject);
Begin
  application.bringtofront;
  frmStayConnected.BringToFront;
  Dec(TimeCountDown);
  PanelCountdown.Caption := IntToStr(TimeCountDown);
  If (TimeCountDown / 2) = trunc(TimeCountDown / 2) Then
    messagebeep(0);

  If TimeCountDown = 0 Then
    Button2Click(Application);
End;

Procedure TfrmStayConnected.FormShow(Sender: TObject);
Begin
  timeCountdown := 31;
  PanelCountdown.Caption := IntToStr(TimeCountDown);
  Timer1.Enabled := True;
  BringToFront;
End;

Procedure TfrmStayConnected.Timer2Timer(Sender: TObject);
Begin
  frmStayConnected.BringToFront;
End;

End.
