unit deletetemplateverification;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  StdCtrls,
  Trpcb;

type
  TfrmDeleteTemplate = class(TForm)
    Edit1: TEdit;
    editVerifyCode: TEdit;
    editVerifyCodeUser: TEdit;
    Edit4: TEdit;
    Button1: TButton;
    Button2: TButton;
    MemoTemplateInfo: TMemo;
    procedure editVerifyCodeContextPopup(Sender: TObject; MousePos: TPoint;
      var Handled: Boolean);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmDeleteTemplate: TfrmDeleteTemplate;

implementation

uses main;

{$R *.DFM}

procedure TfrmDeleteTemplate.editVerifyCodeContextPopup(Sender: TObject;
  MousePos: TPoint; var Handled: Boolean);
begin
  ShowmessageCAPRI('Right click is not allowed here!');
  handled := true;
end;

procedure TfrmDeleteTemplate.Button1Click(Sender: TObject);
begin
  modalresult := mrCancel;
end;

procedure TfrmDeleteTemplate.Button2Click(Sender: TObject);
begin
  if editVerifyCode.text <> editVerifyCodeUser.text then begin
    ShowmessageCAPRI('The codes do not match.  Please try again.');
    editVerifyCodeUser.Text := '';
    editVerifyCode.SetFocus;
    exit;
  end;

  (*
  frmMain.MailManBuffer.Lines.Clear;
  frmMain.MailManBuffer.Lines.Add('This message is being sent as a record that an unsigned CAPRI C&P exam');
  frmMain.MailManBuffer.Lines.Add('template has been deleted.');
  frmMain.MailManBuffer.Lines.Add('');
  frmMain.MailManBuffer.Lines.Add('Normally, no further action is necessary.');
  frmMain.MailManBuffer.Lines.Add('');
  if memoTemplateInfo.Lines.Count>0 then
    for x:=0 to memoTemplateInfo.Lines.Count-1 do
      frmMain.MailManBuffer.Lines.Add(memoTemplateInfo.Lines[x]);

  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB SEND MSG';
  frmMain.RPCBroker1.Param[0].Value := AuthorIEN;  //DUZ Of Author of Note
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBroker1.Param[1].Value := 'CAPRI: Deletion of CAPRI Exam Template'; //Max 45 Chars
  frmMain.RPCBroker1.Param[1].PType := literal;
  frmMain.RPCBroker1.Param[2].PType := list;
  for i := 0 to frmMain.MailManBuffer.lines.count-1 do
     frmMain.RPCBroker1.Param[2].Mult[IntToStr(i+1)] := frmMain.MailManBuffer.Lines[i];
     // frmMain.RPCBroker1.Param[2].Mult[IntToStr(i+1)+',0'] := MainManBuffer.Lines[i];
  frmMain.RPCBroker1.Param[3].Value := 'DVBA C 2507 CANCELLATION';  //Mail Group Name
  frmMain.RPCBroker1.Param[3].PType := literal;
  frmMain.RPCBrokerCall;; try frmMain.RPCBroker1.Call;
    except
  On EBrokerError do
    ShowMessageCAPRI('RPC DVBAB SEND MSG could not be accessed!');
  end;
  If frmMain.RPCBroker1.Results[0]<>'MESSAGE SENT' then ShowMessageCAPRI('There was a problem notifying one or more recipents of mailgroup DVBA C 2507 CANCELLATION.  Please notify IRM!');
  *)

  modalresult := mrok;
end;

procedure TfrmDeleteTemplate.FormCreate(Sender: TObject);
begin
  randomize;
  editVerifyCode.Text := inttostr(random(9)); // 0 to 9
  editVerifyCode.Text := editVerifyCode.text + inttostr(random(9)); // 0 to 9
  editVerifyCode.Text := editVerifyCode.text + inttostr(random(9)); // 0 to 9
  editVerifyCode.Text := editVerifyCode.text + inttostr(random(9)); // 0 to 9
end;

end.
