unit demTranMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, Menus, StdCtrls, ExtCtrls, ComCtrls, frmContractedExamNewResend
  //, frmContractedExamCheckIn
  , clsPatientInfo, PtntSlctnDlg, PatientSelectionDlg,
  Trpcb, CCOWRPCBrokerCAPRI, RpcConf1, MFunStr, cls2507Info, Diaccess, untBrkrMthds,
  clsUserInfo, dlgAbout, dlgExitApp, VERGENCECONTEXTORLib_TLB, ComObj,
  frmContractorEditor, frmContractedExamDeleteCO, frmContractedAdminCheckIn,
  dlgFeeInfoEdtr, dlgVAMCInfoEdtr, untConstVals,
  untMiscMthds,                                                                 // DONE: CodeCR457 - LMS IOUtils removed all references to this XE2 unit
  dlgCntrctdExmRpts, frm508ReportRslts, clsVrsnChckr, Fmcntrls, dialogsCAPRI,
  ManageReportsCCR, (* DONE: RJL removed PlannerDatePicker, *) Fmcmpnts, DiTypLib
  , clsSFTPConn
  , vlerCCRExams
  , SBSFtpCommon, StrUtils, ShellAPI, Buttons, CCOWRPCBroker;

type
  TfrmCntrctdExmMain = class(TForm)
    mnuMain: TMainMenu;
    mnuItmFile: TMenuItem;
    mnuItmSlctPtnt: TMenuItem;
    N1: TMenuItem;
    mnuItmExit: TMenuItem;
    mnuItmRpts: TMenuItem;
    GroupBox1: TGroupBox;
    Panel1: TPanel;
    GroupBox2: TGroupBox;
    btnSlctPtnt: TButton;
    btnRfrshExamList: TButton;
    btnNewExam: TButton;
    btnResendExam: TButton;
    btnCheckInExam: TButton;
    CCOWRPCBrkrMain: TCCOWRPCBrokerCAPRI;
    trVw2507Info: TTreeView;
    tmrAppShutDwn: TTimer;
    tmrEnsrBrkrCnntctd: TTimer;
    mnuItmHelp: TMenuItem;
    mnuItmHlpAbout: TMenuItem;
    N2: TMenuItem;
    mnuItmHlpCntnt: TMenuItem;
    mnuItmAdmin: TMenuItem;
    mnuItmAdminCntrctrEditor: TMenuItem;
    N3: TMenuItem;
    mnuItmEdtFeeInfo: TMenuItem;
    mnuItmAdminDeleteCO: TMenuItem;
    mnuItmEdtVAMCInfo: TMenuItem;
    mnuItmCRptsDtld: TMenuItem;
    mnuItmCRptsSmmry: TMenuItem;
    mnuItmCRptsTmlnss: TMenuItem;
    mnuItmCRpts: TMenuItem;
    mnuItmAdminEditCI: TMenuItem;
    mnuItmTools: TMenuItem;
    mnuItmToolsMngeCPExmRqsts: TMenuItem;
    tmrShowForm: TTimer;
    GroupBox3: TGroupBox;
    cmbBxExamFltr: TComboBox;
    GroupBox4: TGroupBox;
    edtDtPckrExamFrom: TLabeledEdit;
    edtDtPckrExamTo: TLabeledEdit;
    fmLstrReq: TFMLister;
    fmLstrCntrcts: TFMLister;
    fmLstrExam: TFMLister;
    sbMain: TStatusBar;
    btnDtPckrExamTo: TSpeedButton;
    btnDtPckrExamFrom: TSpeedButton;
    btnSimulateVLERResults: TButton;
    GenMedNewExamPanel: TPanel;
    FMFiler1: TFMFiler;
    FMExamType: TFMEdit;
    FMExamStatus: TFMEdit;
    FMFeeExam: TFMEdit;
    fmFindOneTemp: TFMFindOne;
    fmGetsTemp: TFMGets;
    fmLastExamAddedBy: TFMEdit;
    fmLastExamAddDate: TFMEdit;
    FMExamRequest: TFMEdit;
    FMExamNumber: TFMEdit;
    FMExamContractor: TFMEdit;
    FMExamDtSent: TFMEdit;
    lblPtntNme: TLabeledEdit;
    lblSSN: TLabeledEdit;
    lblDOB: TLabeledEdit;
    function HasRequests(ReqLstr: TFMLister; var Reqsts: String): Boolean;
    function GetExams(ExamLstr: TFMLister; Reqsts: String; ExamList: TStringList): Boolean;
    //function GetTempExmDir(DUZ: String): String;
    function GetReqErrMsg(ReqIen, Con: String): String;
    function ProcessFilesVLER(slExams, okFiles: TStringList; olOk: TList; Rcon: String): Boolean;
    function ProcessFilesSFTP(slEx, slOk: TStringList; olOk: TList; Rcon: String): Boolean;
    function UpdateVistaSFTP(slResults, slOurExams: TStringList; ReqIen, ExamIen, IntResDt,
      ResultStub: String; ReqAllDone: Boolean): Boolean;
    function UpdateVistaVLER(slResults, slOurExams: TStringList; ReqIen, ExamIen, IntResDt,
      ResultStub, VLERResultObjID: String; ReqAllDone: Boolean): Boolean;
    procedure btnNewExamClick(Sender: TObject);
    procedure btnCheckInExamClick(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormShow(Sender: TObject);
    procedure btnSlctPtntClick(Sender: TObject);
    procedure mnuItmSlctPtntClick(Sender: TObject);
    procedure mnuItmExitClick(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
//    procedure dtPckrExamFromChange(Sender: TObject);
//    procedure dtPckrExamToChange(Sender: TObject);
    procedure btnRfrshExamListClick(Sender: TObject);
    procedure btnResendExamClick(Sender: TObject);
    procedure tmrAppShutDwnTimer(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure tmrEnsrBrkrCnntctdTimer(Sender: TObject);
    procedure mnuItmHlpAboutClick(Sender: TObject);
    procedure mnuItmHlpCntntClick(Sender: TObject);
    procedure mnuItmAdminCntrctrEditorClick(Sender: TObject);
    procedure mnuItmEdtFeeInfoClick(Sender: TObject);
    procedure mnuItmAdminDeleteCOClick(Sender: TObject);
    procedure mnuItmEdtVAMCInfoClick(Sender: TObject);
    procedure mnuItmCRptsDtldClick(Sender: TObject);
    procedure mnuItmCRptsSmmryClick(Sender: TObject);
    procedure mnuItmCRptsTmlnssClick(Sender: TObject);
    procedure mnuItmAdminEditCIClick(Sender: TObject);
    procedure dtPckrExamFromExit(Sender: TObject);
    procedure dtPckrExamToExit(Sender: TObject);
    procedure mnuItmToolsMngeCPExmRqstsClick(Sender: TObject);
    procedure tmrShowFormTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure cmbBxExamFltrChange(Sender: TObject);
    procedure StatusMsg(Msg: String);
    procedure btnDtPckrExamToClick(Sender: TObject);
    procedure edtDtPckrExamToExit(Sender: TObject);
    procedure btnDtPckrExamFromClick(Sender: TObject);
    procedure edtDtPckrExamFromChange(Sender: TObject);
    procedure edtDtPckrExamFromExit(Sender: TObject);
    procedure edtDtPckrExamToChange(Sender: TObject);
    procedure btnSimulateVLERResultsClick(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure lblPtntNmeEnter(Sender: TObject);
    procedure lblSSNEnter(Sender: TObject);
    procedure lblDOBEnter(Sender: TObject);
  protected
    { Protected declarations }
    CntxtrCntrl: TContextorControl;
    Procedure ContextorControlCanceled(Sender: TObject);
    Procedure ContextorControlCommitted(Sender: TObject);
    Procedure ContextorControlPending(Sender: TObject; Const aContextItemCollection: IDispatch);
  private
    { Private declarations }
    _PtntInfo: TPatientInfo;
    _2507Info: T2507Info;
    frmvlerCCRExams: TfrmvlerCCRExams;
    slContractors: TStringList;                                                 // DONE: LMS may be add VlerEnabled to this list.
    //function UserHasKey(DUZ, Key: String): Boolean; // DONE: LMS: to be removed. Has been refactored out.
    function ContinueCOWBadAddrss(): Boolean;                                   { Check-Out Bad Address Prompt }
    procedure CheckOutExam(RsndInfo: Boolean);
    procedure DisplayPatientInfo;
    procedure Display2507Info;
    procedure GenerateContractedReport(RptType: String);
    procedure GetPatientInfo;
    procedure Get2507Info;
    procedure NoRqstsErrMsg;
    procedure ResetAppTmr;
    procedure ResetCntrctdPrcssBtns;
    procedure SetupForm;
//    procedure SetupSSO;
    function GetDateOfText(aDateStr: string; defaultDate: string): TDateTime;
    // function IsDateValid(aDateStr : string) : Boolean;  // DONE: LMS refactored out
    procedure DateComplete(var StrLikeDate: string; MinDate: TDate;
      const NowIfError: Boolean = TRUE);
    procedure FillContractorsList;
    procedure SetContractorVLEREnabledAndName(RCon: String; Value: string);
    //procedure AttemptToSetInProcessManifestsOpenTList(lstFilesVLER: TList);  not used.. for future use only if needed
    procedure AttemptToSetInProcessManifestsOpenTStringList(aStrList: TStringList);
  public
    { Public declarations }
    function GetRemoteConIen(LocalContractor: String): String;                  // DONE: LMS - Can lookup remote contractor from anywhere - was .... function GetRemoteConIen(Index: String; slCon: TStringList): String;
    function IsContractorVLEREnabled(RCon: String): Boolean;
    function GetContractorName(RCon: String): String;
    Function HorologDateStringToDouble(FMorHorologDtStr: string): Double;
    procedure GetFMInternalDateFromDateTime(var intVendResultDate: string; vFileDate: TDateTime);
    //procedure ConvertVLERFileTimeToDateTime(var vFileDate: TDateTime; vFileTimeStamp: string);
    function CreateNewExamSentByVendor(ExamReqID: string; VLERExamName: string; LocalContractorID: string; DtSent: string): string;
    function CreateManageReportsCCR: TFrmManageReportsCCR;
  end;

var
  frmCntrctdExmMain: TfrmCntrctdExmMain;

implementation

uses
  Main                                                                          // DONE: CodeCR457 - LMS For embedding into CAPRI
  , VocRehabSelectDate                                                          // DONE: CodeCR457 - LMS For replacing date selection components
  , DateUtils
  , untAddtnlMMthds
  , Patient                                                                     // rpk 7/15/2014
  , VlerDasClient
  , clsVLERConn
  , clsVendConn
  , IdDateTimeStamp
  , IdBaseComponent
  , VA508AccessibilityRouter
  ;


{$R *.dfm}

{ Form }

procedure TfrmCntrctdExmMain.FormCreate(Sender: TObject);
  function DeleteDirectoryRecurse(const DirName: string): Boolean;              // DONE: LMS replacement for TDirectory.Delete
  var
    FileOp: TSHFileOpStruct;
  begin
    FillChar(FileOp, SizeOf(FileOp), 0);
    FileOp.wFunc := FO_DELETE;
    FileOp.pFrom := PChar(DirName + #0);                                        //double zero-terminated
    FileOp.fFlags := FOF_SILENT or FOF_NOERRORUI or FOF_NOCONFIRMATION;
    Result := (SHFileOperation(FileOp) = 0);
  end;
var
  TempDirCCOWUserDUZ: string;                                                   // DONE: LMS ??? Array[0..MAX_PATH - 1] Of char;
begin
  FreeAndNil(CCOWRPCBrkrMain);

{$IFDEF CAPRIDEVELOPER}
  btnSimulateVLERResults.visible := true;
  btnRfrshExamList.visible := true;
{$ENDIF}


  CCOWRPCBrkrMain := frmMain.RPCBroker1;
  fmLstrCntrcts.RPCBroker := CCOWRPCBrkrMain;
  fmLstrExam.RPCBroker := CCOWRPCBrkrMain;
  fmLstrReq.RPCBroker := CCOWRPCBrkrMain;

  SetupForm;
  { Delete Folder and any outstanding files caused by crashes ect... for user }
  TempDirCCOWUserDUZ := GetTempExmDir(CCOWRPCBrkrMain.User.DUZ);                // DONE: LMS later replace demTranTemp with relevant new call from CAPRI
  if DirectoryExists(TempDirCCOWUserDUZ) then
    DeleteDirectoryRecurse(TempDirCCOWUserDUZ);                                 // DONE: LMS rewrote new function

  slContractors := TStringList.Create;
end;

procedure TfrmCntrctdExmMain.FormDestroy(Sender: TObject);
begin
  if Assigned(frmvlerCCRExams) then begin
    frmvlerCCRExams.Release;
    //application.processmessages;
    frmvlerCCRExams := nil
  end;
end;

procedure TfrmCntrctdExmMain.FormShow(Sender: TObject);
begin
  (*if CCOWRPCBrkrMain.Connected then
  begin
    btnSlctPtntClick(self);  { Put a patient into context }
    { No patient selected or exception occurred, terminate application }
    if Not Assigned(_PtntInfo) then
      Application.Terminate
    else
      tmrShowForm.Enabled := True;
  end
  else
    Application.Terminate;  { Quit if broker connection wasn't created }*)
end;

procedure TfrmCntrctdExmMain.FormActivate(Sender: TObject);
begin
  cmbBxExamFltr.ItemIndex := 2;
  btnRfrshExamListClick(Application);
end;

procedure TfrmCntrctdExmMain.FormClose(Sender: TObject;
  var Action: TCloseAction);
begin
  _PtntInfo.Free;
  _2507Info.Free;
  slContractors.Free;
  CCOWRPCBrkrMain := nil;                                                       // DONE: LMS so form free doesn't kill the mainform broker.
  (* DONE: LMS
  if (CCOWRPCBrkrMain.Contextor <> nil) then
  begin
    try
      CntxtrCntrl.suspend;
    finally
      try
        CntxtrCntrl.Free;
      except  { Do Nothing, just close application }
      end;  { End Inner Try Except Block }
    end;  { End Outer Try Finally Block }
  end;  { End If Contextor Not NIL }
  *)
end;

procedure TfrmCntrctdExmMain.FormCloseQuery(Sender: TObject;
  var CanClose: Boolean);
begin
  // DONE: LMS CCOWRPCBrkrMain.Connected := False;  { Shutdown RPC Connection }
end;

procedure TfrmCntrctdExmMain.tmrAppShutDwnTimer(Sender: TObject);
(*var
  dlgExitApp: TfrmExitAppDlg;
  *)
begin
  tmrAppShutDwn.Enabled := False;
  (* DONE: lms removing
  dlgExitApp := TfrmExitAppDlg.Create(self);
  Application.BringToFront;
  if dlgExitApp.ShowModal = mrOk then
  begin
    dlgExitApp.Release;
    Close;
  end  { End Else Ok - Close Application }
  else
  begin
    dlgExitApp.Release;
    ResetAppTmr;
  end;  { End Else Cancel }
  *)
end;

procedure TfrmCntrctdExmMain.tmrEnsrBrkrCnntctdTimer(Sender: TObject);
begin
  tmrEnsrBrkrCnntctd.Enabled := False;
  (* DONE: LMS removing
  { Ensure Broker still connected if not connected try to reconnect silently }
  if Not EnsureBrokerConnected(CCOWRPCBrkrMain) then
    Close  { Shut application down if Broker is not connected }
  else
    tmrEnsrBrkrCnntctd.Enabled := True;
    *)
end;

procedure TfrmCntrctdExmMain.tmrShowFormTimer(Sender: TObject);
begin
  (*tmrShowForm.Enabled := False;
  Application.BringToFront;  { Ensure Application is brought to front on Startup }*)
end;

(*
function TfrmCntrctdExmMain.UserHasKey(DUZ, Key: String): Boolean;
// DONE: LMS: completely redundant. class function TUserInfo.UserHasKey already does this.
  function IsKeyInList(KeyName: string; KeyList: TFMLister): Boolean;
  var
    i: Integer;
  begin
    Result := False;
    for i := 0 to KeyList.Results.Count - 1 do
    begin
      if SameText(UpperCase(KeyList.GetRecord(KeyList.Results[i]).GetField('.01').
           FMDBExternal), KeyName) then
      begin
        Result := True;
        break;
      end;  { End If Search Key Value found in list }
    end;  { End Keylist Loop }
  end;

var
  FMLstrUsrInfo: TFMLister;
begin
  FMLstrUsrInfo := TFMLister.Create(self); // DONE: LMS change ownership to ensure cleanup.
  try
    { Retrieve User's Assigned Key(s) }
    // TODO: LMS - No - non existing member of class.. what functionality is lost?
    FMLstrUsrInfo.RPCBroker := CCOWRPCBrkrMain;  // DONE: LMS Do we need this BROKER!
    FMLstrUsrInfo.FileNumber := '200.051';
    FMLstrUsrInfo.FieldNumbers.Add('.01');  { Key Name - DBIA #10060 }
    FMLstrUsrInfo.IENS := ',' + DUZ;
    FMLstrUsrInfo.GetList(nil);
    { Determine if user has Admin Key }
    Result := IsKeyInList(Key, FMLstrUsrInfo);
  finally
    FMLstrUsrInfo.Free;
  end;  { End Try/Finally Block }
end;
*)

function TfrmCntrctdExmMain.CreateManageReportsCCR: TFrmManageReportsCCR;
begin
  // If any change is made here, check to make sure it's not needed in "mnuItmToolsMngeCPExmRqstsClick"
  tmrAppShutDwn.Enabled := False;
  GetPatientInfo;                                                               // rpk 10/29/2014
  result := tFrmManageReportsCCR.Create(self, _PtntInfo, CCOWRPCBrkrMain,
    (tmrAppShutDwn.Interval - 60000));
  result.ExamRequestRefreshClick(application);
end;

{ Menu Items }

procedure TfrmCntrctdExmMain.mnuItmToolsMngeCPExmRqstsClick(Sender: TObject);
var
  frmManageReports: tFrmManageReportsCCR;                                       // DONE: LMS ref to unit renamed
begin
  // If any change is made here, check to make sure it's not needed in "CreateManageReportsCCR"
  tmrAppShutDwn.Enabled := False;

  frmManageReports := tFrmManageReportsCCR.Create(self, _PtntInfo, CCOWRPCBrkrMain,
    (tmrAppShutDwn.Interval - 60000));
  frmManageReports.ExamRequestRefreshClick(application);
  frmManageReports.ShowModal;
  if (frmManageReports.CheckInDeleted) then
    btnRfrshExamListClick(self);                                                { Refresh List only if Check-In Disapproved }
  frmManageReports.Free;
  //ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmSlctPtntClick(Sender: TObject);
begin
  btnSlctPtntClick(self);
end;

procedure TfrmCntrctdExmMain.mnuItmHlpAboutClick(Sender: TObject);
begin
  ResetAppTmr;
  TfrmAboutDlg.ShowAbout;                                                       { Display modal About window }
end;

procedure TfrmCntrctdExmMain.mnuItmHlpCntntClick(Sender: TObject);
begin
  // ShellExecute(frmCntrctdExmMain.Handle, '', 'CapriContractReferral.chm', '', '', SW_SHOWNORMAL);
  // DONE: LMS may need the below code instead. Depends on Mike.
  Application.HelpContext(7000);                                                // LMS: 7000 for CCR specific items
end;

procedure TfrmCntrctdExmMain.mnuItmCRptsDtldClick(Sender: TObject);
begin
  GenerateContractedReport('Detailed');
end;

procedure TfrmCntrctdExmMain.mnuItmCRptsSmmryClick(Sender: TObject);
begin
  GenerateContractedReport('Summary');
end;

procedure TfrmCntrctdExmMain.mnuItmCRptsTmlnssClick(Sender: TObject);
begin
  GenerateContractedReport('Timeliness');
end;

procedure TfrmCntrctdExmMain.mnuItmAdminCntrctrEditorClick(Sender: TObject);
var
  frmCntrctrEditor: TContractorEditorForm;
begin
  tmrAppShutDwn.Enabled := False;
  frmCntrctrEditor := TContractorEditorForm.Create(self, CCOWRPCBrkrMain,
    (tmrAppShutDwn.Interval - 60000));
  frmCntrctrEditor.ShowModal;
  frmCntrctrEditor.Free;                                                        { Ensure Memory is released }
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmAdminDeleteCOClick(Sender: TObject);
var
  frmDeleteCheckOut: TExntdCntrctdBaseFormDeleteCO;
begin
  tmrAppShutDwn.Enabled := False;
  frmDeleteCheckOut := TExntdCntrctdBaseFormDeleteCO.Create(self, _PtntInfo,    // Sending self as owner is important. It is used in some instances.
    CCOWRPCBrkrMain, (tmrAppShutDwn.Interval - 60000));
  { Refresh display if 1 or more exams had their check-out deleted and the
    display is set for Open exam types to be shown. }
  if ((frmDeleteCheckOut.ShowModal = mrOk) And
    SameText(Uppercase(cmbBxExamFltr.Text), 'PENDING REFERRALS')) then
    btnRfrshExamListClick(self);                                                { Refresh List }
  frmDeleteCheckOut.Free;                                                       { Ensure Memory is released }
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmAdminEditCIClick(Sender: TObject);
var
  frmAdminEditCheckIn: TExntdCntrctdBaseFormAdminCheckIn;
begin
  tmrAppShutDwn.Enabled := False;
  frmAdminEditCheckIn := TExntdCntrctdBaseFormAdminCheckIn.Create(self,         // Sending self as owner is important. It is used in some instances.
    _PtntInfo, CCOWRPCBrkrMain, (tmrAppShutDwn.Interval - 60000));
  { Refresh display if 1 or more exams had their check-in changed/deleted }
  if (frmAdminEditCheckIn.ShowModal = mrOk) then
    btnRfrshExamListClick(self);                                                { Refresh List }
  frmAdminEditCheckIn.Free;                                                     { Ensure Memory is released }
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmEdtVAMCInfoClick(Sender: TObject);
var
  dlgVAMCEdtr: TfrmVAMCEdtrDlg;                                                 { Phone Number stored in Windows Registry }
begin
  tmrAppShutDwn.Enabled := False;
  dlgVAMCEdtr := TfrmVAMCEdtrDlg.Create(self, tmrAppShutDwn.Interval - 60000);
  dlgVAMCEdtr.ShowModal;
  dlgVAMCEdtr.Free;
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmEdtFeeInfoClick(Sender: TObject);
var
  dlgFeeEdtr: TfrmFeeEdtrDlg;                                                   { Contact Address stored in Windows Registry }
begin
  tmrAppShutDwn.Enabled := False;
  dlgFeeEdtr := TfrmFeeEdtrDlg.Create(self, tmrAppShutDwn.Interval - 60000);
  dlgFeeEdtr.ShowModal;
  dlgFeeEdtr.Free;
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.mnuItmExitClick(Sender: TObject);
begin
  Close;
end;

{ Date Pickers }

//procedure TfrmCntrctdExmMain.dtPckrExamFromChange(Sender: TObject);
//begin
//  ResetAppTmr;
//  edtDtPckrExamFrom.Text := DatetoStr(DtPckrExamFrom.Date);
//end;

procedure TfrmCntrctdExmMain.dtPckrExamFromExit(Sender: TObject);
var
  msg: String;
begin
  msg := '';
  ResetAppTmr;
//  { Check for Valid Date }
//  if (dtPckrExamFrom.IsDateValid) then
//  begin
//    if (dtPckrExamFrom.Date > dtPckrExamTo.Date) then
//      msg := 'From date cannot exceed the To date.' + #13#10 +
//           'Please enter a date on or before ' + DateTimeToStr(dtPckrExamTo.Date) + '.';
//  end
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrExamFrom.SetFocus;
//    dtPckrExamFrom.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
end;

//procedure TfrmCntrctdExmMain.dtPckrExamToChange(Sender: TObject);
//begin
//  ResetAppTmr;
//  edtDtPckrExamTo.Text := DatetoStr(DtPckrExamTo.Date);
//end;

procedure TfrmCntrctdExmMain.dtPckrExamToExit(Sender: TObject);
var
  msg: String;
begin
  msg := '';
  ResetAppTmr;
//  { Check for Valid Date }
//  if (dtPckrExamTo.IsDateValid) then
//  begin
//    if (dtPckrExamTo.Date < dtPckrExamFrom.Date) then
//      msg := 'To date cannot precede the From date.' + #13#10 +
//           'Please enter a date on or after ' + DateTimeToStr(dtPckrExamFrom.Date) + '.';
//  end
//  else
//    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
//         'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
//  if (Not SameText(msg, '')) then
//  begin
//    ShowMessageCAPRI(msg);
//    dtPckrExamTo.SetFocus;
//    dtPckrExamTo.SelectAll;
//  end;  { End Error Occured, display message and reset focus }
end;

procedure TfrmCntrctdExmMain.edtDtPckrExamFromChange(Sender: TObject);
begin
  // DONE: LMS redundant   ResetAppTmr;
  // DONE: LMS not used any more. edtDtPckrExamFrom.Text := DatetoStr(DtPckrExamFrom.Date);
  // DONE: LMS btnRfrshExamListClick(Application);

  // This is commented out because it causes other issues if it is called.
  // Basically, Get2507DsplyScreen in cls2507info.pas gets called with a blank
  // from date and displays an error.  So refreshing the display when the From
  // date changes causes more problems.  JRL 8/1/13
  //  btnRfrshExamListClick(Application);
  if IsDateValid(edtDtPckrExamFrom.Text) then btnRfrshExamListClick(Application); // DONE: LMS 8/7/13 validating date and other changes have fixed this problem
end;

procedure TfrmCntrctdExmMain.edtDtPckrExamFromExit(Sender: TObject);
var
  msg: String;
  s: string;
  MinDate: TDate;
begin
  msg := '';
  ResetAppTmr;
  // validate text input in date field
  s := edtDtPckrExamFrom.Text;
  MinDate := StrToDate('01/01/1900');
  DateComplete(s, MinDate, FALSE);
  edtDtPckrExamFrom.Text := s;
  if copy(edtDtPckrExamFrom.Text, 1, 4) = 'Min ' then
  begin
    edtDtPckrExamFrom.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrExamFrom.SetFocus;
  end;
  { Check for Valid Date Range}
  if IsDateValid(edtDtPckrExamFrom.Text) then
  begin
    if ((GetDateOfText(edtDtPckrExamFrom.Text, '1/1/1900'))
      > (GetDateOfText(edtDtPckrExamTo.Text, '1/1/2000'))) then
      msg := 'From date cannot exceed the To date.' + #13#10 +
        'Please enter a date on or before ' + edtDtPckrExamTo.Text + '.';
  end
  else
    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
      'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
  if (Not SameText(msg, '')) then
  begin
    ShowMessageCAPRI(msg);
    edtDtPckrExamFrom.SetFocus;
    edtDtPckrExamFrom.SelectAll;
  end;                                                                          { End Error Occured, display message and reset focus }
end;

procedure TfrmCntrctdExmMain.edtDtPckrExamToChange(Sender: TObject);
begin
  // DONE: LMS redundant ResetAppTmr;
  // DONE: LMS not used any more. edtDtPckrExamTo.Text := DatetoStr(DtPckrExamTo.Date);
  if IsDateValid(edtDtPckrExamTo.Text) then btnRfrshExamListClick(Application); // DONE: LMS 8/7/13 validating date and other changes have fixed the refresh problem
end;

procedure TfrmCntrctdExmMain.edtDtPckrExamToExit(Sender: TObject);
var
  msg: String;
  s: string;
  MinDate: TDate;
begin
  msg := '';
  ResetAppTmr;
  // validate text input in date field
  s := edtDtPckrExamTo.Text;
  MinDate := StrToDate('01/01/2000');
  DateComplete(s, MinDate, FALSE);
  edtDtPckrExamTo.Text := s;
  if copy(edtDtPckrExamTo.Text, 1, 4) = 'Min ' then
  begin
    edtDtPckrExamTo.Text := '';
    ShowMessageCAPRI('Please select a more current date');
    edtDtPckrExamFrom.SetFocus;
  end;
  { Check for Valid Date }
  if IsDateValid(edtDtPckrExamTo.Text) then
  begin
    if ((GetDateOfText(edtDtPckrExamFrom.Text, '1/1/1900'))
      > (GetDateOfText(edtDtPckrExamTo.Text, '1/1/2000'))) then
      msg := 'From date cannot exceed the To date.' + #13#10 +
        'Please enter a date on or after ' + edtDtPckrExamFrom.Text + '.';
  end
  else
    msg := 'The date entered is invalid, please enter a valid date to continue.' + #13#10 +
      'Valid date format is: 1-2 digit Month / 1-2 digit Day / 2-4 digit year';
  if (Not SameText(msg, '')) then
  begin
    ShowMessageCAPRI(msg);
    edtDtPckrExamTo.SetFocus;
    edtDtPckrExamTo.SelectAll;
  end;                                                                          { End Error Occured, display message and reset focus }
end;

{ Buttons }

procedure TfrmCntrctdExmMain.btnSimulateVLERResultsClick(Sender: TObject);
begin
  application.ProcessMessages;
  // TODO -cNextRelease: LMS - Wait - Here look at an exam that's selected in the grid, for that make dummy data and send it back to VLER as manifest and also as Results. Always include one junk file instead of making live files.
end;

procedure TfrmCntrctdExmMain.btnSlctPtntClick(Sender: TObject);
begin
  ResetAppTmr;
  GetPatientInfo;
  Get2507Info;
  if ((_PtntInfo <> nil) and Assigned(_PtntInfo)) then                          // DONE: LMS should check for nil also. Otherwise "invalid pointer operation"
    ResetCntrctdPrcssBtns;
end;

procedure TfrmCntrctdExmMain.btnRfrshExamListClick(Sender: TObject);
begin
  ResetAppTmr;
  GetPatientInfo;                                                               // DONE: LMS Move all into FormCreate since patient context will never change for the life of the forms.
  Get2507Info;
  Display2507Info;
  ResetCntrctdPrcssBtns;                                                        { In case patient request info has changed }
end;

procedure TfrmCntrctdExmMain.btnDtPckrExamFromClick(Sender: TObject);
var
  ADate: TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    (*if frmMain.VocRehab.AddExam = TRUE then  // new exam - enforce no previous dates
       frmVRSelectDate.MinimumDate := Today
    else*)
    frmVRSelectDate.MinimumDate := StrToDate('01/01/1900');                     // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrExamFrom.Text, ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Today;
    frmVRSelectDate.ShowModal;
    edtDtPckrExamFrom.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrExamFrom) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TfrmCntrctdExmMain.btnDtPckrExamToClick(Sender: TObject);
var
  ADate: TDateTime;
  frmVRSelectDate: TfrmVRSelectDate;
begin
  frmVRSelectDate := TfrmVRSelectDate.Create(Application);
  try
    (*if frmMain.VocRehab.AddExam = TRUE then  // new exam - enforce no previous dates
       frmVRSelectDate.MinimumDate := Tomorrow
    else*)
    frmVRSelectDate.MinimumDate := StrToDate('01/01/2000');                     // editing - allow reasonable dates
    if TryStrToDate(edtDtPckrExamTo.Text, ADate) then
      frmVRSelectDate.calSelectDate.Date := ADate
    else
      frmVRSelectDate.calSelectDate.Date := Tomorrow;
    frmVRSelectDate.ShowModal;
    edtDtPckrExamTo.Text := frmVRSelectDate.SelectedDate;
  finally
    FreeAndNil(frmVRSelectDate);
  end;
  if (ActiveControl = edtDtPckrExamTo) then
    SelectNext(ActiveControl as TWinControl, TRUE, TRUE);
end;

procedure TfrmCntrctdExmMain.btnNewExamClick(Sender: TObject);
begin
  application.ProcessMessages;
  CheckOutExam(False);
end;

procedure TfrmCntrctdExmMain.btnResendExamClick(Sender: TObject);
begin
  application.ProcessMessages;
  CheckOutExam(True);
end;

{Not used.. available if needed in the future
procedure TfrmCntrctdExmMain.AttemptToSetInProcessManifestsOpenTList(lstFilesVLER: TList);
var
  lstIx: Integer;
  aStrList : TStringList;
begin
  aStrList := TStringList.Create;
  aStrList.Sorted := true;
  aStrList.Duplicates := dupIgnore;

  for lstIx := lstFilesVLER.Count - 1 downto 0 do begin
    aStrList.Add(TVlerResultFileInfo(lstFilesVLER[lstIx]).ManifestObjectId);
  end;
  AttemptToSetInProcessManifestsOpenTStringList(aStrList);
end;
}

procedure TfrmCntrctdExmMain.AttemptToSetInProcessManifestsOpenTStringList(aStrList: TStringList);
var
  lstIx: Integer;
  excepMsg: string;
begin
  if aStrList.Count > 0 then
  begin
    TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);
    for lstIx := aStrList.Count - 1 downto 0 do
    try
      frmvlerCCRExams.SetManifestStatus(aStrList[lstIx], 'Open', 'InProcess');
    except
      on Excp: Exception do begin
        excepMsg := 'Error: ' + Excp.message + '.'
          + #13#10 + 'Error occurred while attempting to reset a Manifest Notification status back to "Open".'
          + #13#10 + 'Please report the following ManifestObjectId to support -> ' + aStrList[lstIx] // + ''
          + #13#10 + '**** Failure to report this error with the exact ID above will cause one or more'
          + #13#10 + 'exam results from Vendor to never get processed! Please also note the Patient ID.****'
          ;
        ShowMessageCAPRI(excepMsg);
      end;
    end;
    // done: lms - if there is an error in the setting, we don't trap/handle it. If a manifest remains INProcess too long VLER is supposed to alerts us.
  end;
end;

procedure TfrmCntrctdExmMain.btnCheckInExamClick(Sender: TObject);
  procedure RemoveLocalConFromExams(slExams, slExamsNoLocalCon: TStringList);
  var
    examNum: integer;
  begin
    slExamsNoLocalCon.clear;
    examNum := 0;
    while (examNum < slExams.count) do begin
      slExamsNoLocalCon.add(Piece(slExams[examNum], '-', 1, 4));
      inc(examNum);
    end;
  end;

  function dbgStrRconLstFiles(aObj: TList): String;
  var
    ix1: integer;
  begin
    Result := '';
    for ix1 := 0 to aObj.count - 1 do begin
      Result := Result + #$D + #$A + TElSftpFileInfo(aObj[ix1]).Name;
    end;
  end;

  function dbgStrRconLstVLERFiles(aObj: TList): String;
  var
    ix1: integer;
  begin
    Result := '';
    for ix1 := 0 to aObj.count - 1 do begin
      Result := Result + #$D + #$A + TVlerResultFileInfo(aObj[ix1]).FileName;
      if TVlerResultFileInfo(aObj[ix1]).ExamId <> '' then
        Result := Result + '-genMed-' + TVlerResultFileInfo(aObj[ix1]).ExamId;
    end;
  end;

  function CreateRConSubsetLstFiles(lstFilesVLER: TList; RCon: string): TList;
  var
    curConName: string;
    lstIx: Integer;
    aVlerResultFileInfo: TVlerResultFileInfo;
  begin
    curConName := GetContractorName(RCon);
    Result := TList.Create;
    lstIx := lstFilesVLER.Count - 1;
    while lstIx >= 0 do
    begin
      if piece(TVlerResultFileInfo(lstFilesVLER[lstIx]).FileName, '$', 2) = curConName then
      begin
        aVlerResultFileInfo := TVlerResultFileInfo.Create(nil);
        aVlerResultFileInfo.CopyFrom(TVlerResultFileInfo(lstFilesVLER[lstIx]));
        Result.Add(aVlerResultFileInfo);
        // copy items from lstFileVLER into Result that are for this contractor
        //lstFilesVLER.Delete(lstIx);        // not removing so, any that do not get processed, their manifests can be marked open again
      end;
      dec(lstIx);
    end;
  end;
var
  Reqsts, Rcon, locFileName: String;                                            // DONE: LMS split usage of X and F into new vars  , tmpDir, F, X: String;
  //oneFile : string;
  //oneExamCon : string;
  oneExamRcon: string;
  oneExamRconFile: string;
  CurExam, FileNum, idx: Integer;                                               // DONE: LMS replace i with CurExam for readability
//  slExamsFull,
  slExams, slExamsNoLocalCon, okFiles: TStringList;
  lstFiles, okObjLst: TList;
  SftpCon: TSFTPConn;
  VlerCon: TVLERConn;
  Done, VendorHasResults, AtLeastOneResultProcessed: Boolean;
  dbgStrRconObjLstFiles, dbgStrRconListFiles, dbgStrRconOkFiles: string;
  VLEREnabled: Boolean;
  curPat: string;
  curPatICN: string;
  VLERFetchDone: Boolean;
  lstFilesVLER: TList;
  dbgStrRconListFilesVLER: string;
  FullManifestList: TStringList;
  //curConName: string;
  //tmpDir: string;
  aObj: TObject;
begin
  curPat := '';
  VLEREnabled := false;
  VLERFetchDone := false;
  FullManifestList := nil;
  SftpCon := nil;
  VlerCon := nil;

  if not (IsProductionAccount(CCOWRPCBrkrMain) or
    TUserInfo.UserHasKey(CCOWRPCBrkrMain, 'ZJFW CONTRACTED EXM TEST'))
    then
  begin
    MessageDlgCAPRI('This functionality has been disabled on TEST accounts,' + #13#10 +
      'since the Broker Security Enhancements (BSE) used to reverse' + #13#10 +
      'lookup the Vendors SFTP information on CLAIMS is not readily supported.', mtWarning, [mbOK], 0);
    Exit;
  end;

  if Assigned(frmvlerCCRExams) then begin
    frmvlerCCRExams.Release;
    //application.processmessages;
    frmvlerCCRExams := nil
  end;

  if Assigned(frmvlerCCRExams) then begin
    frmvlerCCRExams.Release;
    //application.processmessages;
    frmvlerCCRExams := nil
  end;
  VendorHasResults := False;
  AtLeastOneResultProcessed := false;
  slExams := TStringList.Create;                                                // DONE : LMS no finally to ensure no memory leak
  slExamsNoLocalCon := TStringList.Create;
  okFiles := TStringList.Create;
  okObjLst := TList.Create;
  tmrAppShutDwn.Enabled := False;
  try
    StatusMsg('Searching for referred requests');
    { Ensure Patient Still has available requests since putting into context }
    if (HasRequests(fmLstrReq, Reqsts)) then
    begin
      if (GetExams(fmLstrExam, Reqsts, slExams)) then
      begin
        slExams.Sorted := True;                                                 // done: lms sort by REMOTE vendor.
        RemoveLocalConFromExams(slExams, slExamsNoLocalCon);                    // DONE: LMS after adding "con" as 4th piece we can't match files to exams. Strip 4th piece out.

        CurExam := 0;
        Done := False;
        Rcon := 'FIRST';
        StatusMsg('Contacting vendors and DAS to retrieve results');
        repeat
          begin
            if (CurExam < slExams.Count) then begin
              oneExamRcon := Piece(slExams[CurExam], '-');
              // oneExamCon := Piece(slExams[CurExam], '-', 5);
            end else begin
              oneExamRcon := '';
              // oneExamCon := '';
              Done := True;
            end;
            if (CompareText(Rcon, oneExamRcon) <> 0) then                       { New remote connection }
            begin
              if (CompareText(Rcon, 'FIRST') <> 0) then                         { Not the first one }
              begin
                VLEREnabled := IsContractorVLEREnabled(RCon);                   // DONE: CodeCR570 LMS

                if VLEREnabled then begin
                  if (okFiles.Count > 0) then try
                      // VlerCon.DownloadFiles(okFiles);  // Download is already done
                    if ProcessFilesVLER(slExams, okFiles, okObjLst, Rcon) then  // DONE: LMS should return subset of okFiles that were processed. Changed the method so it only returns true when all files are processed without error.
                    begin
                      AtLeastOneResultProcessed := true;
                      // VlerCon.ArchiveFiles(okFiles);   // No archive operation through VLER.
                    end;
                  finally
                    VlerCon.Free;                                               { local temp and close vler con. It's non-intuitive but there's no memory leak }
                  end;
                end else begin
                  if (okFiles.Count > 0) then try
                    SftpCon.DownloadFiles(okFiles);                             { Download vendor results to }
                    if ProcessFilesSFTP(slExams, okFiles, okObjLst, Rcon) then  // DONE: LMS should return subset of okFiles that were processed. Changed the method so it only returns true when all files are processed without error.
                    begin
                      AtLeastOneResultProcessed := true;
                      // DONE: lms - redundant try SftpCon := TSFTPConn.Create(Rcon, False, CCOWRPCBrkrMain);
                      SftpCon.ArchiveFiles(okFiles);
                      // DONE: lms - redundant  finally SftpCon.Free; end;
                    end;
                  finally
                    SftpCon.Free;                                               { local temp and close ftp con. It's non-intuitive but there's no memory leak }
                  end;
                end;

                dbgStrRconOkFiles := Rcon + '^' + okfiles.text;                 // DONE: LMS temp: - no - here make var "last Rcon"+okfiles.text  // TElSftpFileInfo(okObjLst[0]).Name
                btnRfrshExamListClick(Self);
                Application.ProcessMessages;                                    // DONE: LMS allow timers to do their work.
                okFiles.Clear;
                okObjLst.Clear;
              end;
              if (Length(oneExamRcon) = 0) then
                Break;                                                          // jltp 18-jan-2013 Break or Exit? DONE: LMS - definitely break;
              Rcon := oneExamRcon;
              if (CompareText(Rcon, '0') = 0) then                              // No vendor or invalid vendor
              begin
                while (CompareText(Rcon, '0') = 0) and (CurExam < slExams.Count) do
                begin
                  Inc(CurExam);
                  oneExamRcon := Piece(slExams[CurExam], '-');
                  Rcon := oneExamRcon;
                end;
  //              Continue;
              end;

              VLEREnabled := IsContractorVLEREnabled(RCon);                     // DONE: CodeCR568 LMS

              if assigned(lstFiles) then                                        // DONE: LMS memory leak .. need to ensure all list items are freed.
                FreeAndNilListWithObjects(lstFiles);

              // Not needed anymore because EnsureBrokerConnected does it //  application.ProcessMessages;                   // DONE: LMS pending timers are causing problems in the class create because new RPCBroker instance creation does processmessages in between.
              if VLEREnabled then begin
                if not VLERFetchDone then begin
                  VLERFetchDone := true;
                  VlerCon := TVlerConn.Create(Rcon, True, CCOWRPCBrkrMain);
                  curPat := _PtntInfo.PatientSSN;                               //  GetExternalSSN;    All VLER exchanges will not use any formatting  // needs to match SSN sent out in TExntdCntrctdBaseFormNewRsnd.SetPatientInfoInVlerXML
                  curPatICN := _PtntInfo.PatientICN;

                  try
                    TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);
                    //if not Assigned(frmvlerCCRExams) then
                      //Application.CreateForm(TfrmvlerCCRExams, frmvlerCCRExams);

                    lstFilesVLER := VlerCon.GetExamFileListForPatient(curPat, frmvlerCCRExams);
                    if lstFilesVLER.Count > 0 then begin
                      aObj := lstFilesVLER[0];
                      if (aObj is TStringList) then begin                       // Pop off the additional pointer added on top. This pointer is the Full list of manifests marked as InProcess.
                        FullManifestList := TStringList(aObj);
                        lstFilesVLER.Delete(0);
                      end;
                    end;
{$IFDEF CAPRIDEVELOPER}
                    frmvlerCCRExams.Visible := true;
                    frmvlerCCRExams.ShowModal;
{$ENDIF}
                  finally
{$IFDEF CAPRIDEVELOPER}
                    frmvlerCCRExams.ModalResult := mrOk;
{$ENDIF}
                    frmvlerCCRExams.close;
                  end;
                  dbgStrRconListFilesVLER := Rcon + '^' + dbgStrRconLstVLERFiles(lstFilesVLER); // DONE: lms temp TElSftpFileInfo(okObjLst[0]).Name
                end;
                lstFiles := CreateRConSubsetLstFiles(lstFilesVLER, Rcon);
                dbgStrRconListFiles := Rcon + '^' + dbgStrRconLstVLERFiles(lstFiles); // DONE: lms temp TElSftpFileInfo(okObjLst[0]).Name one contractor specific items
              end else begin
                SftpCon := TSFTPConn.Create(Rcon, True, CCOWRPCBrkrMain);
                //SetContractorVLEREnabledAndName(RCon, SftpCon.VLEREnabled);  // Save value for future use so don't have to go to server each time.

                lstFiles := SftpCon.GetFileDirContents;
                dbgStrRconListFiles := Rcon + '^' + dbgStrRconLstFiles(lstFiles); // DONE: lms temp TElSftpFileInfo(okObjLst[0]).Name
              end;
            end;

            FileNum := 0;
            if VLEREnabled then begin
              while (FileNum < lstFiles.Count) do
              begin
                locFileName := TVlerResultFileInfo(lstFiles[FileNum]).FileName;
                oneExamRconFile := Rcon + '-' + Piece(Piece(locFileName, '$', 1), '-', 1, 3);
                idx := slExamsNoLocalCon.IndexOf(oneExamRconFile);
                if (idx >= 0) then
                begin
                  VendorHasResults := True;
                  //oneFile := TVlerResultFileInfo(lstFiles[FileNum]).FileName;
                  okFiles.Add('VLER^' + GetTempExmDir(CCOWRPCBrkrMain.User.DUZ) {tmpDir} + '\' + locFileName {oneFile}); // unnecessary variable
                  okObjLst.Add(lstFiles[FileNum]);                              // ** NOTE: Full TVlerResultFileInfo object is being referenced.
                end;
                Inc(FileNum);
              end;
              dbgStrRconObjLstFiles := Rcon + '^' + dbgStrRconLstVLERFiles(okObjLst); // DONE: LMS temp : here add a function to return okObjList contents as String
            end else begin
              while (FileNum < lstFiles.Count) do
              begin
                locFileName := TElSftpFileInfo(lstFiles[FileNum]).Name;
                oneExamRconFile := Rcon + '-' + Piece(locFileName, '-', 1, 3);
                idx := slExamsNoLocalCon.IndexOf(oneExamRconFile);
                if (idx >= 0) then
                begin
                  VendorHasResults := True;
                  //oneFile := TElSftpFileInfo(lstFiles[FileNum]).Name;
                  okFiles.Add(SftpCon.AbsPath(locFileName {oneFile}) + '^' + GetTempExmDir(CCOWRPCBrkrMain.User.DUZ) {tmpDir} + '\' + locFileName {oneFile});
                  okObjLst.Add(lstFiles[FileNum]);
                end;
                Inc(FileNum);
              end;
              dbgStrRconObjLstFiles := Rcon + '^' + dbgStrRconLstFiles(okObjLst); // DONE: LMS temp : here add a function to return okObjList contents as String
            end;
            while ((CurExam < slExams.Count) and (Piece(slExams[CurExam], '-') = Rcon)) do
              Inc(CurExam);
          end;                                                                  // redundant block
        until (Done);
        if (not VendorHasResults) then
        begin
          StatusMsg('');
          ShowMessage('No Vendor(s) have results ready for this patient.');     // DONE: LMS More accurate message text.
          //Exit;  // DONE: LMS was causing memory losses
        end else if (AtLeastOneResultProcessed) then begin
          StatusMsg('');
//          ShowMessage('Vendor(s) Exam Results have been processed for this patient.'); // DONE: LMS More accurate message text.
          ShowMessage('Vendor Exam Results have been downloaded for this patient.'); // CodeCR730 rpk 6/2/2015
          //Exit;
        end;
        if FullManifestList <> nil then
        try
          AttemptToSetInProcessManifestsOpenTStringList(FullManifestList);      // reset any there weren't set to closed back to open
        except
        end;
      end;
    end                                                                         { End If Patient Still has available requests }
    else
    begin
      StatusMsg('');
      ShowMessage('There are no pending results for this patient.');
    end;
  finally
    ResetAppTmr;
    slExams.Free;
    slExamsNoLocalCon.Free;
    okFiles.Free;
    OkObjLst.Free;

    if lstFiles <> nil then                                                     // DONE: LMS memory leak .. need to ensure all list items are freed.
      FreeAndNilListWithObjects(lstFiles);

    if lstFilesVLER <> nil then
      {try
        AttemptToSetInProcessManifestsOpenTList(lstFilesVLER);  // not needed now. Unprocessed items on FullManifestList handles it.
      finally}
      FreeAndNilListWithObjects(lstFilesVLER);                                  // some objects may have already been freed from previous lstFiles free calls. clear out all that didn't get processed.
      {end;}

    if FullManifestList <> nil then
    try
      FreeAndClearTStrings(FullManifestList);
        //FullManifestList.Free;             // FreeAndNilListWithObjects(lstFilesVLER);
    except
    end;
  end;
end;

function TfrmCntrctdExmMain.ProcessFilesSFTP(slEx, slOk: TStringList; olOk: TList; Rcon: String): Boolean;
var
  locFileName, locFilePath, ReqIen, ExamIen, ExamRef, ExTypPtr, X, U, Con: String; // Con
  DtSent, DtRcvd, DtCmplt, ExTyp, Status, OrigExam, ResultStub, ExamReq: String;
  vFileDate: TDateTime;
  slResults, slOurExams: TStringList;
  i, e: Integer;
  fmExamGets: TFMGets;
  ReqOk, SameVendor, ReqAllDone: Boolean;
  ExamVendorTemp, LastFailedExamCon: string;
  DtRcvdF, DtSentF, DtCmpltF: Double;
begin
  Result := False;
  //Con := '0';
  U := '^';

  (*i := 0;
  while (i < slContractors.Count) do
  begin  // Use Remote Contractor IEN to find Local Contractor IEN
    if (CompareText(Piece(slContractors[i], U, 2), Rcon) = 0) then begin
      Con := Piece(slContractors[i], U);
      break;  // TODO: LMS Are we getting the right Local vendor?  -- no guarantee, we might get a different local for the same remote contractor
    end;
    Inc(i);
  end;
  *)

  slResults := TStringList.Create;                                              // DONE: LMS memory leak in case of exceptions.
  slOurExams := TStringList.Create;
  fmExamGets := TFMGets.Create(nil);
  try
    fmExamGets.RPCBroker := CCOWRPCBrkrMain;
    fmExamGets.FileNumber := '396.4';                                           // Exam file
    fmExamGets.FieldNumbers.Add('.02');                                         // Exam Request
    fmExamGets.FieldNumbers.Add('.03');                                         // Exam type
    fmExamGets.FieldNumbers.Add('.04');                                         // Exam status
    fmExamGets.FieldNumbers.Add('90');                                          // Date tx complete  // DONE: LMS CodeCR533 we probably should not be using this field.. only 102 (or 102I?)
    fmExamGets.FieldNumbers.Add('100');                                         // Vendor
    fmExamGets.FieldNumbers.Add('101');                                         // Date sent
    fmExamGets.FieldNumbers.Add('102');                                         // Date Results returned

    ResultStub := '';

    i := 0;
    while (i < slOk.Count) do
    begin
      locFilePath := Piece(slOk[i], U, 2);
      slResults.LoadFromFile(locFilePath);
      slOurExams.clear;                                                         // DONE: LMS SQA55 otherwise processing exams from prior loop.
      vFileDate := TElSftpFileInfo(olOk[i]).Attributes.CTime;
      if vFileDate < TElSftpFileInfo(olOk[i]).Attributes.MTime then             // DONE: LMS CodeCR524 Some servers return MTime and not CTime.
        vFileDate := TElSftpFileInfo(olOk[i]).Attributes.MTime;

      if vFileDate < TElSftpFileInfo(olOk[i]).Attributes.CATime then            // DONE: LMS CodeCR524 Picking the largest date of all as date when vendor provided us the exam results.
        vFileDate := TElSftpFileInfo(olOk[i]).Attributes.CATime;

      locFileName := TElSftpFileInfo(olOk[i]).Name;
      ReqIen := Piece(locFileName, '-', 2);
      OrigExam := Piece(locFileName, '-', 3);

      ReqOk := True;
      ReqAllDone := True;

      for e := 0 to slEx.Count - 1 do                                           // DONE: LMS changed the loop structure to make it more obvious and efficient
      begin
        X := Piece(slEx[e], '-', 2, 4);
        ExamIen := Piece(X, '-', 3);
        Con := Piece(slEx[e], '-', 5);                                          // DONE: LMS also get the local contractor - NOT NEEDED
        if (CompareText(Piece(X, '-', 2), ReqIen) = 0) then
        begin
          fmExamGets.IENS := ExamIen;
          fmExamGets.GetData;
          ExamRef := fmExamGets.GetField('.01').FMDBInternal;
          ExamReq := fmExamGets.GetField('.02').FMDBInternal;                   // DONE: LMS (see above) if ExamReq and ReqIen match then continue
          ExTypPtr := fmExamGets.GetField('.03').FMDBInternal;
          if (CompareText(ExamIen, OrigExam) = 0) then                          // DONE: SQA55 LMS Exam results from different requests are getting posted. See above, clearing slOurExams
          begin
            ResultStub := fmExamGets.GetField('.03').FMDBExternal;              // DONE: LMS This just gets a Result Stub ready in case there are exams in this request other than the file that was received. The stub should be used only for those "multiple" exams that were sent in one request and aren't the "primary" exam used to send results back.
            ResultStub := 'Please refer to the exam report contained in ' + ResultStub;
          end;
          Status := fmExamGets.GetField('.04').FMDBInternal;
          DtCmplt := fmExamGets.GetField('102').FMDBInternal;                   // // DONE: LMS CodeCR533 Changed field 90 to 102.  See updatevista method.
          ExamVendorTemp := fmExamGets.GetField('100').FMDBInternal;            // DONE: LMS putting val in var to be able to access during debug
          // DONE: LMS - Here Con and ExamVendorTemp should be the same
          ExamVendorTemp := GetRemoteConIen(ExamVendorTemp);                    // DONE: LMS Field 100 is local contractor. Translate local contractor to remote contractor.

          SameVendor := (CompareText(ExamVendorTemp, RCon) = 0);                // DONE: LMS now the value of Con should accurately reflect the value in the exam.
          if ((not SameVendor) and (CompareText(Status, 'C') <> 0)) then
            ReqAllDone := False;
          DtSent := fmExamGets.GetField('101').FMDBInternal;
          DtRcvd := fmExamGets.GetField('102').FMDBInternal;

          DtRcvdF := HorologDateStringToDouble(DtRcvd);                         // DONE: LMS CodeCR568 - Fixed Date handling.
          DtSentF := HorologDateStringToDouble(DtSent);
          DtCmpltF := HorologDateStringToDouble(DtCmplt);

          if (SameVendor and (CompareText(ReqIen, ExamReq) = 0)) then
          begin
            slOurExams.Add('-' + ReqIen + '-' + ExamIen + '-' + ExamRef + '-' + ExTypPtr);
            if (((Length(DtCmplt) > 0) and (Int(DtCmpltF) > Int(DtSentF)))      // DONE: LMS - Transcription Complete not null, or Completed after sent (instead of completed before sent), i.e. in case of reject
              or
              ((not (Length(DtSent) > 0) and (Length(DtRcvd) = 0)))             // If not (sent but not rcvd)
              )
              then begin
              ReqOk := False;
              LastFailedExamCon := Con;
              break;
            end;
            (*if (not (Length(DtSent) > 0) and  // If not (sent) and rcvd
              (Length(DtRcvd) = 0)) then
                ReqOk := False;*)
          end;
        end;
        //Inc(e);
      end;
      if (not ReqOk) then
      begin
        ShowMessage(GetReqErrMsg(ReqIen, LastFailedExamCon));                   // DONE: LMS analyze impact of waiting on dialog for FTP timeout and then archive files fails. FTP now automatically reconnects, so archive will not fail.
        StatusMsg('');
        Result := false;                                                        // DONE: LMS corrected missing result set
        // Break; //Exit;  // DONE: LMS code was messed up
      end else begin                                                            // Everything is good, update Vista
        // Extracted to a function.. though I think the code below is not correct.
        //X := FormatDateTime('yyyy', vFileDate);
        //X := IntToStr(StrToInt(X) - 1700);
        //X := X + FormatDateTime('MMdd.HHmm', vFileDate);
        //while (RightStr(X, 1) = '0') do
        //  X := LeftStr(X, Length(X) - 1);

        GetFMInternalDateFromDateTime(X, vFileDate);
        // Below lines are two other options.
        // X := DelphiDateToFMInternal(vFileDate);   // can't use  this.. it doesn't do seconds part of the horolog value
        // X := DelphiDateTimeToHorolog(vFileDate);

        ExamIen := Piece(locFileName, '-', 3);
        Result := UpdateVistaSFTP(slResults, slOurExams, ReqIen, ExamIen, X, ResultStub, ReqAllDone);
      end;
      If not Result then break;                                                 // DONE: LMS don't update any more if there is a problem
      Inc(i);
    end;
  finally
    slResults.Free;
    slOurExams.Free;
    fmExamGets.Free;
  end;
end;

function TfrmCntrctdExmMain.UpdateVistaSFTP(slResults, slOurExams: TStringList; ReqIen,
  ExamIen, IntResDt, ResultStub: String; ReqAllDone: Boolean): Boolean;
var
  ResultsMemo: TFMMemo;
  ResultsFiler, ReqFiler: TFMFiler;
  ExamRef, ExamTypPtr, X: String;
  i: Integer;
  FirstOne: Boolean;
begin
  Result := True;
  ResultsMemo := TFMMemo.Create(nil);                                           // DONE: LMS all these creates don't pair with finally. Possible memory leak.
  ResultsMemo.ParentWindow := frmCntrctdExmMain.Handle;
  ResultsFiler := TFMFiler.Create(nil);
  ReqFiler := TFMFiler.Create(nil);

  try
    // DONE: LMS - no - non existing member of class.. what functionality is lost?
    ResultsFiler.RPCBroker := CCOWRPCBrkrMain;
    ReqFiler.RPCBroker := CCOWRPCBrkrMain;

    ResultsFiler.FilerFlags := [ffLock];
    ResultsFiler.FilerOptions := [foProcessProblemList];
    ReqFiler.FilerFlags := [ffLock];
    ReqFiler.FilerOptions := [foProcessProblemList];

    ResultsMemo.FMFiler := ResultsFiler;
    ResultsMemo.FMFile := '396.4';
    ResultsMemo.FMField := '70';
    ResultsMemo.IENS := ExamIen;
    ResultsMemo.FMMemoStyle := msByLines;                                       // DONE: LMS Contractor supplied results were getting wrapped.
    ResultsMemo.Lines := slResults;
    ResultsMemo.FMModified := True;
    ResultsFiler.AddChgdControl(ResultsMemo);
    if ResultsFiler.Update then
      StatusMsg('Results filed under exam #' + ExamIen)
    else begin
      ResultsFiler.DisplayErrors;
      Result := False;
    end;
    i := 0;
    while (i < slOurExams.Count) do
    begin
      X := Piece(slOurExams[i], '-', 3);
      ResultsMemo.IENS := X;
      ExamRef := Piece(slOurExams[i], '-', 4);
      ExamTypPtr := Piece(slOurExams[i], '-', 5);
      FirstOne := (CompareText(X, ExamIen) = 0);
      if (not FirstOne) then
      begin
        ResultsMemo.Lines.Clear;
        ResultsMemo.Lines.Add(ResultStub);
        ResultsFiler.AddChgdControl(ResultsMemo);
        if ResultsFiler.Update then
          StatusMsg('Results stub message for exam ' + X + ' filed')
        else begin
          ResultsFiler.DisplayErrors;
          Result := False;
        end;
      end;
      ResultsFiler.AddFDA('396.4', X + ',', '.01', ExamRef);
      ResultsFiler.AddFDA('396.4', X + ',', '.03', ExamTypPtr);
      ResultsFiler.AddFDA('396.4', X + ',', '.04', 'C');

      // ResultsFiler.AddFDA('396.4', X + ',', '90', IntResDt);  // DONE: LMS CodeCR533 Commenting this line out because updating this field is being seen as setting that the exam is "Transcribed"Date" and as a result not allowed to "auto-release". See code referring to field 90 in tiusign.pas and uncosignedutility.pas units... also see referred code section below.
                                                                       //    further.. nowhere in the production demtran version 1.3.2.6 source code did I find a reference to field 90
             (*
                if FMGetsExamInfo.GetField('90').FMDBExternal <> '' then
                  Transcribed := True;
             *)
             // below line updating 102 is already there. Will point references to 90 to use 102 instead. One reference is in managereportsCCR.pas  .. see below
             (*
             FMfiler1.AddFDA('396.4', whichIEN, '.90', '');
             *)
             // 102I is being labeled Date received from contractor. How's that different from 102

      ResultsFiler.AddFDA('396.4', X + ',', '102', IntResDt);
      ResultsFiler.AddFDA('396.4', X + ',', '73', '@');                         // 396.4,73      XML DAS CONFIRMATION   4;1 FREE TEXT.  "Description: This is the DAS status confirmation returned by VLER DAS.". Storing DAS result object id here for VLER only. Clearing for SFTP
      if ResultsFiler.Update then
        StatusMsg('Fields updated for exam #' + X)
      else begin
        ResultsFiler.DisplayErrors;
        Result := False;
      end;
      Inc(i);
    end;

    if (ReqAllDone) then
    begin
      ReqFiler.AddFDA('396.3', ReqIen, '17', 'P');
      if ReqFiler.Update then begin
        StatusMsg('Request #' + ReqIen + 'updated.');
      end else begin
        ReqFiler.DisplayErrors;
        Result := False;
      end;
    end;

    // StatusMsg('');
  finally
    ResultsMemo.Free;
    ResultsFiler.Free;
    ReqFiler.Free;
  end;
  // Result := True;       // DONE: LMS only if successful! Added lines above in method to appropriately return value.
end;

function TfrmCntrctdExmMain.ProcessFilesVLER(slExams, okFiles: TStringList; olOk: TList; Rcon: String): Boolean;
var
  fileIX, eX: Integer;
  slResults, slOurExams: TStringList;
  fmExamGets: TFMGets;
  locFileName, locFilePath, FileReqIen, ExamIen, ExamRef, ExTypPtr, intVendResultDate, anExamID, U, Con: String; // Con
  DtSent, DtRcvd, DtCmplt, ExTyp, Status, FileExam, ResultStub, ExamReq: String;
  vFileDate: TDateTime;
  ReqOk, SameVendor, ReqAllDone: Boolean;
  LocalContractorID, LastFailedExamCon: string;
  DtRcvdF, DtSentF, DtCmpltF: Double;
  IdDateTimeStamp1: TIdDateTimeStamp;
  //vFileTimeStamp: string;
  VLERResultObjID: string;
  VLERExamName: string;
  VLERManifObjID: string;
  ManifInProcessList: TStringList;
  ixManif: Integer;
  ExamName: string;
  newExamIen: string;
  //NewExamType: string;
  ExamTypeName: string;
  RemoteContractor: string;
  //genMedExam: string;
  ExamReqID: string;
begin
 // DONE: LMS CodeCR570
  Result := False;
  U := '^';

  ManifInProcessList := TStringList.Create;
  ManifInProcessList.Sorted := true;
  ManifInProcessList.Duplicates := dupIgnore;

  slResults := TStringList.Create;                                              // DONE: LMS memory leak in case of exceptions.
  slOurExams := TStringList.Create;
  fmExamGets := TFMGets.Create(nil);
  try
    fmExamGets.RPCBroker := CCOWRPCBrkrMain;
    fmExamGets.FileNumber := '396.4';                                           // Exam file
    fmExamGets.FieldNumbers.Add('.02');                                         // Exam Request
    fmExamGets.FieldNumbers.Add('.03');                                         // Exam type
    fmExamGets.FieldNumbers.Add('.04');                                         // Exam status
    fmExamGets.FieldNumbers.Add('90');                                          // Date tx complete  // DONE: LMS CodeCR533 we probably should not be using this field.. only 102 (or 102I?)
    fmExamGets.FieldNumbers.Add('100');                                         // Vendor
    fmExamGets.FieldNumbers.Add('101');                                         // Date sent
    fmExamGets.FieldNumbers.Add('102');                                         // Date Results returned

    ResultStub := '';

    fileIX := 0;
    while (fileIX < okFiles.Count) do
    begin
      //genMedExam := '';
      locFilePath := Piece(okFiles[fileIX], U, 2);
      // VLERResultObjID := Piece(okFiles[fileIX], U, 3);
      // slResults.LoadFromFile(locFilePath);    // done : lms : move right before UpdateVLER for optimization
      slOurExams.clear;                                                         // DONE: LMS SQA55 otherwise processing exams from prior loop.

      {
      Actual File name is formatted like so..
              Result := vler_ExamIdNode.Text
                          + '$' + vler_PhysicalSourceNode.Text
                          + '$' + StringReplace(vStatusDate,':','#',[rfReplaceAll])  // fileDateTime ":" won't save on disk
                          + '.txt';
      }

      // TODO 3: LMS **** Here do okFile[i] and olOk[i] belong to same exam? They should..
      //vFileTimeStamp := TVlerResultFileInfo(olOk[fileIX]).FileDateTimeStr;
      vFileDate := TVlerResultFileInfo(olOk[fileIX]).FileDateTime;

      //ConvertVLERFileTimeToDateTime(vFileDate, vFileTimeStamp);

      locFileName := TVlerResultFileInfo(olOk[fileIX]).FileName;                // ** NOTE: olOk has the full TVlerResultFileInfo object
      VLERResultObjID := TVlerResultFileInfo(olOk[fileIX]).ExamResultObjectId;
      VLERExamName := TVlerResultFileInfo(olOk[fileIX]).ExamName;

      VLERManifObjID := TVlerResultFileInfo(olOk[fileIX]).ManifestObjectId;
      ManifInProcessList.Add(VLERManifObjID);

      FileReqIen := Piece(locFileName, '-', 2);
      FileExam := Piece(locFileName, '-', 3);
      FileExam := Piece(FileExam, '$');

      ReqOk := True;
      ReqAllDone := True;

      //eX := fileIX;

      newExamIen := '';

      for eX := 0 to slExams.Count - 1 do                                       // TODO 3: LMS for VLER it doesn't need to be a loop
      begin
        anExamID := Piece(slExams[eX], '-', 2, 4);
        ExamIen := Piece(anExamID, '-', 3);
        if (CompareText(ExamIen, FileExam) <> 0) then                           // only process this one exam ID, including genmed
        begin
          continue;
        end;
        Con := Piece(slExams[eX], '-', 5);                                      // DONE: LMS - not needed - also get the local contractor.
        ExamReqID := Piece(anExamID, '-', 2);
        if (CompareText(ExamReqID, FileReqIen) = 0) then
        begin
          fmExamGets.IENS := ExamIen;
          fmExamGets.GetData;

          ExamTypeName := fmExamGets.GetField('.03').FMDBExternal;
          LocalContractorID := fmExamGets.GetField('100').FMDBInternal;
          DtSent := fmExamGets.GetField('101').FMDBInternal;

          // DONE: LMS If Exam Name doesn't match the existing exam in the result, then it is GENMED scenario. In that case we create a new Exam Record.
          if uppercase(VLERExamName) <> uppercase(ExamTypeName) then
          begin
            newExamIen := CreateNewExamSentByVendor(ExamReqID, VLERExamName, LocalContractorID, DtSent);

            ExamIen := piece(newExamIen, '^');                                  // second piece is for future use only.
            TVlerResultFileInfo(olOk[fileIX]).ExamId := piece(anExamID, '-', 1, 2) + '-' + ExamIen;
            fmExamGets.IENS := ExamIen;                                         // piece(newExamIen,'^');         // move fmExamGets to new exam
            fmExamGets.GetData;
            // ExTypPtr := NewExamType; // VLERExamName; // fmExamGets.GetField('.03').FMDBInternal;
          end;

          ExamRef := fmExamGets.GetField('.01').FMDBInternal;                   // temp: does this match piece 2 of the return above
          ExamReq := fmExamGets.GetField('.02').FMDBInternal;                   // DONE: LMS (see above and below) if ExamReq and ReqIen match then continue
          ExTypPtr := fmExamGets.GetField('.03').FMDBInternal;

          //LocalContractorID := fmExamGets.GetField('100').FMDBInternal;  // temp

          //Not relevant for VLER
          {if (CompareText(ExamIen, OrigExam) = 0) then            // DONE: SQA55 LMS Exam results from different requests are getting posted. See above, clearing slOurExams
          begin
            //ResultStub := fmExamGets.GetField('.03').FMDBExternal;     // DONE: LMS This just gets a Result Stub ready in case there are exams in this request other than the file that was received. The stub should be used only for those "multiple" exams that were sent in one request and aren't the "primary" exam used to send results back.
            //ResultStub := 'Please refer to the exam report contained in ' + ResultStub;
          end;}

          Status := fmExamGets.GetField('.04').FMDBInternal;

          DtCmplt := fmExamGets.GetField('102').FMDBInternal;                   // // DONE: LMS CodeCR533 Changed field 90 to 102.  See updatevista method.

          // moved prior to Genmed ExamVendorTemp := fmExamGets.GetField('100').FMDBInternal;   // DONE: LMS putting val in var to be able to access during debug

          // DONE: LMS - Here Con and ExamVendorTemp should be the same
          RemoteContractor := GetRemoteConIen(LocalContractorID);               // DONE: LMS Field 100 is local contractor. Translate local contractor to remote contractor.

          SameVendor := (CompareText(RemoteContractor, RCon) = 0);              // DONE: LMS now the value of Con should accurately reflect the value in the exam.

          if ((not SameVendor) and (CompareText(Status, 'C') <> 0)) then
            ReqAllDone := False;

          // moved prior to Genmed DtSent := fmExamGets.GetField('101').FMDBInternal;
          DtRcvd := fmExamGets.GetField('102').FMDBInternal;

          DtRcvdF := HorologDateStringToDouble(DtRcvd);                         // DONE: LMS CodeCR568 - Fixed Date handling.
          DtSentF := HorologDateStringToDouble(DtSent);
          DtCmpltF := HorologDateStringToDouble(DtCmplt);

          if (SameVendor and (CompareText(FileReqIen, ExamReq) = 0)) then
          begin
            slOurExams.Add('-' + FileReqIen + '-' + ExamIen + '-' + ExamRef + '-' + ExTypPtr);

            if (((Length(DtCmplt) > 0) and (Int(DtCmpltF) > Int(DtSentF)))      // DONE: LMS - Transcription Complete not null, or Completed after sent (instead of completed before sent), i.e. in case of reject
              or
              ((not (Length(DtSent) > 0) and (Length(DtRcvd) = 0)))             // If not (sent but not rcvd)
              )
              then begin
              ReqOk := False;
              LastFailedExamCon := Con;
            end;
            (*if (not (Length(DtSent) > 0) and  // If not (sent but not rcvd)
              (Length(DtRcvd) = 0)) then
                ReqOk := False;*)
          end;
          break;                                                                // Matched the exam to this file. No need to loop through the rest
        end;
        //Inc(e);
      end;
      if (not ReqOk) then
      begin
        ShowMessage(GetReqErrMsg(FileReqIen, LastFailedExamCon));               // DONE: LMS analyze impact of waiting on dialog for FTP timeout and then archive files fails. FTP now automatically reconnects, so archive will not fail.
        StatusMsg('');
        Result := false;                                                        // DONE: LMS corrected missing result set
        // Break; //Exit;   // DONE: LMS code was messed up
      end else begin
        // Everything is good, update Vista
        GetFMInternalDateFromDateTime(intVendResultDate, vFileDate);
        //if newExamIen = '' then begin
          //ExamIen := piece(newExamIen, '^',2);
        //end else begin
          //ExamIen := Piece(locFileName, '-', 3);
          //ExamIen := Piece(ExamIen, '$');
        //end;
        slResults.LoadFromFile(locFilePath);
        Result := UpdateVistaVLER(slResults, slOurExams, FileReqIen, ExamIen, intVendResultDate, ResultStub, VLERResultObjID, ReqAllDone);
      end;
      If not Result then begin
        while ManifInProcessList.IndexOf(VLERManifObjID) > -1 do
          ManifInProcessList.Delete(ManifInProcessList.IndexOf(VLERManifObjID)); // this manifest is not processed completely.
        break;                                                                  // DONE: LMS don't update any more if there is a problem
      end;
      Inc(fileIX);
    end;
    if ManifInProcessList.Count > 0 then begin
      TfrmvlerCCRExams.EnsurefrmvlerCCRExamsReady(frmvlerCCRExams);
       {for all exams in ManifInProcessList}
{$IFNDEF CAPRIDEVELOPERLeosCode}                                                // not closing because we're not saving data to vista, so they can be reopened
      for ixManif := 0 to ManifInProcessList.Count - 1 do begin
        frmvlerCCRExams.SetManifestStatus(ManifInProcessList[ixManif], 'Closed', 'InProcess'); // todo : lms - wait - check return value and raise error if not successful. The error should be logged as well.
      end;
{$ENDIF}
    end;
  finally
    slResults.Free;
    slOurExams.Free;
    fmExamGets.Free;
    ManifInProcessList.Free;
  end;
end;

function TfrmCntrctdExmMain.UpdateVistaVLER(slResults, slOurExams: TStringList; ReqIen,
  ExamIen, IntResDt, ResultStub, VLERResultObjID: String; ReqAllDone: Boolean): Boolean;
var
  ResultsMemo: TFMMemo;
  ResultsFiler, ReqFiler: TFMFiler;
  ExamRef, ExamTypPtr, X: String;
  i: Integer;
//  FirstOne: Boolean;
begin
  Result := True;
  ResultsMemo := TFMMemo.Create(nil);                                           // DONE: LMS all these creates don't pair with finally. Possible memory leak.
  ResultsMemo.ParentWindow := frmCntrctdExmMain.Handle;
  ResultsFiler := TFMFiler.Create(nil);
  ReqFiler := TFMFiler.Create(nil);

  try
    // DONE: LMS - NOT to do - non existing member of class.. what functionality is lost?
    application.processmessages;

    ResultsFiler.RPCBroker := CCOWRPCBrkrMain;
    ReqFiler.RPCBroker := CCOWRPCBrkrMain;

    ResultsFiler.FilerFlags := [ffLock];
    ResultsFiler.FilerOptions := [foProcessProblemList];
    ReqFiler.FilerFlags := [ffLock];
    ReqFiler.FilerOptions := [foProcessProblemList];

    ResultsMemo.FMFiler := ResultsFiler;
    ResultsMemo.FMFile := '396.4';
    ResultsMemo.FMField := '70';
    ResultsMemo.IENS := ExamIen;
    ResultsMemo.FMMemoStyle := msByLines;                                       // DONE: LMS Contractor supplied results were getting wrapped.
    ResultsMemo.Lines := slResults;
    ResultsMemo.FMModified := True;
    ResultsFiler.AddChgdControl(ResultsMemo);
    if ResultsFiler.Update then
      StatusMsg('Results filed under exam #' + ExamIen)
    else begin
      ResultsFiler.DisplayErrors;
      Result := False;
    end;
    i := 0;

    // DONE : LMS Here slOurExams[0] should have ExamIen. There should be no other exam in slOurExams

    // TODO : LMS slOurExam and all others are arrays but we
    //    need to call individual exams and update those. For now it's working but the loops should be removed for VLER. They only make sense for SFTP
    while (i < slOurExams.Count) do
    begin
      X := Piece(slOurExams[i], '-', 3);
      //ResultsMemo.IENS := X;
      ExamRef := Piece(slOurExams[i], '-', 4);                                  // should be same as ExamIen. Seems to be mis-named. all this code needs cleaning
      ExamTypPtr := Piece(slOurExams[i], '-', 5);
      {  SFTP only function
      FirstOne := (CompareText(X, ExamIen) = 0);
      if (not FirstOne) then   //  **** ??? TODO ???
      begin
        ResultsMemo.Lines.Clear;
        ResultsMemo.Lines.Add(ResultStub);
        ResultsFiler.AddChgdControl(ResultsMemo);
        if ResultsFiler.Update then
          StatusMsg('Results stub message for exam ' + X + ' filed')
        else begin
          ResultsFiler.DisplayErrors;
          Result := False;
        end;
      end;
      }
      ResultsFiler.AddFDA('396.4', X + ',', '.01', ExamRef);
      ResultsFiler.AddFDA('396.4', X + ',', '.03', ExamTypPtr);
      ResultsFiler.AddFDA('396.4', X + ',', '.04', 'C');                        // Completed

      // ResultsFiler.AddFDA('396.4', X + ',', '90', IntResDt);  // DONE: LMS CodeCR533 Commenting this line out because updating this field is being seen as setting that the exam is "Transcribed"Date" and as a result not allowed to "auto-release". See code referring to field 90 in tiusign.pas and uncosignedutility.pas units... also see referred code section below.
                                                                       //    further.. nowhere in the production demtran version 1.3.2.6 source code did I find a reference to field 90
             (*
                if FMGetsExamInfo.GetField('90').FMDBExternal <> '' then
                  Transcribed := True;
             *)
             // below line updating 102 is already there. Will point references to 90 to use 102 instead. One reference is in managereportsCCR.pas  .. see below
             (*
             FMfiler1.AddFDA('396.4', whichIEN, '.90', '');
             *)
             // 102I is being labeled Date received from contractor. How's that different from 102

      ResultsFiler.AddFDA('396.4', X + ',', '102', IntResDt);
      ResultsFiler.AddFDA('396.4', X + ',', '73', VLERResultObjID);             // 396.4,73      XML DAS CONFIRMATION   4;1 FREE TEXT.  "Description: This is the DAS status confirmation returned by VLER DAS.". Storing DAS result object id here for later use, in case of reject.
      if ResultsFiler.Update then
        StatusMsg('Fields updated for exam #' + X)
      else begin
        ResultsFiler.DisplayErrors;
        Result := False;
      end;
      Inc(i);
    end;

    if (ReqAllDone) then
    begin
      ReqFiler.AddFDA('396.3', ReqIen, '17', 'P');
      if ReqFiler.Update then begin
        StatusMsg('Request #' + ReqIen + 'updated.');
      end else begin
        ReqFiler.DisplayErrors;
        Result := False;
      end;
    end;

    // StatusMsg('');
  finally
    ResultsMemo.Free;
    ResultsFiler.Free;
    ReqFiler.Free;
  end;
  // Result := True;       // DONE: LMS only if successful! Added lines above in method to appropriately return value.
end;

function TfrmCntrctdExmMain.GetReqErrMsg(ReqIen, Con: String): String;
var
  fmReqGets, fmConGets: TFMGets;
  ConName, CRLF: String;
begin
  CRLF := Chr(13) + Chr(10);
  fmReqGets := TFMGets.Create(nil);
  fmReqGets.RPCBroker := CCOWRPCBrkrMain;
  fmReqGets.FileNumber := '396.3';
  fmReqGets.IENS := ReqIen;
  fmReqGets.AddField('.01');
  fmReqGets.AddField('1');
  fmReqGets.GetData;
  fmConGets := TFMGets.Create(nil);
  fmConGets.RPCBroker := CCOWRPCBrkrMain;
  fmConGets.FileNumber := '396.45';
  fmConGets.IENS := Con;
  fmConGets.AddField('.01');
  fmConGets.GetData;
  ConName := fmConGets.GetField('.01').FMDBExternal;
  Result := 'Request for ' + fmReqGets.GetField('.01').FMDBExternal +
    ', Req Date ' + fmReqGets.GetField('1').FMDBExternal + CRLF +
    ' for Vendor ' + ConName + ' is not appropriate for new results.' +
    CRLF + 'Please review this request manually.';
  fmReqGets.Free;
  fmConGets.Free;
end;

function TfrmCntrctdExmMain.HasRequests(ReqLstr: TFMLister; var Reqsts: String): Boolean;
var
//  iii,
  i: Integer;
//  AllowedStatuses: array[1..4] of string;
begin
  ReqLstr.PartList.Clear;
  ReqLstr.PartList.Add(_PtntInfo.PatientDFN);
  ReqLstr.FromList.Clear;
  ReqLstr.FromList.Add(_PtntInfo.PatientDFN);
  ReqLstr.Number := '5000';                                                     // arbiterary max.. a Patient can't have more than 5000 requests.

  ReqLstr.Screen := 'I +^(0)=' + _PtntInfo.PatientDFN +                         // done: LMS reintroduced the PatientDFN comparison to eliminate possibility of 20840 catching 208400 also.
    ',$P(^(0),U,18)]"","|P|N|NT|S|"[("|"_$P(^(0),U,18)_"|")';                   // done: lms why was it commented? Dunno!

  ReqLstr.ListerOptions := [loQuickList];
  ReqLstr.ListerFlags := [lfInternal];

  Reqsts := '|';
  ReqLstr.Results.Clear;
  ReqLstr.GetList(nil);
  if (ReqLstr.Results.Count > 0) then
  begin
    i := 0;
    while (i < ReqLstr.Results.Count) do
    begin
      Reqsts := Reqsts + ReqLstr.Results[i] + '|';
      Inc(i);
    end;
  end;

  Result := length(Reqsts) > 1;
end;

// DONE: LMS move into untMiscMthds as likely the most appropriate unit
(*
function TfrmCntrctdExmMain.IsDateValid(aDateStr: string): Boolean;
var
  aDate : TDateTime;
begin
  Result := TryStrToDate(aDateStr, aDate);
  (* DONE: LMS more efficient implementation
  try
    aDate := StrToDate(aDateStr);
    Result := true;
  except on e:exception do
    Result := false;
  end;
  *)(*
end;*)

function TfrmCntrctdExmMain.GetRemoteConIen(LocalContractor: String): string;   // slCon: TStringList): String; //DONE: LMS Made public so all CCR forms can lookup contractor list while "demtranmain" form is open as dialog. These should ONLY be used by forms that have their AOwner as demTranMain form.
var
  i: Integer;
begin
  if slContractors.Count = 0 then
    FillContractorsList;

  Result := '0';
  i := 0;
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^') = LocalContractor) then begin
      Result := Piece(slContractors[i], '^', 2);
      exit;
    end;
    Inc(i);
  end;
end;

procedure TfrmCntrctdExmMain.FillContractorsList;
var
  i: Integer;
begin
  // DONE: LMS Piece(CCOWRPCBrkrMain.User.Division, U, 3);
  fmLstrCntrcts.GetList(slContractors);
  i := 0;
  while (i < slContractors.Count) do
  begin
    slContractors[i] := fmLstrCntrcts.Results[i] + '^' + slContractors[i];      // Saving as "Local^Remote".  Really should have been implemented as Name Value pairs of TStringList.
    Inc(i);
  end;
end;

function TfrmCntrctdExmMain.IsContractorVLEREnabled(RCon: String): Boolean;
var
  i: Integer;
  Connection: TVendorConnect;
begin
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  Result := false;
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon) then begin
      if (Piece(slContractors[i], '^', 3) = '') then begin
        Connection := TVendorConnect.Create(Rcon, False, CCOWRPCBrkrMain);
        try
          Result := (Connection.VLEREnabled = 'Y');
          slContractors[i] := slContractors[i] + '^' + Connection.VLEREnabled + '^' + Connection.VendorName;
          SetContractorVLEREnabledAndName(RCon, Connection.VLEREnabled + '^' + Connection.VendorName); // fill any other instances of this RCon also.
        finally
          Connection.Free;
        end;
      end else
        Result := (Piece(slContractors[i], '^', 3) = 'Y');

      break;
    end;
    Inc(i);
  end;
end;

procedure TfrmCntrctdExmMain.lblDOBEnter(Sender: TObject);
begin
  GetScreenReader.Speak('DOB');
end;

procedure TfrmCntrctdExmMain.lblPtntNmeEnter(Sender: TObject);
begin
  GetScreenReader.Speak('Name');
end;

procedure TfrmCntrctdExmMain.lblSSNEnter(Sender: TObject);
begin
  GetScreenReader.Speak('SSN');
end;

function TfrmCntrctdExmMain.GetContractorName(RCon: String): String;
var
  i: Integer;
  Connection: TVendorConnect;
begin
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  Result := '';
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon) then begin
      if (Piece(slContractors[i], '^', 4) = '') then begin
        Connection := TVendorConnect.Create(Rcon, False, CCOWRPCBrkrMain);
        try
          slContractors[i] := slContractors[i] + '^' + Connection.VLEREnabled + '^' + Connection.VendorName;
          Result := Connection.VendorName;
          SetContractorVLEREnabledAndName(RCon, Connection.VLEREnabled + '^' + Connection.VendorName); // fill any other instances of this RCon also.
        finally
          Connection.Free;
        end;
      end else
        Result := Piece(slContractors[i], '^', 4);

      break;
    end;
    Inc(i);
  end;
end;

(*
procedure TfrmCntrctdExmMain.ConvertVLERFileTimeToDateTime(var vFileDate: TDateTime; vFileTimeStamp: string);
var
  ISOFormatSettings: TFormatSettings;
begin
  vFileTimeStamp := copy(vFileTimeStamp, 1, length(vFileTimeStamp) - 4);
  // remove .txt extension
  vFileTimeStamp := StringReplace(vFileTimeStamp, 'T', ' ', []);
  // ,[rfReplaceAll]);
  vFileTimeStamp := StringReplace(vFileTimeStamp, '-', '/', [rfReplaceAll]);
  //vFileDate := StrToDateTime('08/24/2014 13:01:49'); // vFileTimeStamp, // vFileTimeStamp  ** temp
  // Big promise but unfinished  -> IdDateTimeStamp1 := TIdDateTimeStamp.Create(self);
  //   DONE: LMS using StrToDateTime --  will have to hand do this..
  {
      try
        IdDateTimeStamp1.SetFromISO8601(vFileTimeStamp);
        vFileDate := IdDateTimeStamp1.GetAsTDateTime;
      finally
        IdDateTimeStamp1.free;
      end;
      }
  GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, ISOFormatSettings);
  ISOFormatSettings.ShortDateFormat := 'yyyy/mm/dd';
  vFileDate := StrToDateTime(vFileTimeStamp, ISOFormatSettings);
end;
*)

procedure TfrmCntrctdExmMain.GetFMInternalDateFromDateTime(var intVendResultDate: string; vFileDate: TDateTime);
begin
  intVendResultDate := FormatDateTime('yyyy', vFileDate);
  intVendResultDate := IntToStr(StrToInt(intVendResultDate) - 1700);
  intVendResultDate := intVendResultDate + FormatDateTime('MMdd.HHmm', vFileDate);
  while (RightStr(intVendResultDate, 1) = '0') do
    intVendResultDate := LeftStr(intVendResultDate, Length(intVendResultDate) - 1);
end;

// TODO 5: LMS - GenMED
{Create new exam for this request.. populate fields.
            Get new ID and assign it to EXAMID of this TVlerResultFileInfo record
            Check other lists it needs to be added to.
            refresh fmExamGets after creating.
            Some of the related similar work is done in Procedure TfrmNewExam.btnSendRequestClick(Sender: TObject);
          }
          {
          Also might make a list of examID's and ExamNames already processed in this loop.
          If found a duplicate, then it's GENMED. In case of genmed, the triggering exam can't be allowed to process/post if new exam can't be built.
          Also check if the new GENMED exam already got posted to VLER but we ended up resetting the InProcess flag back to Open due to some other error in the processing of other exams.
            If it's posted, then don't make a new one. It should have the Exam result ID already in the field 73.
            To find this exam, we can check all exams for the request in descending order of examid and value match in field 73.
          }
          {
          End result. New Exam exists in VistA and in this loop it is considered valid.
          }
// CreateNewExamSentByVendor(VLERExamName, anExamID);

function TfrmCntrctdExmMain.CreateNewExamSentByVendor(ExamReqID: string; VLERExamName: string; LocalContractorID: string; DtSent: string): string;
var
  NewExamType: string;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB INCREASE EXAM COUNT';
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC DVBAB INCREASE EXAM COUNT could not be accessed!');
  end;
  //Result := frmMain.RPCBroker1.Results[0];

  FMExamNumber.Text := frmMain.RPCBroker1.Results[0];

  Result := FMExamNumber.Text;

  /// get request ien
  //FMExamRequest.Text := '`' + piece(anExamID, '-', 2);
  FMExamRequest.Text := '`' + ExamReqID;

  /// find the exam in the list by name
  fmFindOneTemp.FileNumber := '396.6';
  fmFindOneTemp.Screen := 'I $P(^(0),U,5)="A"';
  fmFindOneTemp.FMIndex := 'B';
  fmFindOneTemp.Value := VLERExamName;
  NewExamType := fmFindOneTemp.GetIEN;
  FMExamType.Text := '`' + NewExamType;                                         // find the exam in the list by name
  ///

  FMExamStatus.Text := 'O';
  FMFeeExam.Text := 'Y';                                                        // ? Same as the triggering exam
  FMExamContractor.Text := '`' + LocalContractorID;

  FMExamDtSent.Text := DtSent;

                      //FMInsufficientReason.Text := '';

  //fmLastExamAddDate.Text := 'NOW';   // Date from Vendor's exam send?
  //fmLastExamAddedBy.Text := '`' + AuthorIEN;

  FMExamNumber.IENS := '+1';                                                    //  Need to capture this number
  FMExamRequest.IENS := '+1';
  FMExamType.IENS := '+1';
  FMExamStatus.IENS := '+1';
  FMFeeExam.IENS := '+1';
  FMExamContractor.IENS := '+1';
  FMExamDtSent.IENS := '+1';

  //fmLastExamAddDate.IENS:= '+1';
  //fmLastExamAddedBy.IENS:= '+1';


  {if fmLastExamAddDate.FMModified then
    if fmLastExamAddDate.Validate then begin
      FMFiler1.AddChgdControl(fmLastExamAddDate);
      fmLastExamAddDate.Text := fmLastExamAddDate.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      fmLastExamAddDate.Text := fmLastExamAddDate.FMTag;
    end;
  if fmLastExamAddedBy.FMModified then
    if fmLastExamAddedBy.Validate then begin
      FMFiler1.AddChgdControl(fmLastExamAddedBy);
      fmLastExamAddedBy.Text := fmLastExamAddedBy.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      fmLastExamAddedBy.Text := fmLastExamAddedBy.FMTag;
    end;}
  if FMExamRequest.FMModified then
    if FMExamRequest.Validate then begin
      FMFiler1.AddChgdControl(FMExamRequest);
      FMExamRequest.Text := FMExamRequest.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamRequest.Text := FMExamRequest.FMTag;
    end;
  if FMExamNumber.FMModified then
    if FMExamNumber.Validate then begin
      FMFiler1.AddChgdControl(FMExamNumber);
      FMExamNumber.Text := FMExamNumber.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamNumber.Text := FMExamNumber.FMTag;
    end;
  if FMExamType.FMModified then
    if FMExamType.Validate then begin
      FMFiler1.AddChgdControl(FMExamType);
      FMExamType.Text := FMExamType.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamType.Text := FMExamType.FMTag;
    end;
  if FMExamStatus.FMModified then
    if FMExamStatus.Validate then begin
      FMFiler1.AddChgdControl(FMExamStatus);
      FMExamStatus.Text := FMExamStatus.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamStatus.Text := FMExamStatus.FMTag;
    end;
  if FMExamContractor.FMModified then
    if FMExamContractor.Validate then begin
      FMFiler1.AddChgdControl(FMExamContractor);
      FMExamContractor.Text := FMExamContractor.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamContractor.Text := FMExamContractor.FMTag;
    end;

  if FMExamDtSent.FMModified then
    if FMExamDtSent.Validate then begin
      FMFiler1.AddChgdControl(FMExamDtSent);
      FMExamDtSent.Text := FMExamDtSent.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamDtSent.Text := FMExamDtSent.FMTag;
    end;

  if FMFiler1.AnythingToFile then
    if FMFiler1.DataProblemCheck then begin
      FMFiler1.ProcessDataProblemList
    end
    else begin
      if not FMFiler1.Update then
        FMFiler1.DisplayErrors;
    end;
  Result := FMFiler1.FindIen('+1,') + '^' + Result;                             // IEN and new ID created
end;

Function TfrmCntrctdExmMain.HorologDateStringToDouble(FMorHorologDtStr: string): Double;
begin
  try
    FMorHorologDtStr := StringReplace(FMorHorologDtStr, ',', '.', [rfReplaceAll]);
    Result := StrToFloat(FMorHorologDtStr);
  except on e: Exception do
      Result := 0;
  end;
end;

procedure TfrmCntrctdExmMain.SetContractorVLEREnabledAndName(RCon, Value: string);
var
  i: Integer;
begin
  // DONE : LMS Optimization
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon)
      and ((Piece(slContractors[i], '^', 3) + '^' + Piece(slContractors[i], '^', 4)) <> Value)
      then begin
      slContractors[i] := Piece(slContractors[i], '^', 1, 2) + '^' + Value;
      // break; // Not breaking because, there can be multiple lines of same remote contractor and different local contractor records. Fill all of them
    end;
    Inc(i);
  end;
end;

function TfrmCntrctdExmMain.GetExams(ExamLstr: TFMLister;
  Reqsts: String; ExamList: TStringList): Boolean;
var
  Stn, Con, Rcon, Rqst, ExmIEN, U: String;
  i: Integer;
  iii: Integer;
  tmpExamList: TStringList;
begin
  U := '^';
end;

function TfrmCntrctdExmMain.IsContractorVLEREnabled(RCon: String): Boolean;
var
  i: Integer;
  Connection: TVendorConnect;
begin
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  Result := false;
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon) then begin
      if (Piece(slContractors[i], '^', 3) = '') then begin
        Connection := TVendorConnect.Create(Rcon, False, CCOWRPCBrkrMain);
        try
          Result := (Connection.VLEREnabled = 'Y');
          slContractors[i] := slContractors[i] + '^' + Connection.VLEREnabled + '^' + Connection.VendorName;
          SetContractorVLEREnabledAndName(RCon, Connection.VLEREnabled + '^' + Connection.VendorName); // fill any other instances of this RCon also.
        finally
          Connection.Free;
        end;
      end else
        Result := (Piece(slContractors[i], '^', 3) = 'Y');

      break;
    end;
    Inc(i);
  end;
end;

procedure TfrmCntrctdExmMain.lblDOBEnter(Sender: TObject);
begin
  GetScreenReader.Speak('DOB');
end;

procedure TfrmCntrctdExmMain.lblPtntNmeEnter(Sender: TObject);
begin
  GetScreenReader.Speak('Name');
end;

procedure TfrmCntrctdExmMain.lblSSNEnter(Sender: TObject);
begin
  GetScreenReader.Speak('SSN');
end;

function TfrmCntrctdExmMain.GetContractorName(RCon: String): String;
var
  i: Integer;
  Connection: TVendorConnect;
begin
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  Result := '';
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon) then begin
      if (Piece(slContractors[i], '^', 4) = '') then begin
        Connection := TVendorConnect.Create(Rcon, False, CCOWRPCBrkrMain);
        try
          slContractors[i] := slContractors[i] + '^' + Connection.VLEREnabled + '^' + Connection.VendorName;
          Result := Connection.VendorName;
          SetContractorVLEREnabledAndName(RCon, Connection.VLEREnabled + '^' + Connection.VendorName); // fill any other instances of this RCon also.
        finally
          Connection.Free;
        end;
      end else
        Result := Piece(slContractors[i], '^', 4);

      break;
    end;
    Inc(i);
  end;
end;

(*
procedure TfrmCntrctdExmMain.ConvertVLERFileTimeToDateTime(var vFileDate: TDateTime; vFileTimeStamp: string);
var
  ISOFormatSettings: TFormatSettings;
begin
  vFileTimeStamp := copy(vFileTimeStamp, 1, length(vFileTimeStamp) - 4);
  // remove .txt extension
  vFileTimeStamp := StringReplace(vFileTimeStamp, 'T', ' ', []);
  // ,[rfReplaceAll]);
  vFileTimeStamp := StringReplace(vFileTimeStamp, '-', '/', [rfReplaceAll]);
  //vFileDate := StrToDateTime('08/24/2014 13:01:49'); // vFileTimeStamp, // vFileTimeStamp  ** temp
  // Big promise but unfinished  -> IdDateTimeStamp1 := TIdDateTimeStamp.Create(self);
  //   DONE: LMS using StrToDateTime --  will have to hand do this..
  {
      try
        IdDateTimeStamp1.SetFromISO8601(vFileTimeStamp);
        vFileDate := IdDateTimeStamp1.GetAsTDateTime;
      finally
        IdDateTimeStamp1.free;
      end;
      }
  GetLocaleFormatSettings(LOCALE_SYSTEM_DEFAULT, ISOFormatSettings);
  ISOFormatSettings.ShortDateFormat := 'yyyy/mm/dd';
  vFileDate := StrToDateTime(vFileTimeStamp, ISOFormatSettings);
end;
*)

procedure TfrmCntrctdExmMain.GetFMInternalDateFromDateTime(var intVendResultDate: string; vFileDate: TDateTime);
begin
  intVendResultDate := FormatDateTime('yyyy', vFileDate);
  intVendResultDate := IntToStr(StrToInt(intVendResultDate) - 1700);
  intVendResultDate := intVendResultDate + FormatDateTime('MMdd.HHmm', vFileDate);
  while (RightStr(intVendResultDate, 1) = '0') do
    intVendResultDate := LeftStr(intVendResultDate, Length(intVendResultDate) - 1);
end;

// TODO 5: LMS - GenMED
{Create new exam for this request.. populate fields.
            Get new ID and assign it to EXAMID of this TVlerResultFileInfo record
            Check other lists it needs to be added to.
            refresh fmExamGets after creating.
            Some of the related similar work is done in Procedure TfrmNewExam.btnSendRequestClick(Sender: TObject);
          }
          {
          Also might make a list of examID's and ExamNames already processed in this loop.
          If found a duplicate, then it's GENMED. In case of genmed, the triggering exam can't be allowed to process/post if new exam can't be built.
          Also check if the new GENMED exam already got posted to VLER but we ended up resetting the InProcess flag back to Open due to some other error in the processing of other exams.
            If it's posted, then don't make a new one. It should have the Exam result ID already in the field 73.
            To find this exam, we can check all exams for the request in descending order of examid and value match in field 73.
          }
          {
          End result. New Exam exists in VistA and in this loop it is considered valid.
          }
// CreateNewExamSentByVendor(VLERExamName, anExamID);

function TfrmCntrctdExmMain.CreateNewExamSentByVendor(ExamReqID: string; VLERExamName: string; LocalContractorID: string; DtSent: string): string;
var
  NewExamType: string;
begin
  frmMain.RPCBroker1.Results.Clear;
  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB INCREASE EXAM COUNT';
  frmMain.RPCBrokerCall;
  try
    frmMain.RPCBroker1.Call;
  except
    on EBrokerError do
      ShowMessageCAPRI('RPC DVBAB INCREASE EXAM COUNT could not be accessed!');
  end;
  //Result := frmMain.RPCBroker1.Results[0];

  FMExamNumber.Text := frmMain.RPCBroker1.Results[0];

  Result := FMExamNumber.Text;

  /// get request ien
  //FMExamRequest.Text := '`' + piece(anExamID, '-', 2);
  FMExamRequest.Text := '`' + ExamReqID;

  /// find the exam in the list by name
  fmFindOneTemp.FileNumber := '396.6';
  fmFindOneTemp.Screen := 'I $P(^(0),U,5)="A"';
  fmFindOneTemp.FMIndex := 'B';
  fmFindOneTemp.Value := VLERExamName;
  NewExamType := fmFindOneTemp.GetIEN;
  FMExamType.Text := '`' + NewExamType;                                         // find the exam in the list by name
  ///

  FMExamStatus.Text := 'O';
  FMFeeExam.Text := 'Y';                                                        // ? Same as the triggering exam
  FMExamContractor.Text := '`' + LocalContractorID;

  FMExamDtSent.Text := DtSent;

                      //FMInsufficientReason.Text := '';

  //fmLastExamAddDate.Text := 'NOW';   // Date from Vendor's exam send?
  //fmLastExamAddedBy.Text := '`' + AuthorIEN;

  FMExamNumber.IENS := '+1';                                                    //  Need to capture this number
  FMExamRequest.IENS := '+1';
  FMExamType.IENS := '+1';
  FMExamStatus.IENS := '+1';
  FMFeeExam.IENS := '+1';
  FMExamContractor.IENS := '+1';
  FMExamDtSent.IENS := '+1';

  //fmLastExamAddDate.IENS:= '+1';
  //fmLastExamAddedBy.IENS:= '+1';


  {if fmLastExamAddDate.FMModified then
    if fmLastExamAddDate.Validate then begin
      FMFiler1.AddChgdControl(fmLastExamAddDate);
      fmLastExamAddDate.Text := fmLastExamAddDate.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      fmLastExamAddDate.Text := fmLastExamAddDate.FMTag;
    end;
  if fmLastExamAddedBy.FMModified then
    if fmLastExamAddedBy.Validate then begin
      FMFiler1.AddChgdControl(fmLastExamAddedBy);
      fmLastExamAddedBy.Text := fmLastExamAddedBy.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      fmLastExamAddedBy.Text := fmLastExamAddedBy.FMTag;
    end;}
  if FMExamRequest.FMModified then
    if FMExamRequest.Validate then begin
      FMFiler1.AddChgdControl(FMExamRequest);
      FMExamRequest.Text := FMExamRequest.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamRequest.Text := FMExamRequest.FMTag;
    end;
  if FMExamNumber.FMModified then
    if FMExamNumber.Validate then begin
      FMFiler1.AddChgdControl(FMExamNumber);
      FMExamNumber.Text := FMExamNumber.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamNumber.Text := FMExamNumber.FMTag;
    end;
  if FMExamType.FMModified then
    if FMExamType.Validate then begin
      FMFiler1.AddChgdControl(FMExamType);
      FMExamType.Text := FMExamType.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamType.Text := FMExamType.FMTag;
    end;
  if FMExamStatus.FMModified then
    if FMExamStatus.Validate then begin
      FMFiler1.AddChgdControl(FMExamStatus);
      FMExamStatus.Text := FMExamStatus.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamStatus.Text := FMExamStatus.FMTag;
    end;
  if FMExamContractor.FMModified then
    if FMExamContractor.Validate then begin
      FMFiler1.AddChgdControl(FMExamContractor);
      FMExamContractor.Text := FMExamContractor.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamContractor.Text := FMExamContractor.FMTag;
    end;

  if FMExamDtSent.FMModified then
    if FMExamDtSent.Validate then begin
      FMFiler1.AddChgdControl(FMExamDtSent);
      FMExamDtSent.Text := FMExamDtSent.FMCtrlExternal;
    end
    else begin
      frmMain.FMValidator1.DisplayErrors;
      FMExamDtSent.Text := FMExamDtSent.FMTag;
    end;

  if FMFiler1.AnythingToFile then
    if FMFiler1.DataProblemCheck then begin
      FMFiler1.ProcessDataProblemList
    end
    else begin
      if not FMFiler1.Update then
        FMFiler1.DisplayErrors;
    end;
  Result := FMFiler1.FindIen('+1,') + '^' + Result;                             // IEN and new ID created
end;

Function TfrmCntrctdExmMain.HorologDateStringToDouble(FMorHorologDtStr: string): Double;
begin
  try
    FMorHorologDtStr := StringReplace(FMorHorologDtStr, ',', '.', [rfReplaceAll]);
    Result := StrToFloat(FMorHorologDtStr);
  except on e: Exception do
      Result := 0;
  end;
end;

procedure TfrmCntrctdExmMain.SetContractorVLEREnabledAndName(RCon, Value: string);
var
  i: Integer;
begin
  // DONE : LMS Optimization
  if slContractors.Count = 0 then
    FillContractorsList;

  i := 0;
  while (i < slContractors.Count) do
  begin
    if (Piece(slContractors[i], '^', 2) = RCon)
      and ((Piece(slContractors[i], '^', 3) + '^' + Piece(slContractors[i], '^', 4)) <> Value)
      then begin
      slContractors[i] := Piece(slContractors[i], '^', 1, 2) + '^' + Value;
      // break; // Not breaking because, there can be multiple lines of same remote contractor and different local contractor records. Fill all of them
    end;
    Inc(i);
  end;
end;

function TfrmCntrctdExmMain.GetExams(ExamLstr: TFMLister;
  Reqsts: String; ExamList: TStringList): Boolean;
var
  Stn, Con, Rcon, Rqst, ExmIEN, U: String;
  i: Integer;
  iii: Integer;
  tmpExamList: TStringList;
begin
  U := '^';
  tmpExamList := nil;
  Stn := GetDivisionOfCBOC(CCOWRPCBrkrMain.User.Division);

  //if slContractors.Count = 0 then   // the getRemoteConIen call will make sure its filled
    //FillContractorsList;

  iii := 2;                                                                     // requests are | delimited, e.g. |208470|208479|
  try
    tmpExamList := TStringList.Create;
    ExamLstr.FMIndex := 'C';
    ExamLstr.Number := '500';                                                   // arbiterary max.. a Request can't have more than 500 Exams.

    ExamLstr.ListerOptions := [loQuickList];
    ExamLstr.ListerFlags := [lfInternal];

    while (piece(reqsts, '|', iii) <> '') do
    begin
      Rqst := piece(reqsts, '|', iii);
      ExamLstr.PartList.Clear;
      ExamLstr.PartList.Add(Rqst);
      ExamLstr.FromList.Clear;
      ExamLstr.FromList.Add(Rqst);
      ExamLstr.Screen := 'I $P(^(0),U,2)=' + Rqst;                              // DONE: LMS to eliminate requests for 20840 catching 208400 also.
      ExamLstr.GetList(tmpExamList);
      if ExamLstr.Results.Count > 0 then begin
        i := 0;
        while (i < tmpExamList.Count) do
        begin
          ExmIEN := ExamLstr.Results[i];                                        // Piece(tmpExamList[i],U,1);  Piece 1 is internal value. We get external from Results index list
          Rqst := Piece(tmpExamList[i], U, 2);
          Con := Piece(tmpExamList[i], U, 3);
          Rcon := GetRemoteConIen(Con);                                         // , slContractors);
          tmpExamList[i] := Rcon + '-' + Stn + '-' + Rqst + '-' + ExmIEN + '-' + Con; // DONE: LMS Adding "con" as we also need local contractor to match the exam back to proper entry.
          Inc(i);
        end;
        ExamList.AddStrings(tmpExamList);
        tmpExamList.clear;
      end;
      inc(iii);
    end;
  finally
    tmpExamList.Free;
  end;

  StatusMsg(IntToStr(ExamList.Count) + ' exams found.');
  Result := (ExamList.Count > 0);
end;

{ Functions / Procedures }

procedure TfrmCntrctdExmMain.SetupForm;
begin
  { Initialize Date Parameters for 2507 Display
      FROM: 2 Months preceeding current date
      TO: 6 Months after current date }
//  dtPckrExamFrom.Date := IncMonth(Date, -2);
  edtDtPckrExamFrom.Text := DateToStr(IncMonth(Date, -2));
//  dtPckrExamTo.Date := IncMonth(Date, 6);
  edtDtPckrExamTo.Text := DateToStr(IncMonth(Date, 6));
  { Initialize Timer Val }
  // DONE: LMS removing tmrAppShutDwn.Interval := TUserInfo.GetUserTimeOut(CCOWRPCBrkrMain);
  { Enable Admin Menu if User has applicable Key }
  mnuItmAdmin.Visible := frmMain.IsCCRSuperVisor();                             // DONE: LMS TUserInfo.UserHasKey(CCOWRPCBrkrMain, CCRADMINKEY);
end;

procedure TfrmCntrctdExmMain.GenerateContractedReport(RptType: String);
var
  dlgRpt: TfrmRptRslts;
  dlgRptParams: TcntrctdExmRptDlg;
begin
  tmrAppShutDwn.Enabled := False;
  dlgRptParams := nil;
  dlgRpt := nil;
  try
    try
      { Initialize Report Parameter Dialog }
      dlgRptParams := TcntrctdExmRptDlg.Create(self, RptType, CCOWRPCBrkrMain,
        (tmrAppShutDwn.Interval - 60000));
      if (dlgRptParams.ShowModal = mrOk) then
      begin
        { Initialize Report Window }
        try
          Repaint;
          Screen.Cursor := crHourGlass;
          dlgRpt := TfrmRptRslts.Create(self, RptType, dlgRptParams.GetParams,
            CCOWRPCBrkrMain, (tmrAppShutDwn.Interval - 60000));
          Screen.Cursor := crDefault;
          dlgRpt.ShowModal;                                                     { Generate Report and Display }
        except
          on E: Exception do
          begin
            Screen.Cursor := crDefault;
            Application.MessageBox(PChar(E.Message), 'Report Error', MB_OK);
          end;                                                                  { End Exception Handling }
        end;                                                                    { End Try/Except Block for dlgRpt }
      end;                                                                      { End If User Accepted Report Parameters }
    except
      on E: Exception do
      begin
        Application.MessageBox(PChar(E.Message), 'No 2507 Contractors', MB_OK);
      end;                                                                      { End Exception Handling }
    end;                                                                        { End Try/Except Block for dlgRptParams }
  finally
    dlgRptParams.Free;
    dlgRpt.Free;
    ResetAppTmr;
  end;                                                                          { End Try/Finally Block }
end;

procedure TfrmCntrctdExmMain.CheckOutExam(RsndInfo: Boolean);
var
  coCntrctdExam: TExntdCntrctdBaseFormNewRsnd;
begin
  tmrAppShutDwn.Enabled := False;
  { Ensure Patient Still has available requests since putting into context }
  if _2507Info.HasAvailableRequests then
  begin
    if _PtntInfo.HasBadAddress then                                             { Bad Address Indicator populated (2.121) }
      if Not ContinueCOWBadAddrss then                                          { Ensure user wants to continue }
        exit;                                                                   { Do Nothing }
    coCntrctdExam := nil;                                                       { Initialize to suppress warning message }
    try
      try
        coCntrctdExam := TExntdCntrctdBaseFormNewRsnd.Create(self, _PtntInfo,   // Sending self as owner is important. It is used in some instances.
          CCOWRPCBrkrMain, (tmrAppShutDwn.Interval - 60000), RsndInfo);
        if ((coCntrctdExam.ShowModal = mrOk) and (Not RsndInfo)) then
          btnRfrshExamListClick(self);                                          { Refresh List }
      except
        On E: Exception Do
        begin
          Application.MessageBox(PChar(E.Message), 'No 2507 Contractors', MB_OK);
        end;                                                                    { End Exception }
      end;                                                                      { End Try/Except }
    finally
      coCntrctdExam.Free;                                                       { Ensure Memory is released }
    end;                                                                        { End Try/Finally }
  end                                                                           { End If Patient Still has available requests }
  else
    NoRqstsErrMsg;
  ResetAppTmr;
end;

procedure TfrmCntrctdExmMain.cmbBxExamFltrChange(Sender: TObject);
begin
  btnRfrshExamListClick(Application);
end;

procedure TfrmCntrctdExmMain.GetPatientInfo;
var
  (*ptntSlctnDlg: TPtntSlctnDlg;
  DFN: String; Name: string;
  SSN: string; DOB: string;
  AGE: String; SEX: string;
  DOD: String;
  ClaimNum, NameComponents: String;
  VTRN: Boolean;
  *)
  NewPatientInfo: Boolean;
  TmpPatientInfo: TPatientInfoBucket;
begin
  TmpPatientInfo := nil;                                                        // CodeCR701 rpk 2/12/2015
  TmpPatientInfo := frmMain.PatientInfo;
  if not Assigned(TmpPatientInfo) then                                          // CodeCR701 rpk 2/9/2015
    exit;                                                                       // CodeCR701 rpk 2/9/2015

  if (Not Assigned(_PtntInfo)) then
    NewPatientInfo := true
  else begin
    if (_PtntInfo.PatientDFN <> TmpPatientInfo.DFN)
      or (_PtntInfo.PatientSSN <> TmpPatientInfo.SSN)
      or (_PtntInfo.PatientICN <> TmpPatientInfo.ICN)
      or (_PtntInfo.PatientClaimFolderNumber <> TmpPatientInfo.ClaimNum)
      then begin                                                                // DONE: LMS if any of patient info has changed then we get the new values.
      FreeAndNil(_PtntInfo);
      NewPatientInfo := True;
    end else
      NewPatientInfo := False;
  end;

  if NewPatientInfo then                                                        // DONE: LMS get all patient info. Cell phone and home phone still waiting on Jerry's XML.
  begin
    _PtntInfo := TPatientInfo.Create(TmpPatientInfo.DFN
      , TmpPatientInfo.Name
      , TmpPatientInfo.SSN
      , TmpPatientInfo.ICN
      , TmpPatientInfo.DOB
      , TmpPatientInfo.AGE
      , TmpPatientInfo.SEX
      , TmpPatientInfo.DOD
      , TmpPatientInfo.ClaimNum
      , TmpPatientInfo.NameComponents
      , TmpPatientInfo.BadAddressType                                           // LMS CodeCR 536
      , TmpPatientInfo.VTRN);
    _PtntInfo.PatientLastName := TmpPatientInfo.Last;
    _PtntInfo.PatientFirstName := TmpPatientInfo.First;
    _PtntInfo.PatientMiddleName := TmpPatientInfo.Middle;
    _PtntInfo.PatientAddress1 := TmpPatientInfo.Address1;
    _PtntInfo.PatientAddress2 := TmpPatientInfo.Address2;
    _PtntInfo.PatientAddress3 := TmpPatientInfo.Address3;
    _PtntInfo.PatientCity := TmpPatientInfo.City;
    _PtntInfo.PatientStateOrProvince := TmpPatientInfo.StateProv;
    _PtntInfo.PatientZip := TmpPatientInfo.Zip;
    _PtntInfo.PatientCountry := TmpPatientInfo.Country;
    _PtntInfo.PatientHomePhone := TmpPatientInfo.HomePhone;
    _PtntInfo.PatientCellPhone := TmpPatientInfo.CellPhone;

  end;
  DisplayPatientInfo;
end;

procedure TfrmCntrctdExmMain.Get2507Info;
begin
  if (_2507Info = nil) or (not assigned(_2507Info)) then                        // DONE: LMS refresh if patient has changed. X will not happen
  begin
    _2507Info := T2507Info.Create(_PtntInfo, frmMain.RPCBroker1);
  end;
end;

function TfrmCntrctdExmMain.GetDateOfText(aDateStr, defaultDate: string): TDateTime;
begin
  try
    Result := StrToDate(aDateStr)
  except on e: exception do
    try
      Result := StrToDate(defaultDate);
    except on e2: exception do
        Result := StrToDate('1/1/1800');
    end;
  end;
end;

procedure TfrmCntrctdExmMain.DisplayPatientInfo;
var
  dte: TDateTime;
  strDte: String;
begin
  { NOTE: There will ALWAYS be a patient in context. }
//  lblPtntNme.Caption := _PtntInfo.PatientName;

  lblPtntNme.Text := _PtntInfo.PatientName;                                     // rpk 10/17/2014
//  lblSSN.Caption := _PtntInfo.GetExternalSSN;
  lblSSN.Text := _PtntInfo.GetExternalSSN;                                      // rpk 10/17/2014
  strDte := _PtntInfo.PatientDOB;
  if TryStrToDate(strDte, dte) then
    strDte := FormatDateTime('mmmm dd, yyyy', dte);
//  lblDOB.Caption := strDte + ' (' + _PtntInfo.PatientAGE + ')';
  lblDOB.Text := strDte + ' (' + _PtntInfo.PatientAGE + ')';                    // rpk 10/17/2014
end;

procedure TfrmCntrctdExmMain.Display2507Info;
var
  parm: String;
//  tDtStrF, tDtStrT: string;
  tDtTimeF, tDtTimeT: TDateTime;                                                // DONE: LMS for blanks, error was being raised.
  dtModified: Boolean;
begin
  { Get search parameters for 2507 Info }
  parm := cmbBxExamFltr.Text;
  dtModified := false;

  if not TryStrToDate(edtDtPckrExamTo.Text, tDtTimeT) then begin
    tDtTimeT := now;
    dtModified := true;
  end;
  if not TryStrToDate(edtDtPckrExamFrom.Text, tDtTimeF) then begin
    tDtTimeF := now;
    dtModified := true;
  end;

  if dtModified then
  begin
    if tDtTimeF > tDtTimeT then
      tDtTimeT := tDtTimeF + 186;                                               // DONE: LMS Code really shouldn't get here but in case it does.. 6+ months from now to today. Could be changed to a better value.
  end;

  // DONE: LMS this had been removed in original source given to us.. updated and reenabled.
  //parm := cmbBxExamFltr.Text + '^' + edtDtPckrExamFrom.Text + '^' +
  //         edtDtPckrExamTo.Text;
  parm := cmbBxExamFltr.Text + '^' + DateToStr(tDtTimeF) + '^' +
    DateToStr(tDtTimeT);
  { Retrieve 2507 Info to display in Tree [Request [Exams]] }
  _2507Info.GetPatient2507Info(trVw2507Info, parm);
  trVw2507Info.FullExpand;                                                      { Make entire tree visible }
  trVw2507Info.Selected := trVw2507Info.Items.GetFirstNode;                     { Navigate to top }
end;

procedure TfrmCntrctdExmMain.ResetAppTmr;
begin
  (* not TODO: LMS removing initially but may bring it back in... if broker connections break too much! So far they are breaking only during FTP or other debugging when the app is paused for a long time waiting for debugger
  tmrAppShutDwn.Enabled := False;
  tmrEnsrBrkrCnntctd.Enabled := False;
  tmrAppShutDwn.Enabled := True;
  tmrEnsrBrkrCnntctd.Enabled := True;
  *)
end;

procedure TfrmCntrctdExmMain.ResetCntrctdPrcssBtns;
var
  rqstsExist: Boolean;
begin
  { Ensure Patient Selected has at least 1 request with a status of
    P: Pending, Reported, N: New, NT: New, Transferred In or
    S: Pending, Scheduled prior to enabling contracted process buttons. }
  rqstsExist := _2507Info.HasAvailableRequests;
  btnNewExam.Enabled := rqstsExist;
  btnResendExam.Enabled := rqstsExist;
  btnCheckInExam.Enabled := rqstsExist;
  mnuItmAdminDeleteCO.Enabled := rqstsExist;
end;

procedure TfrmCntrctdExmMain.NoRqstsErrMsg;
begin
  Application.MessageBox('Patient does not have any applicable 2507 requests to fulfill.' +
    #13#10 + 'Contract processing requires 2507 requests to have a status of: ' +
    #13#10#13#10 + '         -  New' + #13#10 + '         -  New, Transferred In' +
    #13#10 + '         -  Pending, Reported  or ' + #13#10 +
    '         -  Pending, Scheduled', 'No Available 2507 Requests', MB_OK);
end;

{
function TfrmCntrctdExmMain.GetTempExmDir(DUZ: String): String;
begin
end;
}

function TfrmCntrctdExmMain.ContinueCOWBadAddrss(): Boolean;
begin
  Result := False;
  if MessageDlgCAPRI('Patient''s record has been flagged with the ''Bad Address Indicator'': ' +
    _PtntInfo.PatientBadAddressType + '.' + #13#10 + 'Address information will ' +
    'NOT be included in the documents supplied to the contractor until the' +
    #13#10 + 'indicator is removed or unless VBA has included an address in ' +
    'the remarks section of the 2507.' + #13#10#13#10 +
    'Do you wish to continue with Check-Out/Resend processing?',
    mtConfirmation, [mbYes, mbNo], 0) = mrYes then
    Result := True;
end;

{ CONTEXTOR }

{ procedure TfrmCntrctdExmMain.SetupSSO;
begin
  // Setup SSO to prevent subsequent logon dlg prompt, if NOT needed
  // DONE: LMS This whole method is not being called now
  try
    CntxtrCntrl := TContextorControl.Create(self);
    with CntxtrCntrl do
    begin
      OnPending := ContextorControlPending;
      OnCommitted := ContextorControlCommitted;
      OnCanceled := ContextorControlCanceled;
    end;
    CntxtrCntrl.Run('CntrctdExmsApp', '', True, '*');
  except
    on exc : EOleException do
    begin
      FreeAndNil(CntxtrCntrl);
      try
        CntxtrCntrl := TContextorControl.Create(self);
        with CntxtrCntrl do
        begin
          OnPending := ContextorControlPending;
          OnCommitted := ContextorControlCommitted;
          OnCanceled := ContextorControlCanceled;
        end;
        CntxtrCntrl.Run('CntrctdExmsApp#', '', True, '*');
      except
        FreeAndNil(CntxtrCntrl);
      end;  // End Inner Try/Except
    end;  // End OLE Exception
  end;  // End Outer Try/Except
  if (CntxtrCntrl <> nil) then
    CCOWRPCBrkrMain.Contextor := CntxtrCntrl;

end; }

procedure TfrmCntrctdExmMain.StatusMsg(Msg: String);
begin
  sbMain.Panels[0].Text := Msg;
end;

procedure TfrmCntrctdExmMain.ContextorControlCanceled(Sender: TObject);
begin
  { Do Nothing for User Context Changes @ this time }
  { Patient Context NOT handled at this time }
end;

procedure TfrmCntrctdExmMain.ContextorControlCommitted(Sender: TObject);
begin
  { Do Nothing for User Context Changes @ this time }
  { Patient Context NOT handled at this time }
end;

procedure TfrmCntrctdExmMain.ContextorControlPending(Sender: TObject;
  const aContextItemCollection: IDispatch);
begin
  { Do Nothing for User Context Changes @ this time }
  { Patient Context NOT handled at this time }
end;

procedure TfrmCntrctdExmMain.DateComplete(var StrLikeDate: string; MinDate: TDate;
  const NowIfError: Boolean);
var
  DateStr: string;
  Year, Month, Day: Word;
  cnt, SepCount: Integer;
begin
  DateStr := StrLikeDate;
  if DateStr = '' then
    Exit;
  SepCount := 0;
  for cnt := 1 to Length(DateStr) do
  begin
    if not (DateStr[cnt] in ['0'..'9']) then
    begin
      DateStr[cnt] := DateSeparator;
      inc(SepCount);
    end;
  end;
  while (DateStr <> '') and (DateStr[Length(DateStr)] = DateSeparator) do
  begin
    Delete(DateStr, Length(DateStr), 1);
    Dec(SepCount);
  end;
  DecodeDate(Now, Year, Month, Day);
  if SepCount = 0 then
  begin
    case Length(DateStr) of
      0: DateStr := DateToStr(Now);
      1, 2: DateStr := DateStr + DateSeparator + IntToStr(Day);
//     1, 2: DateStr := DateStr+DateSeparator+IntToStr(Month);  // use this if short date format is dd/mm/yyyy
      4: Insert(DateSeparator, DateStr, 3);
      6, 8: begin
          Insert(DateSeparator, DateStr, 5);
          Insert(DateSeparator, DateStr, 3);
        end;
    end;                                                                        // case
  end;                                                                          // if SepCount
  try
    StrLikeDate := FormatDateTime('mm/dd/yyyy', StrToDate(DateStr));
  Except
    if NowIfError = TRUE then
    begin
      StrLikeDate := DateToStr(Date)
    end
    else
      StrLikeDate := '';
  end;
   // Date is valid, check for greater than minimum date
  if StrToDate(DateStr) < MinDate then
    StrLikeDate := 'Min ' + StrLikeDate;

end;

end.

