unit infodialog;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  DialogsCAPRI,
  Dialogs,
  GIFImage,
  StdCtrls,
  ExtCtrls;

type
  TfrmInfoDialog = class(TForm)
    Panel1: TPanel;
    memoInfo: TMemo;
    Button1: TButton;
    CCOWTimer: TTimer;
    imgIcon: TImage;
    procedure Button1Click(Sender: TObject);
    procedure CCOWTimerTimer(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmInfoDialog: TfrmInfoDialog;

implementation

uses main, CapriSupport;

{$R *.DFM}

procedure TfrmInfoDialog.Button1Click(Sender: TObject);
begin
  modalresult := mrOK;
end;

procedure TfrmInfoDialog.CCOWTimerTimer(Sender: TObject);
begin
  if ShutdownCAPRIModalDialogs = true then begin
    CCOWTimer.Enabled := False;
    frmInfoDialog.Visible := False;
    ContextorChangeMessage := '';
    Button1Click(Application);
  end;
end;

procedure TfrmInfoDialog.FormActivate(Sender: TObject);
begin
  CCOWTimer.Enabled := True;
end;

procedure TfrmInfoDialog.FormCreate(Sender: TObject);
begin
  imgIcon.Picture.Icon.Handle := LoadIcon(0, IconArray[1]);
end;

end.
