unit mergePScripts;

interface

uses sysutils,
  classes,
  dialogsCAPRI,
  forms;

procedure MergePScript(main: tstrings; incoming: tstrings);

implementation

function CheckForTags(source: tstrings): boolean;
var
  m1, m2, m3, m4, m5, m6, m7, m8, m9, m10, m11, m12, m13, m14, m15, m16, m17, m18: boolean;
  x: integer;
  s: string;
begin
  result := false;
  m1 := False;
  m2 := False;
  m3 := False;
  m4 := False;
  m5 := False;
  m6 := False;
  m7 := False;
  m8 := False;
  m9 := False;
  m10 := False;
  m11 := False;
  m12 := False;
  m13 := False;
  m14 := False;
  m15 := False;
  m16 := False;
  m17 := False;
  m18 := False;
  for x := 1 to source.count - 1 do begin
    if trim(uppercase(source[x])) = '//CAPRITAG:VARIABLESTART//' then
      m1 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:VARIABLEEND//' then
      m2 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:FIRSTRUNPROCVARSSTART//' then
      m3 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:FIRSTRUNPROCVARSEND//' then
      m4 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:FIRSTRUNPROCSTART//' then
      m5 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:FIRSTRUNPROCEND//' then
      m6 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:LASTRUNFUNCVARSSTART//' then
      m7 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:LASTRUNFUNCVARSEND//' then
      m8 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:LASTRUNFUNCSTART//' then
      m9 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:LASTRUNFUNCEND//' then
      m10 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:MAINPROGRAMSTART//' then
      m11 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:MAINPROGRAMEND//' then
      m12 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:REGULARCODESTART//' then
      m13 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:REGULARCODEEND//' then
      m14 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:PROBLEMLISTCHANGEDVARSSTART//' then
      m15 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:PROBLEMLISTCHANGEDVARSEND//' then
      m16 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:PROBLEMLISTCHANGEDSTART//' then
      m17 := true;
    if trim(uppercase(source[x])) = '//CAPRITAG:PROBLEMLISTCHANGEDEND//' then
      m18 := true;
  end;

  s := 'Fatal error.  PScript code cannot be merged.  Section missing: ';
  if m1 = false then
    showmessageCAPRI(s + '//CAPRITag:VariableStart//');
  if m2 = false then
    showmessageCAPRI(s + '//CAPRITag:VariableEnd//');
  if m3 = false then
    showmessageCAPRI(s + '//CAPRITag:FirstRunProcVarsStart//');
  if m4 = false then
    showmessageCAPRI(s + '//CAPRITag:FirstRunProcVarsEnd//');
  if m5 = false then
    showmessageCAPRI(s + '//CAPRITag:FirstRunProcStart//');
  if m6 = false then
    showmessageCAPRI(s + '//CAPRITag:FirstRunProcEnd//');
  if m7 = false then
    showmessageCAPRI(s + '//CAPRITag:LastRunFuncVarsStart//');
  if m8 = false then
    showmessageCAPRI(s + '//CAPRITag:LastRunFuncVarsEnd//');
  if m9 = false then
    showmessageCAPRI(s + '//CAPRITag:LastRunFuncStart//');
  if m10 = false then
    showmessageCAPRI(s + '//CAPRITag:LastRunFuncEnd//');
  if m11 = false then
    showmessageCAPRI(s + '//CAPRITag:MainProgramStart//');
  if m12 = false then
    showmessageCAPRI(s + '//CAPRITag:MainProgramEnd//');
  if m13 = false then
    showmessageCAPRI(s + '//CAPRITag:RegularCodeStart//');
  if m14 = false then
    showmessageCAPRI(s + '//CAPRITag:RegularCodeEnd//');
  if m15 = false then
    showmessageCAPRI(s + '//CAPRITag:ProblemListChangedVarsStart//');
  if m16 = false then
    showmessageCAPRI(s + '//CAPRITag:ProblemListChangedVarsEnd//');
  if m17 = false then
    showmessageCAPRI(s + '//CAPRITag:ProblemListChangedStart//');
  if m18 = false then
    showmessageCAPRI(s + '//CAPRITag:ProblemListChangedEnd//');

  if (m1 = true) and (m2 = true) and (m3 = true) and (m4 = true) and (m5 = true) and (m6 = true) and
    (m7 = true) and (m8 = true) and (m9 = true) and (m10 = true) and (m11 = true) and (m12 = true) and
    (m13 = true) and (m14 = true) and (m15 = true) and (m16 = true) and (m17 = true) and
    (m18 = true) then
    result := true;
end;

procedure MergeSection(main, incoming: tstrings; lookfor, lookend: string);
var
  x, y: integer;
  tempts: tstringlist;
  s, s2: string;
  addflag: boolean;
begin
  lookfor := trim(uppercase(lookfor));
  lookend := trim(uppercase(lookend));
  tempts := tstringlist.create;
  for x := 0 to main.count - 1 do begin
    s := main[x];
    tempts.add(s);
    if trim(uppercase(s)) = lookfor then begin
      // Find the section in incoming and add it
      y := 0;
      addflag := false;
      repeat
        s2 := incoming[y];
        if trim(uppercase(s2)) = lookfor then
          addflag := true;
        inc(y);
        if addflag = true then begin
          if (trim(uppercase(s2)) <> lookfor) and (trim(uppercase(s2)) <> lookend) then
            tempts.add(s2);
          dec(y);
          incoming.Delete(y);
        end;
      until trim(uppercase(s2)) = lookend
    end;
  end;

  // Copy into main
  main.clear;
  for x := 0 to tempts.count - 1 do
    main.add(tempts[x]);

  tempts.free;
end;

procedure MergePScript(main: tstrings; incoming: tstrings);
var
  x: integer;
  tempts: tstringlist;
begin
  tempts := tstringlist.create;
  // First check that all required tags are there in each tstringlist
  if main.count > 0 then
    if CheckForTags(main) = false then
      application.terminate;
  if CheckForTags(incoming) = false then
    application.terminate;

  if main.count = 0 then begin
    // No existing report
    for x := 0 to incoming.count - 1 do
      tempts.add(incoming[x]);
    main.clear;
    for x := 0 to tempts.count - 1 do
      main.add(tempts[x]);
  end
  else begin
    MergeSection(main, incoming, '//CAPRITAG:VARIABLESTART//', '//CAPRITAG:VARIABLEEND//');
    MergeSection(main, incoming, '//CAPRITAG:FIRSTRUNPROCVARSSTART//', '//CAPRITAG:FIRSTRUNPROCVARSEND//');
    MergeSection(main, incoming, '//CAPRITAG:FIRSTRUNPROCSTART//', '//CAPRITAG:FIRSTRUNPROCEND//');
    MergeSection(main, incoming, '//CAPRITAG:LASTRUNFUNCVARSSTART//', '//CAPRITAG:LASTRUNFUNCVARSEND//');
    MergeSection(main, incoming, '//CAPRITAG:LASTRUNFUNCSTART//', '//CAPRITAG:LASTRUNFUNCEND//');
    MergeSection(main, incoming, '//CAPRITAG:MAINPROGRAMSTART//', '//CAPRITAG:MAINPROGRAMEND//');
    MergeSection(main, incoming, '//CAPRITAG:RegularCodeStart//', '//CAPRITAG:RegularCodeEnd//');
    MergeSection(main, incoming, '//CAPRITAG:PROBLEMLISTCHANGEDVARSSTART//', '//CAPRITAG:PROBLEMLISTCHANGEDVARSEND//');
    MergeSection(main, incoming, '//CAPRITAG:PROBLEMLISTCHANGEDSTART//', '//CAPRITAG:PROBLEMLISTCHANGEDEND//');

    //    StripFirstRun(incoming);
    //    StripLastRun(incoming);
    //    StripMainProgram(incoming);
    //    MergeWHATEVERSLEFT(main,incoming);
  end;
  tempts.free;
end;

end.
