unit pncsOptionsInfo;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TformOptionsInfo = class(TForm)
    pnlBaseOptionsInfo: TPanel;
    xLabelInfoLabel: TLabel;
    mmoOptionsInfo: TRichEdit;
    xButtonInfoClose: TButton;
    pnlTitle: TPanel;
    pnlClose: TPanel;
    procedure pnlCloseClick(Sender: TObject);
    procedure xButtonInfoCloseClick(Sender: TObject);
  private
    function GetBottomLeft: TPoint;
    procedure SetBottomLeft(const Value: TPoint);
    function GetInfoText: String;
    procedure SetInfoText(const Value: String);
    { Private declarations }
  public
    { Public declarations }
    property BottomLeft   : TPoint  read GetBottomLeft    write SetBottomLeft;
    property InfoText     : String  Read GetInfoText      write SetInfoText;
  end;

var
  formOptionsInfo: TformOptionsInfo;

implementation

{$R *.DFM}

function TformOptionsInfo.GetBottomLeft: TPoint;
begin
  Result.x:=Left;
  Result.y:=Top+Height;
end;

function TformOptionsInfo.GetInfoText: String;
begin
  Result:=mmoOptionsInfo.Text;
end;

procedure TformOptionsInfo.pnlCloseClick(Sender: TObject);
begin
  Close;
end;

procedure TformOptionsInfo.SetBottomLeft(const Value: TPoint);
begin
  Left:=Value.x;
  Top :=Value.y-Height;
end;

procedure TformOptionsInfo.SetInfoText(const Value: String);
begin
  mmoOptionsInfo.Lines.SetText(PChar(Value));
end;

procedure TformOptionsInfo.xButtonInfoCloseClick(Sender: TObject);
begin
  Close;
end;

end.
