unit pncsShow;

interface

Uses
  ComCtrls,
  Fmcmpnts,
  Fmcntrls,
  StdCtrls,
  ZipMcpt,
  XsdEngineLite,
  XmlConfig;

procedure PNCSShowModal(
  FMCommentsMemo      : TFMMemo;   //FMCommentsMemo: TFMMemo;
  FMEditIPR10         : TFMEdit;   //FMEditIPR10: TFMEdit;
  FMEditIPR11         : TFMEdit;   //FMEditIPR11: TFMEdit;
  FMEditIPR2          : TFMEdit;   //FMEditIPR2: TFMEdit;
  FMEditIPR6          : TFMEdit;   //FMEditIPR6: TFMEdit;
  FMEditIPR7          : TFMEdit;   //FMEditIPR7: TFMEdit;
  FMEditIPR8          : TFMEdit;   //FMEditIPR8: TFMEdit;
  FMEditReviewStatus  : TFMEdit;   //FMEditReviewStatus: TFMEdit;
  FMGetsIPRFile       : TFMGets;   //FMGetsIPRFile: TFMGets;
  FMGetsIPRFile3      : TFMGets;   //FMGetsIPRFile3: TFMGets;
  FMGetsTemplateInfo  : TFMGets;   //FMGetsTemplateInfo: TFMGets;
  FMListBox           : TFMListBox;//FMListboxIPR1 : TFMListBox;
  ListBoxIPR1         : TListBox;  //ListBoxIPR1: TListBox;
  MiniZip1            : TMiniZip;  //MiniZip1: TMiniZip;
  mmoFormDefinition   : TRichEdit; //FMMemoFormDefinition: TRichEdit;
  mmoReport           : TRichEdit; //RichEditReport: TRichEdit;
  mmoReportDefinition : TRichEdit; //FMMemoReportDefinition: TRichEdit;
  mmoScriptDefinition : TRichEdit; //FMMemoScriptDefinition: TRichEdit;
  Sender              : TObject;
  SenderName          : String;
  StatusMsg           : TLabel;    //StatusBarLoadPt: TLabel;
  xFMEditObjectCount  : TFMEdit;   //xFMEditObjectCount: TFMEdit;
  xFMTemplatesUtilized: TFMMemo    //xFMTemplatesUtilized: TFMMemo;
  );

implementation
Uses
  Classes,
  Controls,
  dialogscapri,
  Forms,
  Main,
  mergePScripts,
  ORFn,
  PNCSMain,
  SysUtils,
  Trpcb,
  unsigned,
  UUCode,
  wait,
  Windows,
  CCOWRPCBrokerCAPRI;

procedure PNCSShowModal(
  FMCommentsMemo      : TFMMemo;   //FMCommentsMemo: TFMMemo;
  FMEditIPR10         : TFMEdit;   //FMEditIPR10: TFMEdit;
  FMEditIPR11         : TFMEdit;   //FMEditIPR11: TFMEdit;
  FMEditIPR2          : TFMEdit;   //FMEditIPR2: TFMEdit;
  FMEditIPR6          : TFMEdit;   //FMEditIPR6: TFMEdit;
  FMEditIPR7          : TFMEdit;   //FMEditIPR7: TFMEdit;
  FMEditIPR8          : TFMEdit;   //FMEditIPR8: TFMEdit;
  FMEditReviewStatus  : TFMEdit;   //FMEditReviewStatus: TFMEdit;
  FMGetsIPRFile       : TFMGets;   //FMGetsIPRFile: TFMGets;
  FMGetsIPRFile3      : TFMGets;   //FMGetsIPRFile3: TFMGets;
  FMGetsTemplateInfo  : TFMGets;   //FMGetsTemplateInfo: TFMGets;
  FMListBox           : TFMListBox;//FMListboxIPR1 : TFMListBox;
  ListBoxIPR1         : TListBox;  //ListBoxIPR1: TListBox;
  MiniZip1            : TMiniZip;  //MiniZip1: TMiniZip;
  mmoFormDefinition   : TRichEdit; //FMMemoFormDefinition: TRichEdit;
  mmoReport           : TRichEdit; //RichEditReport: TRichEdit;
  mmoReportDefinition : TRichEdit; //FMMemoReportDefinition: TRichEdit;
  mmoScriptDefinition : TRichEdit; //FMMemoScriptDefinition: TRichEdit;
  Sender              : TObject;
  SenderName          : String;
  StatusMsg           : TLabel;    //StatusBarLoadPt: TLabel;
  xFMEditObjectCount  : TFMEdit;   //xFMEditObjectCount: TFMEdit;
  xFMTemplatesUtilized: TFMMemo    //xFMTemplatesUtilized: TFMMemo;
  );
Var
  codeLines         : TStrings;
  fileLines         : TStrings;
  formfilename      : String;
  formfilenamehandle: integer;
  formToMergeIEN    : String;
  PScript           : TStrings;
  reportLines       : TStrings;
  TempFMListbox     : TFMListbox;
  totalcount        : integer;
  x                 : Integer;
  xx                : Integer;
  y                 : Integer;

  xmlMapFile        : TStringList;
  xmlConfigFile     : TStringList;
Begin
  //*********************************************************
  SenderName:=LowerCase(SenderName);
  x := 0;

  If StatusMsg<>nil Then
  Begin
    StatusMsg.Caption := '';
    StatusMsg.Update;
  End;

  If Not frmMain.IsRPCBrokerConnected() Then Exit;
  If ANURemoteProcedureCallInProgress = True Then exit;
  If frmMain.IsPNCSOpen() Then Exit;

  // QC #2016 - JCS - Functionality no longer needed, and mostly replicated
  // by call to IsAllowed2OpenExam several lines down.
  // If Not frmMain.CanAccessReview() Then Exit;

  InfoComment := '';

  mmoFormDefinition.Lines.Clear;
  mmoScriptDefinition.Lines.Clear;
  mmoReportDefinition.Lines.Clear;
  mmoReport.Lines.Clear;
  If SenderName='frmmain.buttoniprdisplay' Then
    FMListBox.ItemIndex := FMListBox.Items.Count - 1 - ListBoxIPR1.ItemIndex;
  TempFMListbox := FMListBox As TFMListBox;
  If Not frmMain.IsPNCSRecordSelected(FMListBox) Then Exit;

  //Start main.pas
  FMGetsIPRFile.IENS := TempFMListBox.GetSelectedRecord.IEN;
  FMGetsIPRFile.GetAndFill;
  {Before starting program, save everything to a disk file}
  FMGetsIPRFile3.IENS := FMGetsIPRFile.IENS;
  FMGetsIPRFile3.GetAndFill;

  //Prevent unauthorized user from opening an 'unlocked' exam
  if not frmMain.IsAllowed2OpenExam(FMGetsIPRFile.IENS) then
    if not frmMain.IsLockedDate(FMGetsIPRFile.IENS) then
    begin
      ShowMessageCAPRI('You must be author, transcriber, or hold advanced security privileges to view this incomplete template.');
      Exit;
    end;

  //*********************************************************
  PScript := TStringList.Create;
  PScript.Clear;

  If frmMain.TIUShowModal(SenderName,FMListBox) Then Exit;

  If MergedFormMode <> true Then
    ReloadingForm := True
  Else
    ReloadingForm := False;

  frmMain.RPCBroker1.RemoteProcedure := 'DVBAB LOAD FORM';
  frmMain.RPCBroker1.Param[0].Value := frmMain.Piece(FMGetsIPRFile.IENS, ',', 1);
  frmMain.RPCBroker1.Param[0].PType := literal;
  frmMain.RPCBrokerCall;
  Try
    frmMain.RPCBroker1.Call;
  Except
    On EBrokerError Do
    Begin
      ANURemoteProcedureCallInProgress := False;
      frmMain.AnimateLogo(False);
      If StatusMsg<>nil Then
      Begin
        StatusMsg.Caption := 'DVBAB LOAD FORM could not be accessed!';
        StatusMsg.Repaint;
      End;
      Application.Processmessages;
      ShowMessageCAPRI('DVBAB LOAD FORM could not be accessed!');
      exit;
    End;
  End;
  QuickCopy(frmMain.RPCBroker1.Results, frmMain.formData.Lines);

  PNCSForm := TPNCSForm.Create(application);

  PNCSForm.xEditMode.Text            := 'OPEN';
  PNCSForm.xEditFormNum.text         := inttostr(x);
  PNCSForm.xPatientIENS.Caption      := FMEditIPR2.FMCtrlInternal;
  PNCSForm.xFMEdit2.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit4.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit5.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit6.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit7.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit8.IENS             := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit10.IENS            := FMGetsIPRFile.IENS;
  PNCSForm.xFMEdit11.IENS            := FMGetsIPRFile.IENS;
  PNCSForm.xFMEditReviewStatus.IENS  := FMGetsIPRFile.IENS;
  PNCSForm.xFormData.IENS            := FMGetsIPRFile.IENS; {Form Data  8}
  PNCSForm.xFMTemplatesUtilized.IENS := FMGetsIPRFile.IENS;

  If Not PNCSForm.DoLock Then
  Begin
    pncsForm.TemplateAction := '~CLOSE~';  //CodeCR107 - rpm 5/12/10
    PNCSForm.Hide;
    If assigned(UnsignedView) Then
      UnsignedView.FormatFormList1;
    Waitform.Hide;
    Exit;
  End;

  //Prevent GetAndFill from displaying control - rpm 3/18/09
  FMCommentsMemo.SendToBack;

  y:=-1;
  //First, load templates/do merge
  //for now, just read line 1
  totalcount := 0;
  For x := 0 To xFMTemplatesUtilized.Lines.Count - 1 Do
  Begin
    FormToMergeIEN := Piece(xFMTemplatesUtilized.Lines[x], '^', 1);
    If (xFMTemplatesUtilized.Lines[x]) = '' Then
    Begin
      ShowMessageCAPRI('The template definition info is missing.  Closing CAPRI to prevent data corruption.');
      application.terminate;
    End;
    FMGetsTemplateInfo.IENS := Piece(xFMTemplatesUtilized.Lines[x], '^', 1);
    FMGetsTemplateInfo.GetAndFill;
    InfoComment := InfoComment + Uppercase(Piece(xFMTemplatesUtilized.Lines[x], '^', 2)) + ':' + char(13);
    If FMCommentsMemo.Lines.Count > 0 Then
    Begin
      For xx := 0 To FMCommentsMemo.Lines.Count - 1 Do
        InfoComment := InfoComment + FMCommentsMemo.Lines[xx] + char(13);
    End
    Else
    Begin
      InfoComment := InfoComment + '[NO COMMENT FOUND]' + char(13);
    End;
    FMGetsTemplateInfo.IENS := Piece(xFMTemplatesUtilized.Lines[x], '^', 1);
    FMGetsTemplateInfo.GetAndFill;
    InfoComment := InfoComment + 'Object Count: ' + xFMEditObjectCount.Text + char(13);
    InfoComment := InfoComment + char(13);
    Try
      totalcount := totalcount + StrToInt(xFMEditObjectCount.Text);
    Except
    End;
    //************************************************************

    WaitForm.BringToFront;
    WaitForm.Label1.Caption := 'Loading ' + Piece(xFMTemplatesUtilized.Lines[x], '^', 2);
    waitform.imagedisk.visible := false;
    waitform.imagenetwork.visible := false;
    waitform.imagedisk.repaint;
    waitform.imagenetwork.repaint;
    WaitForm.Repaint;

    FMGetsTemplateInfo.IENS := formToMergeIEN;
    FMGetsTemplateInfo.GetData;

    formfilename := TempDir;
    formfilename := formfilename + FMGetsTemplateInfo.GetField('.01').FMDBExternal + '^';
    formfilename := formfilename + FMGetsTemplateInfo.GetField('5').FMDBInternal + '.zip';

    If fileexists(formfilename) = false Then
    Begin
      waitform.imagenetwork.visible := True;
      waitform.imagenetwork.repaint;
      waitform.repaint;

      frmMain.RPCBroker1.RemoteProcedure := 'DVBAB TEMPLATE DEFINITION';
      frmMain.RPCBroker1.Param[0].Value := formToMergeIEN;
      frmMain.RPCBroker1.Param[0].PType := literal;
      frmMain.RPCBroker1.Param[1].Value := '1';
      frmMain.RPCBroker1.Param[1].PType := literal;
      WaitForm.StaticText1.Caption := 'Loading definition...';
      Waitform.StaticText1.Repaint;
      frmMain.RPCBrokerCall;
      Try
        frmMain.RPCBroker1.Call;
      Except
        On EBrokerError Do
        Begin
          ANURemoteProcedureCallInProgress := False;
          frmMain.AnimateLogo(False);
          If StatusMsg<>nil Then
          Begin
            StatusMsg.Caption := 'DVBAB TEMPLATE DEFINITION could not be accessed!';
            StatusMsg.Repaint;
          End;
          Application.ProcessMessages;
          ShowMessageCAPRI('DVBAB TEMPLATE DEFINITION could not be accessed!');
        End;
      End;

      If frmMain.RPCBroker1.Results.Count = 0 Then
      Begin
        ShowmessageCAPRI('The template definition needed for ' + Piece(xFMTemplatesUtilized.Lines[x], '^', 2) + ' (IEN #' + formToMergeIEN + ') is no longer available in the file.');
        exit;
      End;

      screen.cursor := crhourglass;
      WaitForm.StaticText1.Caption := 'Decoding...';
      Waitform.StaticText1.Repaint;
      TempFileName := Copy(frmMain.RPCBroker1.Results[0], 11, 999);
      If TempFileName = '' Then
      Begin
        ShowMessageCAPRI('There was a problem with the definition file.  Exiting CAPRI.');
        application.terminate;
        exit;
      End;

      If FileExists(TempDir + TempFileName + '.uue') Then
      Begin
        Try
          DeleteFile(PAnsiChar(TempDir + TempFileName + '.uue'))
        Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
            application.terminate;
          End;
        End;
      End;

      If FileExists(TempDir + TempFileName) Then
      Begin
        Try
          DeleteFile(PAnsiChar(TempDir + TempFileName))
        Except
          Begin
            ShowMessageCAPRI('You have an outdated definition that cannot be deleted.  Exiting CAPRI.');
            application.terminate;
          End;
        End;
      End;

      frmMain.RPCBroker1.Results.SaveToFile(TempDir + TempFileName + '.uue');
      UUDecode(TempDir + TempFileName + '.uue');
      DeleteFile(PAnsiChar(TempDir + TempFileName + '.uue'));
      renamefile(TempDir + TempFileName, formfilename);
      MiniZip1.UnZipFile := formfilename;
      MiniZip1.UnzipAllTo(TempDir);
      MiniZip1.UnZipFile := '';
      TempFileName := Piece(TempFilename, '.', 1);

      RenameFile(TempDir + TempFileName + '.pnl.frm', formfilename + '.pnl.frm');
      RenameFile(TempDir + TempFileName + '.pnl.cde', formfilename + '.pnl.cde');
      RenameFile(TempDir + TempFileName + '.pnl.rep', formfilename + '.pnl.rep');

      if FileExists(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION) then
        RenameFile(TempDir + TempFileName + TXsdEngineLite.FILE_EXTENSION, formfilename + TXsdEngineLite.FILE_EXTENSION);

      if FileExists(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION) then
        RenameFile(TempDir + TempFileName + TXmlConfig.FILE_EXTENSION, formfilename + TXmlConfig.FILE_EXTENSION);      
      
    End
    Else
    Begin // end of file not found on disk yet
      waitform.imagedisk.visible := true;
      waitform.imagedisk.repaint;
      waitform.repaint
    End;

    // Touch form date/time
    formFileNameHandle := FileOpen(formFileName, fmOpenReadWrite);
    If formfileNamehandle > -1 Then
      FileSetDate(formfilename, DateTimeToFileDate(now));
    FileClose(formFileNameHandle);

    mmoFormDefinition.Lines.LoadFromFile(formfilename + '.pnl.frm');
    mmoScriptDefinition.Lines.LoadFromFile(formfilename + '.pnl.cde');
    mmoReportDefinition.Lines.LoadFromFile(formfilename + '.pnl.rep');

    if FileExists(formfilename + TXsdEngineLite.FILE_EXTENSION) then
    begin
      xmlMapFile := TStringList.Create;
      xmlMapFile.LoadFromFile(formfilename + TXsdEngineLite.FILE_EXTENSION);
    end;

    if FileExists(formfilename + TXmlConfig.FILE_EXTENSION) then
    begin
      xmlConfigFile := TStringList.Create;
      xmlConfigFile.LoadFromFile(formfilename + TXmlConfig.FILE_EXTENSION);
    end;

    // Might need to convert to Pascal
    If mmoReportDefinition.Lines.Count > 0 Then
      If Pos('PROGRAM ', Trim(Uppercase(mmoReportDefinition.Lines[0]))) <> 1 Then
      Begin
        PNCSForm.ConvertOldStyleScriptToPascalScript(mmoReportDefinition);
      End;

    If ANURemoteProcedureCallInProgress = True Then
      Repeat application.processMessages Until
      ANURemoteProcedureCallInProgress = False;

    codeLines   := TStringList.Create;
    fileLines   := TStringList.Create;
    reportLines := TStringList.Create;
    Try
      QuickCopy(mmoFormDefinition, fileLines);
      QuickCopy(mmoScriptDefinition, codeLines);
      QuickCopy(mmoReportDefinition, reportLines);

      // Check if PScript Type and do merge
      If POS('PROGRAM ', trim(uppercase(CodeLines[0]))) = 1 Then
      Begin
        MergePScript(PScript, CodeLines);
        codelines.clear;
        codelines.add('');
        codelines.add('');
      End;
                          //form def, script def, temp file name
      PNCSForm.LoadBaseExam(fileLines, codeLines, TempFileName,
                            xmlMapFile, xmlConfigFile);

    Finally
      FreeAndNil(codeLines  );
      FreeAndNil(fileLines  );
      FreeAndNil(reportLines);

      xmlMapFile := Nil;
      xmlConfigFile := Nil;
    End;
    //************************************************************

    PNCSForm.localExam := PNCSForm.Exams[0];

    PNCSForm.xOutputDesign.Lines.Add('// // // //!@#$FORMSTART$#@!');
    // Apppend the report to the existing one
    PNCSForm.xOutputDesign.Lines.Add(mmoReportDefinition.Lines.Text);
    PNCSForm.xOutputDesign.Lines.Add('// // // //!@#$FORMEND$#@!');

    inc(y);

    If y = 0 Then // Special case if only 1 Exam
      PNCSForm.localExam.Merge(Nil) // Merge with nothing
    Else
      PNCSForm.localExam.Merge(PNCSForm.Exams[y]);
  End;
  InfoComment := InfoComment + char(13);
  InfoComment := InfoComment + 'Total Object Count: ' + inttostr(totalcount) + char(13);
  WaitForm.StaticText1.Caption := 'Initializing...';
  Waitform.StaticText1.Repaint;
  waitform.imagedisk.visible := false;
  waitform.imagenetwork.visible := false;
  waitform.imagedisk.repaint;
  waitform.imagenetwork.repaint;
  waitform.repaint;
  //************************************************************

  PNCSForm.ShowExam;

  DeleteFile(PAnsiChar(TempDir + TempFileName + '.pnl'));

  QuickCopy(PNCSForm.localExam.Code.Script, PNCSForm.xMemoCode);
  WaitForm.Label1.Caption := 'Processing ...';
  WaitForm.Label1.Repaint;

  WaitForm.StaticText1.Caption := 'Repopulating objects...';
  Waitform.StaticText1.Repaint;
  QuickCopy(frmMain.FormData, PNCSForm.xFormData);
  QuickCopy(xFMTemplatesUtilized, PNCSForm.xFMTemplatesUtilized);
  PNCSForm.xDateTimeOfNote.Text := FMEditIPR7.Text;
  pncsform.caption := FMEditIPR11.Text;
  PNCSForm.xFMPatientName.Caption := PatientName;
  PNCSForm.xFMSSN.Caption := PatientSSN;
  PNCSForm.xAuthorButton.Caption := FMGetsIPRFile3.GetField('2').FMDBExternal;

  PNCSForm.xFMEdit2.Text := '`' + FMGetsIPRFile3.GetField('.01').FMDBInternal;
  If FMGetsIPRFile3.GetField('10').FMDBInternal <> '' Then
  Begin
    PNCSForm.xFMEdit4.Text := '`' + FMGetsIPRFile3.GetField('10').FMDBInternal; //Transcriber
    If PNCSForm.xFMEdit4.Validate Then
    Begin
      PNCSForm.xFMEdit4.Text := PNCSForm.xFMEdit4.FMCtrlExternal;
    End;
  End
  Else
    PNCSForm.xFMEdit4.Text := '';
  PNCSForm.xFMEdit5.Text := '`' + FMGetsIPRFile3.GetField('2').FMDBInternal;
  PNCSForm.xFMEdit6.Text := FMEditIPR6.Text;
  PNCSForm.xFMEdit7.Text := FMEditIPR7.Text;
  PNCSForm.xFMEdit8.Text := FMEditIPR8.Text;
  PNCSForm.xFMEdit10.Text := FMEditIPR10.Text;
  PNCSForm.xFMEdit11.Text := FMEditIPR11.Text;
  PNCSForm.xFMEditReviewStatus.Text := FMEditReviewStatus.Text;

  if PScript.Count > 0 then
  begin
    Quickcopy(PScript, PNCSForm.xMemoCode);
    PNCSForm.zzzzEditScriptStyle.text := 'PASCAL SCRIPT';
  end;
  PNCSForm.SetupForm(Sender);
  PScript.free;
  PNCSForm.xTimerGo.Enabled := True;
  screen.cursor := crdefault;
End;

end.
