unit pncsdebugunit;

interface

uses
  Windows,
  Messages,
  SysUtils,
  Classes,
  Graphics,
  Controls,
  Forms,
  Dialogs,
  StdCtrls,
  ExtCtrls,
  PNCSCodeRun,
  ComCtrls;

type
  TfrmPNCS   ug = class(TForm)
    LabelScriptStatus: TLabel;
    Timer1: TTimer;
    LabelScriptExecuting: TLabel;
    GroupBox1: TGroupBox;
    RichEditScript: TRichEdit;
    Button1: TButton;
    Button2: TButton;
    SaveDialog1: TSaveDialog;
    Button3: TButton;
    Label1: TLabel;
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmPNCS   ug: TfrmPNCS   ug;

implementation

uses PNCSMain;

{$R *.DFM}

procedure TfrmPNCS   ug.Timer1Timer(Sender: TObject);
begin
  if FormRunning = True then begin
    LabelScriptStatus.caption := 'Script is ON.';
    LabelScriptStatus.Font.Color := clGreen;
  end
  else begin
    LabelScriptStatus.caption := 'Script is OFF.';
    LabelScriptStatus.Font.Color := clRed;
    LabelScriptExecuting.caption := 'Script is waiting.';
    LabelScriptExecuting.Font.Color := clRed;
  end;
  if FormWaiting = False then begin
    LabelScriptExecuting.caption := 'Script is executing.';
    LabelScriptExecuting.Font.Color := clGreen;
  end
  else begin
    LabelScriptExecuting.caption := 'Script is waiting.';
    LabelScriptExecuting.Font.Color := clRed;
  end;
  if inttostr(RichEditScript.Lines.Count) + ' lines' <> Label1.Caption then
    Label1.Caption := inttostr(RichEditScript.Lines.Count) + ' lines';
end;

procedure TfrmPNCS   ug.Button1Click(Sender: TObject);
begin
  SaveDialog1.Title := 'Save Script Execution';
  if SaveDialog1.Execute then begin
    try
      RichEditScript.Lines.SaveToFile(SaveDialog1.FileName);
    except
      MessageDlg('File I/O error.', mtError, [mbOk], 0);
    end;
  end;
end;

procedure TfrmPNCS   ug.Button2Click(Sender: TObject);
begin
  SaveDialog1.Title := 'Save Full Script';
  if SaveDialog1.Execute then begin
    try
      PNCSForm.xMemoCode.Lines.SaveToFile(SaveDialog1.FileName);
    except
      MessageDlg('File I/O error.', mtError, [mbOk], 0);
    end;
  end;
end;

procedure TfrmPNCS   ug.Button3Click(Sender: TObject);
begin
  RichEditScript.Lines.Clear;
end;

end.
