Unit unsigned;

Interface

Uses
  Windows,
  Buttons,
  Classes,
  ClipBrd,
  ComCtrls,
  Controls,
  Diaccess,
  Dialogs,
  DialogsCAPRI,
  DiTypLib,
  ExtCtrls,
  Fmcmpnts,
  Fmcntrls,
  Forms,
  Graphics,
  IniFiles,
  main,
  Menus,
  MergePScripts,
  Messages,
  ORCtrls,
  ORFn,
  orNet,
  PNCSMain,
  StdCtrls,
  SysUtils,
  Tabnotbk,
  Trpcb,
  UUCode,
  wait,
  ZipMcpt, ActnPopup;
  //jcs - d2006
  //ZipMstr;

Type
  TUnsignedView = Class(TForm)
    Button1                  : TButton;
    Button2                  : TButton;
    Button3                  : TButton;
    Button4                  : TButton;
    Button5                  : TButton;
    Button6                  : TButton;
    CCOWTimer                : TTimer;
    FMCommentsMemo           : TFMMemo;
    FMEdit11                 : TFMEdit;
    FMEditIPR10              : TFMEdit;
    FMEditIPR11              : TFMEdit;
    FMEditIPR2               : TFMEdit;
    FMEditIPR4               : TFMEdit;
    FMEditIPR5               : TFMEdit;
    FMEditIPR6               : TFMEdit;
    FMEditIPR7               : TFMEdit;
    FMEditIPR8               : TFMEdit;
    FMEditReviewStatus       : TFMEdit;
    FMFinder1                : TFMFinder;
    FMGetsIPRFile            : TFMGets;
    FMGetsIPRFile3           : TFMGets;
    FMGetsPatientFile        : TFMGets;
    FMGetsTemplateDefinitions: TFMGets;
    FMGetsTemplateInfo       : TFMGets;
    FMLabel1                 : TFMLabel;
    FMListBoxIPR1            : TFMListBox;
    FMMemoFormDefinition     : TRichEdit;
    FMMemoReportDefinition   : TRichEdit;
    FMMemoScriptDefinition   : TRichEdit;
    FormData                 : TFMMemo;
    ImageFlagExclamation     : TImage;
    ImageFlagFlag            : TImage;
    ImageFlagNew             : TImage;
    Label1                   : TLabel;
    LabelGridHeader          : TLabel;
    MiniZip1                 : TMiniZip;
    RichEditReport           : TRichEdit;
    Timer1                   : TTimer;
    xFMEditObjectCount       : TFMEdit;
    xFMTemplatesUtilized     : TFMMemo;
    ZFMFinder1               : TFMFinder;
    mnuPopUnsigndTemplates: TPopupActionBar;
    mnuPopUnsignedDelete: TMenuItem;
    menuPopTempN1: TMenuItem;
    mnuPopUnsignedTogNew: TMenuItem;
    mnuPopUnsignedTogGreen: TMenuItem;
    mnuPopUnsignedTogExclamation: TMenuItem;
    Procedure Button1Click(Sender: TObject);
    Procedure Button2Click(Sender: TObject);
    Procedure Button3Click(Sender: TObject);
    Procedure Button4Click(Sender: TObject);
    Procedure Button5Click(Sender: TObject);
    Procedure Button6Click(Sender: TObject);
    Procedure CCOWTimerTimer(Sender: TObject);
    Procedure FMListBoxIPR1Click(Sender: TObject);
    Procedure FMListBoxIPR1DrawItem(Control: TWinControl; Index: Integer;Rect: TRect; State: TOwnerDrawState);
    Procedure FMListBoxIPR1KeyUp(Sender: TObject; Var Key: Word;Shift: TShiftState);
    Procedure FormActivate(Sender: TObject);
    Procedure FormatFormList1;
    Procedure FormClose(Sender: TObject; Var Action: TCloseAction);
    Procedure FormCloseQuery(Sender: TObject; Var CanClose: Boolean);
    Procedure FormCreate(Sender: TObject);
    Procedure FormShow(Sender: TObject);
    Procedure PopupTemplatesListMenuPopup(Sender: TObject);
    Procedure Timer1Timer(Sender: TObject);
    procedure mnuPopUnsignedTogNewClick(Sender: TObject);
    procedure mnuPopUnsignedTogGreenClick(Sender: TObject);
    procedure mnuPopUnsignedTogExclamationClick(Sender: TObject);
    procedure mnuPopUnsignedDeleteClick(Sender: TObject);
  End;

Var
  Locked: Boolean;
  UnsignedView: TUnsignedView;

Implementation

Uses
  CPWMObjects,
  deletetemplateverification,
  pncsreviewer,
  pncsShow,
  CCOWRPCBrokerCAPRI;

{$R *.DFM}

Procedure TUnsignedView.FormatFormList1;
Var
  examinerName: String;
  examinerNameLen: integer;
  examName: String;
  examNameLen: integer;
  F1: String;
  F1Len: integer;
  F2: String;
  F2Len: integer;
  F3: String;
  i: integer;
  Line: String;
  patientName: String;
  status: String;
  statusLen: integer;
  tempindex: integer;
  x: Integer;
Begin
  For x := 1 To 100 Do
    Application.ProcessMessages; // to solve xmemocode has no parent window issue;

  FMListBoxIPR1.Visible := False;

  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := 0 To FMListBoxIPR1.Items.Count - 1 Do
    Begin

      Line := FMListBoxIPR1.Items[x];
      patientName := Copy(Line, 1, pos('  ', Line));
      Line := Copy(Line, length(patientname) + 1, Length(Line));

      Line := TrimLeft(Line);

      examName := Copy(Line, 1, pos('  ', Line));
      examNameLen := Length(examName);
      Line := Copy(Line, examNameLen + 1, Length(Line));
      Line := TrimLeft(Line);

      examinerName := Copy(Line, 1, pos('  ', Line));
      examinerNameLen := Length(examinerName);
      Line := Copy(Line, examinerNameLen + 1, Length(Line));
      Line := TrimLeft(Line);

      Status := Copy(Line, 1, pos('  ', Line));
      StatusLen := Length(Status);
      Line := Copy(Line, StatusLen + 1, Length(Line));
      Line := TrimLeft(Line);

      F1 := Copy(Line, 1, pos('  ', Line));
      F1Len := Length(F1);
      Line := Copy(Line, F1Len + 1, Length(Line));
      Line := TrimLeft(Line);
      F1 := Trim(F1);
      If F1 = '' Then
        F1 := ' ';

      F2 := Copy(Line, 1, pos('  ', Line));
      F2Len := Length(F2);
      Line := Copy(Line, F2Len + 1, Length(Line));
      Line := TrimLeft(Line);
      F2 := Trim(F2);
      If F2 = '' Then
        F2 := ' ';

      F3 := trim(line);
      If F3 = '' Then
        F3 := ' ';

      // !=Individual item in a merged exam
      If Copy(Line, 1, 1) <> '!' Then
        FMListBoxIPR1.Items[x] := Format('%-23.23s  %-4s%-25.25s  %-22.22s  %s', [patientName, F1 + F2 + F3, examName, examinerName, status])
    End;

  End;
  self.BorderIcons := [biSystemMenu];
  FMListBoxIPR1.Enabled := True;
  FMListBoxIPR1.ItemIndex := -1;
  Button5.Enabled := True;
  Button6.Enabled := True;
  Button4.Enabled := True;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    FMListBoxIPR1.ItemIndex := 0;
    FMListBoxIPR1.ItemIndex := -1;
  End;

  // 1U4N section is here
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    tempIndex := FMListBoxIPR1.ItemIndex;
    If ANURemoteProcedureCallInProgress = True Then
      exit;
    frmMain.RPCBroker1.Results.Clear;
    frmMain.RPCBroker1.RemoteProcedure := 'DVBAB FETCH 1U4N';
    frmMain.RPCBroker1.Param[1].PType := list;
    i := 0;
    x := 0;
    Repeat
      Begin
        FMListBoxIPR1.ItemIndex := x;
        If Copy(FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
        Begin // Don't count merged form details in the list
          frmMain.RPCBroker1.Param[1].Mult[IntToStr(i + 1)] := FMListBoxIPR1.GetSelectedRecord.IEN;
          inc(i);
        End;
        inc(x);
        If x > FMListBoxIPR1.Items.Count - 1 Then
          x := -1;
    End Until x = -1;
    frmMain.RPCBrokerCall;
    Try
      frmMain.RPCBroker1.Call;
    Except
      On EBrokerError Do
      Begin
        ANURemoteProcedureCallInProgress := False;
        frmMain.AnimateLogo(False);
        frmMain.StatusBarLoadPt.Caption := 'DVBAB FETCH 1U4N could not be accessed!';
        frmMain.StatusBarLoadPt.Repaint;
        Application.ProcessMessages;
        ShowMessageCAPRI('DVBAB FETCH 1U4N could not be accessed!');
      End;
    End;

    If frmMain.RPCBroker1.Results.Count = 0 Then
      exit;

    i := 0;
    x := 0;
    Repeat
      Begin
        If Copy(FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
        Begin // Don't count merged form details in the list
          FMListBoxIPR1.Items[x] := Piece(frmMain.RPCBroker1.Results[i], '^', 2) + '  ' + FMListBoxIPR1.Items[x];
          inc(i);
        End;
        inc(x);
        If x > FMListBoxIPR1.Items.Count - 1 Then
          x := -1;
    End Until x = -1;
    FMListBoxIPR1.ItemIndex := tempIndex;
  End;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    // Brings list to the top
    FMListBoxIPR1.ItemIndex := 0;
    FMListBoxIPR1.ItemIndex := -1;
  End;
  FMListBoxIPR1.Visible := True;
End;

Procedure TUnsignedView.Button5Click(Sender: TObject);
Var
  oldIndex: String;
  oldScreen: String;
  oldValue: String;
  tempstring: String;
  x: integer;
  xx: integer;
Begin

  If Not frmMain.IsRPCBrokerConnected() Then Exit;
  Label1.Caption := '1';

  FMFinder1.DisplayFields.Clear;
  FMFinder1.DisplayFields.Add('.01');
  FMFinder1.DisplayFields.Add('9');
  FMFinder1.DisplayFields.Add('2');
  FMFinder1.DisplayFields.Add('11');
  FMFinder1.DisplayFields.Add('19');
  FMFinder1.DisplayFields.Add('20');
  FMFinder1.DisplayFields.Add('21');
  FMFInder1.FieldNumbers.Clear;
  FMFinder1.FieldNumbers.Add('.01');
  FMFinder1.FieldNumbers.Add('9');
  FMFinder1.FieldNumbers.Add('2');
  FMFinder1.FieldNumbers.Add('11');
  FMFinder1.FieldNumbers.Add('19');
  FMFinder1.FieldNumbers.Add('20');
  FMFinder1.FieldNumbers.Add('21');

  {Increase performance by using Author index instead of
   pulling all unlocked records - rpm 05/27/2008}
  oldIndex := FMFinder1.FMIndex;
  oldScreen := FMFinder1.Screen;
  oldValue := FMFinder1.Value;
  FMFinder1.FMIndex := 'AT';
  //screen for Unlocked records that are not in a REVIEW PENDING status
  FMFinder1.Screen := 'I $P(^(0),U,5)="2800101",$P(^DVB(396.17,Y,5),U,2)''="P"';
  FMFinder1.Value := frmMain.RPCBroker1.User.Name;

  Button2.Enabled := False;
  Try
  FMFinder1.GetFinderList(FMListBoxIPR1.Items)Except
  End;

  {Restore old FM properties after Get call - rpm 5/27/2008}
  FMFinder1.FMIndex := oldIndex;
  FMFinder1.Screen := oldScreen;
  FMFinder1.Value := oldValue;

  //figure out merged forms and expand
  FMListBoxIPR1.Visible := False;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    Begin
      TempString := FMListBoxIPR1.Items[x];
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      If Copy(TempString, 1, Length('MERGED FORM  ')) = 'MERGED FORM  ' Then
      Begin
        // Insert individual merge form names here
        FMListBoxIPR1.ItemIndex := x;
        Try
          Begin
            FMGetsIPRFile3.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
            FMGetsIPRFile3.GetAndFill;
        End Except;
          ShowmessageCAPRI(FMListBoxIPR1.Items[x]);
        End;
        For xx := 0 To xFMTemplatesUtilized.Lines.Count - 1 Do
        Begin
          Try
            FMListBoxIPR1.Items.Insert(x + 1 + xx, '!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2))
          Except
            FMListBoxIPR1.Items.Add('!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2));
          End;
        End;
      End;
    End;
  End;
  FormatFormList1;
  exit;
End;


Procedure TUnsignedView.FMListBoxIPR1Click(Sender: TObject);
Var
  x: integer;
Begin
  Button1.Enabled := True;
  Button2.Enabled := True;

  // Deal with a sub-form component being clicked
  If Copy(FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex], 1, 1) = '!' Then
  Begin
    x := FMListBoxIPR1.ItemIndex;
    Repeat
      dec(x);
    Until Copy(FMListBoxIPR1.Items[x], 1, 1) <> '!';
    FMListBoxIPR1.ItemIndex := x;
  End;
End;

Procedure TUnsignedView.Button2Click(Sender: TObject);
Var
  quit: boolean;
  s: String;
  x: integer;
Begin
  Inherited;
  If ANURemoteProcedureCallInProgress = True Then
    exit;
  If button2.enabled = false Then
    exit;

  FMGetsIPRFile.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
  FMGetsIPRFile.GetAndFill;
  FMGetsIPRFile3.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
  FMGetsIPRFile3.GetAndFill;
  If (FMEditIPR8.Text <> '') And (FMEditIPR8.Text <> 'JAN 01, 1980') Then
    Locked := True
  Else
    Locked := False; {If there is a saved date, lock the record}
  If Locked = True Then
  Begin
    ShowMessageCAPRI('You can''t delete a signed form!');
    exit;
  End;

  // QC #2016 - jcs - Prevent unauthorized user from deleting an 'unlocked' exam
  if not frmMain.IsAllowed2OpenExam(FMGetsIPRFile.IENS) then
  begin
    ShowMessageCAPRI('You must be author, transcriber, or hold advanced security privileges to delete this incomplete template.');
    Exit;
  end;

    //If Locked=False then if Application.MessageBox('CAUTION!!!  Are you really sure you want to delete this unsigned form?','Cancel?',4)=IDYes then
  frmDeleteTemplate := TfrmDeleteTemplate.Create(self);
  frmDeleteTemplate.memoTemplateInfo.Lines.Clear;
  frmDeleteTemplate.memoTemplateInfo.Lines.Add(FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex]);
  x := 1;
  If FMListBoxIPR1.ItemIndex < FMListBoxIPR1.Items.Count - 1 Then
    If Copy(FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex + 1], 1, 1) = '!' Then
      Repeat
        s := FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex + x];
        s := copy(s, 2, length(s) - 1);
        frmDeleteTemplate.memoTemplateInfo.Lines.Add(s);
        inc(x);
        If x + FMListBoxIPR1.ItemIndex > FMListBoxIPR1.Items.Count - 1 Then
          x := 0; // Need to do this to prevent range check error after last item
      Until (x = 0) Or (Copy(FMListBoxIPR1.Items[FMListBoxIPR1.ItemIndex + x], 1, 1) <> '!');

  If Locked = False Then
    If frmDeleteTemplate.ShowModal = mrOK Then
    Begin
      DeleteRecord(frmMain.RPCBroker1, '396.17', FMGetsIPRFile3.IENS);
      x := FMListBoxIPR1.ItemIndex;
      FMListBoxIPR1.Items.Delete(x);
      // Delete form list
      Quit := False;
      If x < FMListBoxIPR1.Items.Count Then
        If Copy(FMListBoxIPR1.Items[x], 1, 1) = '!' Then
          Repeat
            FMListBoxIPR1.Items.Delete(x);
            If x > FMListBoxIPR1.Items.Count - 1 Then
              quit := true
            Else
              If Copy(FMListBoxIPR1.Items[x], 1, 1) <> '!' Then
                quit := true;
          Until quit = true;
    End;
  frmDeleteTemplate.release;
  Button2.Enabled := False;
End;

Procedure TUnsignedView.Button3Click(Sender: TObject);
Var
  x: integer;
Begin
  Label1.Caption := '2';

  FMFinder1.DisplayFields.Clear;
  FMFinder1.DisplayFields.Add('.01');
  FMFinder1.DisplayFields.Add('9');
  FMFinder1.DisplayFields.Add('10');
  FMFInder1.FieldNumbers.Clear;
  FMFinder1.FieldNumbers.Add('.01');
  FMFinder1.FieldNumbers.Add('9');
  FMFinder1.FieldNumbers.Add('10');

  Button2.Enabled := False;
  Try
  FMFinder1.GetFinderList(FMListBoxIPR1.Items)Except
  End;
  If FMListBoxIPR1.Items.Count > 0 Then
    For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    Begin
      If Pos(AuthorName, FMListBoxIPR1.Items[x]) = 0 Then
        FMLIstBoxIPR1.Items.Delete(x);
    End;
  FormatFormList1;
End;

Procedure TUnsignedView.Button4Click(Sender: TObject);
Var
  x: integer;
  xx: integer;
  tempstring: String;
  oldIndex, oldScreen, oldValue: String;
Begin
  If Not frmMain.IsRPCBrokerConnected() Then Exit;

  Label1.Caption := '4';

  FMFinder1.DisplayFields.Clear;
  FMFinder1.DisplayFields.Add('.01');
  FMFinder1.DisplayFields.Add('9');
  FMFinder1.DisplayFields.Add('2');
  FMFinder1.DisplayFields.Add('11');
  FMFinder1.DisplayFields.Add('19');
  FMFinder1.DisplayFields.Add('20');
  FMFinder1.DisplayFields.Add('21');
  FMFInder1.FieldNumbers.Clear;
  FMFinder1.FieldNumbers.Add('.01');
  FMFinder1.FieldNumbers.Add('9');
  FMFinder1.FieldNumbers.Add('2');
  FMFinder1.FieldNumbers.Add('11');
  FMFinder1.FieldNumbers.Add('19');
  FMFinder1.FieldNumbers.Add('20');
  FMFinder1.FieldNumbers.Add('21');

  {Increase performance by using Review Status index instead of
   pulling all unlocked records - rpm 05/27/2008}
  oldIndex := FMFinder1.FMIndex;
  oldScreen := FMFinder1.Screen;
  oldValue := FMFinder1.Value;
  FMFinder1.Value := 'REVIEW PENDING';
  FMFinder1.FMIndex := 'RS';
  FMFinder1.Screen := 'I $P(^(0),U,5)="2800101"'; //Unlocked records only

  Button2.Enabled := False;
  Try
  FMFinder1.GetFinderList(FMListBoxIPR1.Items)Except
  End;

  {Restore old FM properties after Get call - rpm 5/27/2008}
  FMFinder1.FMIndex := oldIndex;
  FMFinder1.Screen := oldScreen;
  FMFinder1.Value := oldValue;

  //figure out merged forms and expand
  FMListBoxIPR1.Visible := False;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    Begin
      TempString := FMListBoxIPR1.Items[x];
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      If Copy(TempString, 1, Length('MERGED FORM  ')) = 'MERGED FORM  ' Then
      Begin
        FMListBoxIPR1.ItemIndex := x;
        Try
          Begin
            FMGetsIPRFile3.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
            FMGetsIPRFile3.GetAndFill;
        End Except;
          ShowmessageCAPRI(FMListBoxIPR1.Items[x]);
        End;
        For xx := 0 To xFMTemplatesUtilized.Lines.Count - 1 Do
        Begin
          Try
            FMListBoxIPR1.Items.Insert(x + 1 + xx, '!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2))
          Except FMListBoxIPR1.Items.Add('!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2));
          End;
        End;
      End;
    End;
  End;
  FormatFormList1;
End;

Procedure TUnsignedView.FormShow(Sender: TObject);
Begin
  LabelGridHeader.Caption := Format('%-5s  %-23.23s  %-4s%-25.25s  %-22.22s  %s', ['ID', 'Patient', '   ', 'Template', 'Author', 'Status']);
End;

procedure TUnsignedView.mnuPopUnsignedDeleteClick(Sender: TObject);
begin
  Button2Click(Application);
end;

procedure TUnsignedView.mnuPopUnsignedTogExclamationClick(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempstring: String;
Begin
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If (TempText[35] = 'Y') Then
  Begin
    tempstring := 'N';
  End
  Else
  Begin
    tempstring := 'Y';
  End;
  temptext[35] := tempstring[1];
  FMListBoxIPR1.Items[item] := temptext;
  FMListBoxIPR1DrawItem(FMListBoxIPR1, item, rect(0, 0, 0, 0), [odSelected]);
  If tempstring = 'Y' Then
    tempstring := '1'
  Else
    tempstring := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '21', tempstring);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;

procedure TUnsignedView.mnuPopUnsignedTogGreenClick(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempstring: String;
Begin
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If (TempText[34] = 'Y') Then
  Begin
    tempstring := 'N';
  End
  Else
  Begin
    tempstring := 'Y';
  End;
  temptext[34] := tempstring[1];
  FMListBoxIPR1.Items[item] := temptext;
  FMListBoxIPR1DrawItem(FMListBoxIPR1, item, rect(0, 0, 0, 0), [odSelected]);
  If tempstring = 'Y' Then
    tempstring := '1'
  Else
    tempstring := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '20', tempstring);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;

procedure TUnsignedView.mnuPopUnsignedTogNewClick(Sender: TObject);
Var
  temptext: String;
  item: integer;
  tempstring: String;
Begin
  item := FMListBoxIPR1.ItemIndex;
  temptext := FMListBoxIPR1.Items[item];
  If (TempText[33] = 'Y') Or (TempText[33] = ' ') Or (TempText[33] = '') Then
  Begin
    tempstring := 'N';
  End
  Else
  Begin
    tempstring := 'Y';
  End;
  temptext[33] := tempstring[1];
  FMListBoxIPR1.Items[item] := temptext;
  FMListBoxIPR1DrawItem(FMListBoxIPR1, item, rect(0, 0, 0, 0), [odSelected]);
  If tempstring = 'Y' Then
    tempstring := '1'
  Else
    tempstring := '0';
  frmmain.fmfiler1.AddFDA('396.17', FMListBoxIPR1.GetSelectedRecord.IEN, '19', tempstring);
  If Not frmmain.fmfiler1.Update Then
  Begin
    frmmain.fmfiler1.DisplayErrors;
    ShowMessageCAPRI('There was an error setting the flag.');
  End;
end;

Procedure TUnsignedView.FormCreate(Sender: TObject);
Begin

// QC #2016 - jcs - Ensure button is always enabled to match right click delete.
//  If ANUCanEditCPWM = False Then
//  Begin
//    Button2.Visible := False;
//  End;

End;

Procedure TUnsignedView.Button6Click(Sender: TObject);
Var
  x: integer;
  xx: integer;
  tempstring: String;
Begin
  If Not frmMain.IsRPCBrokerConnected() Then Exit;

  Label1.Caption := '3';

  FMFinder1.DisplayFields.Clear;
  FMFinder1.DisplayFields.Add('.01');
  FMFinder1.DisplayFields.Add('9');
  FMFinder1.DisplayFields.Add('2');
  FMFinder1.DisplayFields.Add('11');
  FMFinder1.DisplayFields.Add('19');
  FMFinder1.DisplayFields.Add('20');
  FMFinder1.DisplayFields.Add('21');
  FMFInder1.FieldNumbers.Clear;
  FMFinder1.FieldNumbers.Add('.01');
  FMFinder1.FieldNumbers.Add('9');
  FMFinder1.FieldNumbers.Add('2');
  FMFinder1.FieldNumbers.Add('11');
  FMFinder1.FieldNumbers.Add('19');
  FMFinder1.FieldNumbers.Add('20');
  FMFinder1.FieldNumbers.Add('21');
  Button2.Enabled := False;
  Try
  FMFinder1.GetFinderList(FMListBoxIPR1.Items)Except
  End;
  //figure out merged forms and expand
  FMListBoxIPR1.Visible := False;
  If FMListBoxIPR1.Items.Count > 0 Then
  Begin
    For x := FMListBoxIPR1.Items.Count - 1 Downto 0 Do
    Begin
      TempString := FMListBoxIPR1.Items[x];
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      TempString := Copy(tempstring, Pos('  ', tempstring) + 2, 999);
      If Copy(TempString, 1, Length('MERGED FORM  ')) = 'MERGED FORM  ' Then
      Begin
        FMListBoxIPR1.ItemIndex := x;
        Try
          Begin
            FMGetsIPRFile3.IENS := FMListBoxIPR1.GetSelectedRecord.IEN;
            FMGetsIPRFile3.GetAndFill;
        End Except;
          ShowmessageCAPRI(FMListBoxIPR1.Items[x]);
        End;
        For xx := 0 To xFMTemplatesUtilized.Lines.Count - 1 Do
        Begin
          Try
            FMListBoxIPR1.Items.Insert(x + 1 + xx, '!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2))
          Except FMListBoxIPR1.Items.Add('!' + Piece(xFMTemplatesUtilized.Lines[xx], '^', 2));
          End;
        End;
      End;
    End;
  End;

  FormatFormList1;
End;

Procedure TUnsignedView.FormClose(Sender: TObject;
  Var Action: TCloseAction);
Begin
  modalresult := mrcancel;
  If PNCSForm <> Nil Then
  Begin
    PNCSForm.Release;
  End;
End;

Procedure TUnsignedView.FormCloseQuery(Sender: TObject;
  Var CanClose: Boolean);
Begin
  CanClose := True;
  If PNCSForm <> Nil Then
  Begin
    canClose := False;
    ShowMessageCAPRI('Please close the open template first.');
  End;
End;

Procedure TUnsignedView.Timer1Timer(Sender: TObject);
Begin
  If haltflag = true Then unsignedview.modalresult := mrok;
End;

Procedure TUnsignedView.CCOWTimerTimer(Sender: TObject);
Var
  Action: TCloseAction;
Begin
  If ShutdownCAPRIModalDialogs = true Then
  Begin
    CCOWTimer.Enabled := False;
    If PNCSForm <> Nil Then
      Repeat Application.ProcessMessages Until PNCSForm = Nil;
    action := caHide;
    UnsignedView.FormClose(Application, action);
    UnsignedView.Visible := False;
  End;
End;

Procedure TUnsignedView.FormActivate(Sender: TObject);
Begin
  CCOWTimer.Enabled := True;
End;

Procedure TUnsignedView.FMListBoxIPR1DrawItem(Control: TWinControl;
  Index: Integer; Rect: TRect; State: TOwnerDrawState);
Var
  BitmapFlagRect: tRect;
  itemcount: integer;
  lastindex: integer;
  mergemode: boolean;
  RectHeight: integer;
  tempString: String;
  TempText: String;
  tempx: integer;
  x: integer;
Begin
  Inherited;
  RectHeight := 0;
  lastindex := -1;
  With (Control As TListBox).Canvas Do { draw on control canvas, not on the form }
  Begin
    Font.Color := clWindowText; {Set to default color}
    Font.Style := [];
    Brush.Color := clWindow;
    TempText := (Control As TListBox).Items[Index];
    MergeMode := False;
    If Copy(TempText, 1, 1) = '*' Then
    Begin
      Font.Color := clRed; {Change color to show unsigned}
      TempText := Copy((Control As TListBox).Items[Index], 2, Length((Control As TListBox).Items[Index]) - 1)
    End;
    If Copy(TempText, 1, 1) = '!' Then
    Begin
      Font.Color := clOlive; {Change color to show unsigned}
      Font.Style := [fsItalic];
      TempText := '  ' + Piece(Temptext, '!', 2); // Get rid of the '!' at the beginning and indent;
    End;
    TempString := FMListBoxIPR1.Items[Index];
    // Deal with flags
    If TempString[1] <> '!' Then
    Begin
      // Insert 2 spaces
      If (TempText[33] = 'Y') Or (TempText[33] = ' ') Then
        TempText[33] := #128
      Else
        TempText[33] := ' '; // Flag New
      If TempText[34] = 'Y' Then
        TempText[34] := #129
      Else
        TempText[34] := ' '; // Flag Green Flag
      If TempText[35] = 'Y' Then
        TempText[35] := #130
      Else
        TempText[35] := ' '; // Flag Exclamation
    End;
    If Copy(TempString, 28, Length('MERGED FORM  ')) = 'MERGED FORM  ' Then
    Begin
      lastindex := index;
      Repeat
        inc(lastindex)
      Until (lastindex = (Control As TListBox).Items.Count - 1) Or (Copy((Control As TListBox).Items[lastindex], 1, 1) <> '!');
      // Check last item, in case this is the end of the list
      If Copy((Control As TListBox).Items[lastindex], 1, 1) <> '!' Then
        dec(lastindex);
      ItemCount := Lastindex - Index + 1;
      RectHeight := Rect.bottom - Rect.Top;
      Rect.Bottom := Rect.Top + (RectHeight * ItemCount); // Need this for the highlighting
      Rect.BottomRight.y := Rect.Top + (RectHeight * ItemCount);
      MergeMode := True;
    End;
    If state = [odSelected, odFocused] Then
      Brush.Color := clBtnFace;
    FillRect(rect); { clear the rectangle }
    TextOut(Rect.Left, Rect.Top, TempText); { display the text }

    // Insert flag images if special codes are found
    If length(temptext) > 0 Then
      For x := 1 To length(temptext) Do
      Begin
        If temptext[x] = #128 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          FMListBoxIPR1.Canvas.StretchDraw(BitmapFlagRect, ImageFlagNew.Picture.Graphic);
        End;
        If temptext[x] = #129 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          FMListBoxIPR1.Canvas.StretchDraw(BitmapFlagRect, ImageFlagFlag.Picture.Graphic);
        End;
        If temptext[x] = #130 Then
        Begin
          tempx := TextWidth('Z') * (x - 1);
          BitmapFlagRect.Left := Rect.Left + tempx;
          BitmapFlagRect.Top := Rect.Top;
          BitmapFlagRect.Right := BitmapFlagRect.Left + TextWidth('Z');
          BitmapFlagRect.Bottom := BitmapFlagRect.Top + TextHeight('Z');
          FMListBoxIPR1.Canvas.StretchDraw(BitmapFlagRect, ImageFlagExclamation.Picture.Graphic);
        End;
      End;

    // Draw the individual items under the merge form
    If MergeMode = True Then
    Begin
      Pen.Color := clYellow;
      FrameRect(Rect);
      For x := index + 1 To lastindex Do
      Begin
        Font.Color := clOlive; {Change color to show unsigned}
        Font.Style := [fsItalic];
        temptext := '  ' + Piece((Control As TListBox).Items[x], '!', 2);
        Rect.Top := Rect.Top + RectHeight;
        TextOut(Rect.Left, Rect.Top, TempText); { display the text }
      End;
    End;
  End;
End;

Procedure TUnsignedView.FMListBoxIPR1KeyUp(Sender: TObject; Var Key: Word;
  Shift: TShiftState);
Begin
  // Delete key
  If key = 46 Then
    If button2.visible = true Then
      button2click(application);
  // Enter key
  If key = 13 Then
    button1click(application);
End;

Procedure TUnsignedView.PopupTemplatesListMenuPopup(Sender: TObject);
Begin
  If FMListBoxIPR1.ItemIndex = -1 Then
  Begin
    mnuPopUnsignedDelete.Enabled := False;
    mnuPopUnsignedTogNew.Enabled := False;
    mnuPopUnsignedTogGreen.Enabled := False;
    mnuPopUnsignedTogExclamation.Enabled := False;
  End
  Else
  Begin
    mnuPopUnsignedDelete.Enabled := True;
    mnuPopUnsignedTogNew.Enabled := True;
    mnuPopUnsignedTogGreen.Enabled := True;
    mnuPopUnsignedTogExclamation.Enabled := True;
  End;
End;

Procedure TUnsignedView.Button1Click(Sender: TObject);
Var
  SenderName : String;
  ListBoxIPR1: TListBox;
Begin
  SenderName:='unsignedview';
  ListBoxIPR1:= FMListBoxIPR1 As TListBox;
  PNCSShowModal(
    FMCommentsMemo        ,//FMCommentsMemo      : TFMMemo;   //FMCommentsMemo: TFMMemo;
    FMEditIPR10           ,//FMEditIPR10         : TFMEdit;   //FMEditIPR10: TFMEdit;
    FMEditIPR11           ,//FMEditIPR11         : TFMEdit;   //FMEditIPR11: TFMEdit;
    FMEditIPR2            ,//FMEditIPR2          : TFMEdit;   //FMEditIPR2: TFMEdit;
    FMEditIPR6            ,//FMEditIPR6          : TFMEdit;   //FMEditIPR6: TFMEdit;
    FMEditIPR7            ,//FMEditIPR7          : TFMEdit;   //FMEditIPR7: TFMEdit;
    FMEditIPR8            ,//FMEditIPR8          : TFMEdit;   //FMEditIPR8: TFMEdit;
    FMEditReviewStatus    ,//FMEditReviewStatus  : TFMEdit;   //FMEditReviewStatus: TFMEdit;
    FMGetsIPRFile         ,//FMGetsIPRFile       : TFMGets;   //FMGetsIPRFile: TFMGets;
    FMGetsIPRFile3        ,//FMGetsIPRFile3      : TFMGets;   //FMGetsIPRFile3: TFMGets;
    FMGetsTemplateInfo    ,//FMGetsTemplateInfo  : TFMGets;   //FMGetsTemplateInfo: TFMGets;
    FMListboxIPR1         ,//FMListBox           : TFMListBox;//FMListboxIPR1 : TFMListBox;
    ListBoxIPR1           ,//ListBoxIPR1         : TListBox;  //ListBoxIPR1: TListBox;
    MiniZip1              ,//MiniZip1            : TMiniZip;  //MiniZip1: TMiniZip;
    FMMemoFormDefinition  ,//mmoFormDefinition   : TRichEdit; //FMMemoFormDefinition: TRichEdit;
    RichEditReport        ,//mmoReport           : TRichEdit; //RichEditReport: TRichEdit;
    FMMemoReportDefinition,//mmoReportDefinition : TRichEdit; //FMMemoReportDefinition: TRichEdit;
    FMMemoScriptDefinition,//mmoScriptDefinition : TRichEdit; //FMMemoScriptDefinition: TRichEdit;
    Sender                ,//Sender              : TObject;
    SenderName            ,//SenderName          : String;
    frmMain.StatusBarLoadPt,//StatusMsg           : TLabel;    //StatusBarLoadPt: TLabel;
    xFMEditObjectCount    ,//xFMEditObjectCount  : TFMEdit;   //xFMEditObjectCount: TFMEdit;
    xFMTemplatesUtilized   //xFMTemplatesUtilized: TFMMemo    //xFMTemplatesUtilized: TFMMemo;
    );
end;

End.
